2000-07-24  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.5.

	* arch/unix/x11/gnome/uicolor.c, arch/unix/x11/xaw/uicolor.c:
	Removed debugging cruft.

2000-07-23  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.32.

	* c128/z80.c: Added some missing opcodes.

	* vdrive/vdrive-iec.c (vdrive_iec_open): Check if directory
	could be created.
	(vdrive_iec_read): Check if sector could be read.
	(vdrive_dir_find_next_slot): Give up if sector could not be
	read.

2000-07-22  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.31.

	* c128/z80.c: Added and fixed many opcodes.

	* c128/z80mem.c (z80mem_initialize): Added configurations for
	RAM bank2 and bank3.

	* c128/c128mmu.c (mmu_store): Allow setting bank2 and bank3.

2000-07-20  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.30.

	* arch/unix/x11/xaw/ui.c (ui_select_file): Free filename if
	`NULL' is returned.

	* arch/unix/uicommands.c (attach_disk, attach_tape,
	smart_attach, load_snapshot_trap): Free filename.
	* arch/unix/c64ui.c (attach_cartridge): Likewise.
	* arch/unix/vic20ui.c (attach_cartridge): Likewise.
	* arch/unix/vsidui.c (psid_load); Likewise.
	* arch/unix/uisettings.c (select_user_keymap, ui_load_palette,
	ui_load_romset, ui_load_rom_file, set_rs232_device_file,
	set_printer_dump_file): Likewise.
	* arch/unix/x11/xaw/uicartridge.c (browse_callback): Likewise.
	* arch/unix/x11/xaw/uiedisk.c (browse_callback): Likewise.
	* arch/unix/x11/xaw/uiscreenshot.c (browse_callback):
	Likewise.
	* arch/unix/x11/xaw/uisnapshot.c (browse_callback): Likewise.

	* arch/unix/x11/gnome/ui.c (ui_select_file): Cleanup.

	* info.c: Updated.

2000-07-20  pottendo  <pottendo@utanet.at>

	* arch/unix/x11/xaw/ui.c (ui_destroy_drive8_menu): Set
	`drive8_menu' to NULL after freeing it. 
	(ui_destroy_drive9_menu): ditto for `drive9_menu'.

	* arch/unix/uicommands.c 
	(ui_update_flip_menus): Fixed freeing of menu when goto is taken.
	Fixed if-expression for optimizing when disk is not activated.

2000-07-19  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.29.

	* arch/unix/x11/xaw/widgets/MultiList.c: Free the list data if
	the widget is destroyed.

	* arch/unix/x11/xaw/ui.c (ui_select_file): Cleanup.

	* arch/unix/uicommands.c (ui_update_flip_menus): Destroy old
	widget before creating a new one.
	Initialize `fliplist_start', commented out odd `free()' loop.

	* arch/unix/x11/xaw/ui.c, arch/unix/x11/gnome/ui.c
	(ui_destroy_drive8_menu, ui_destroy_drive9_menu): New
	functions.

	* drive/drive.c (drive_set_half_track): Calculate head
	position if track is changed.
	(drive_init): Initialize `GCR_current_track_size'.

	* attach.c, attach.h (file_system_detach_disk_shutdown): New
	function.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c,
	cbm2/c610.c (machine_shutdown): Do not use the generic disk
	detach routine on shutdown.

2000-07-19  pottendo  <pottendo@utanet.at>

	* arch/unix/x11/xaw/uimenu.c (ui_menu_create): Added and commented
	out debug code.

	* arch/unix/x11/gnome/ui.c (ui_display_tape_counter): Enlarged
	string buffer for translator to 1024 (kludge!)

	* arch/unix/uicommands.c 
	(ui_update_flip_menus): Added hopefully proper free()'s and bound
	check for fliplist menu.
	Enlarged size for allocated menu entries to 1024; This is a first
	kludge to be safe for translations.

2000-07-18  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.28.

	* attach.c (file_system_init): Clear vdrive struct.
	(file_system_detach_disk): Fixed wrong handling of file system
	access if all disks are detached.
	(set_file_system_device): Unified several functions.

	* vdrive/vdrive.c (vdrive_setup_device): Fixed memory leak.

	* arch/unix/x11/xaw/widgets/FileSel.c (Destroy): Close open
	directory.  Use either xmalloc/free or X11 memory functions
	but do not mix both.

	* utils.c (xmalloc): Cosmetics.

2000-07-17  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/spritedrv.c: added entry for file extension
	(none).

2000-07-16  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.27.

	* c128/z80.c: Fixed some opcodes.

	* c128/z80mem.c: Fixed lower shared memory banking.

	* vdc/Makefile.am, vdc/vdc-mem.c: Check for VIC-II DMA request
	before VDC register access.
	* c128/c128mmu.c: Changed likewise.

2000-07-16  pottendo  <pottendo@utanet.at>

	* info.c: Updated my contribution.

	* arch/unix/x11/video.c: (canvas_create): Return in case vsid
	mode. 

	* Instrumented for gettext translation:
	arch/unix/vsidui.c
	arch/unix/vsync.c
	arch/unix/vic20ui.c
	arch/unix/archdep.c
	arch/unix/console.c
	arch/unix/coproc.c
	arch/unix/main_exit.c
	arch/unix/x11/gnome/about.c
	arch/unix/x11/gnome/dummies.c
	arch/unix/x11/gnome/gnomekbd.c
	arch/unix/x11/gnome/gnomevideo.c
	arch/unix/x11/gnome/uicartridge.c
	arch/unix/x11/gnome/uicolor.c
	arch/unix/x11/gnome/uiedisk.c
	arch/unix/x11/gnome/uihotkey.c
	arch/unix/x11/gnome/uimenu.c
	arch/unix/x11/gnome/uiscreenshot.c
	arch/unix/x11/gnome/uisnapshot.c
	arch/unix/x11/fullscreen.c
	arch/unix/x11/kbd.c
	arch/unix/x11/ui-cmdline-options.c
	arch/unix/x11/ui-resources.c
	arch/unix/x11/video.c
	arch/unix/x11/xaw/about.c
	arch/unix/x11/xaw/ui.c
	arch/unix/x11/xaw/uicartridge.c
	arch/unix/x11/xaw/uicolor.c
	arch/unix/x11/xaw/uiedisk.c
	arch/unix/x11/xaw/uihotkey.c
	arch/unix/x11/xaw/uimenu.c
	arch/unix/x11/xaw/uiscreenshot.c
	arch/unix/x11/xaw/uisnapshot.c
	arch/unix/x11/xaw/x11kbd.c
	arch/unix/x11/xaw/x11video.c

2000-07-14  Andreas Boose  <boose@linux.rz.fh-hannover.de>

        * Version 1.4.26.

	* arch/unix/x11/fullscreen.c (fullscreen_mode_init): Fixed
	typo.

2000-07-13  pottendo  <pottendo@utanet.at>

	* arch/unix/x11/gnome/uimenu.c (make_menu_label): call gettext to
	translate static strings in menu.

	* arch/unix/c128ui.c: Instrumented for Internationalization.
	* arch/unix/c610ui.c: ditto.
	* arch/unix/c64ui.c: ditto.
	* arch/unix/uisettings.c: ditto.
	* arch/unix/uicommands.c: ditto.
	* arch/unix/uicmdline.c: ditto.
	* arch/unix/rs232.c: ditto.
	* arch/unix/print.c: ditto.
	* arch/unix/petui.c: ditto.
	* arch/unix/petkmap.c: ditto.
	* arch/unix/mouse.c: ditto.
	* arch/unix/kmap.c: ditto.
	* arch/unix/joystick.c: ditto.

2000-07-13  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.25.

	* diskimage.c, diskimage.h, drive/drive.c, vdrive/vdrive.c:
	Use a function to read the 1541/71 speed map.

	* color.c (color_fill_pixel_return): Fixed conversion table
	index calculation.

	* arch/unix/x11/gnome/uicolor.c: Removed old code.

	* arch/os2/Makefile.am: Fixes.

	* arch/os2/vac++/Makefile.am: Removed references to
	`incl/lpng.icc' and `incl/lzlib.icc' as they don't exist.

2000-07-12  Andreas Matthies  <andreas.matthies@gmx.net>

	* arch/win32/res.h,res.rc: new IDs for the new screenshot
	save hook

	* arch/win32/uisnapshot.c(hook_save_snapshot): handles
	handles init and notification of the screenshot save hook
	(ui_screenshot_save_dialog) now supports every initialized
	screendriver
	(ui_soundshot_save_dialog): removed wrong 'free' of the
	SoundDeviceName resource pointer

	* screenshot.h,screenshot.c: the screendrv_t now includes
	a default file extension; (screenshot_get_driver) is now
	public

	* screendrv/bmp.c,png.c: added default file-extension
	to the drivers

2000-07-12  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* arch/os2/archdep.c: added archdep_create_mutex_sem, some
	minor changes
  
	* arch/os2/config.h: added HAVE_PNG
  
	* arch/os2/console.c: fixed a bug in console_in
  
	* arch/os2/dislogs/dialogs.*: small changes in the layout,
	added screenshot dialog
  
	* arch/os2/dialogs/dlg-emulator.c: added screenshot part
  
	* arch/os2/dialogs/dlg-screenshot.c added
  
	* arch/os2/fonts/bdf2fnt.cc, arch/os2/fonts/bdf2fnt.icc,
	arch/os2/fonts/header.fnt, arch/os2/fonts/vice-cbm.asm,
	arch/os2/fonts/vice-cbm.cmd, arch/fonts/os2/vice-cbm.def,
	arch/os2/fonts/vice-cbm.rc added
      
	* arch/os2/joystick.c: init uses archdep_create_mutex_sem now
  
	* arch/os2/kbd/kbd-*.c: old keyboard transaltion arrays
	deleted
  
	* arch/os2/kbd/: kmap-pet.c, kmap.[ch], parse.[ch], proc.[ch]
	added
  
	* arch/os2/kbd.c: keyboard handling, translation handling and
	processing moved to new files in kbd/
           
	* arch/os2/kbd.h: small corrations in enum
  
	* arch/os2/ui.c: writes also the actual time to the log-file
	now
  
	* arch/os2/vac++/Fonts.ic: added
  
	* arch/os2/vac++/, arch/os2/vac++/incl: screendrv.icc,
	lpng.icc, lzlib.icc added, all necessary changes for compiling
	with the png-lib added
    
	* arch/os2/video.c: make it compile again, some small changes
  
	* arch/os2/videoarch.h: palette removed from canvas_t
  
	* arch/os2/vsync.c removed split into an arch independant an
	dependant part
  
	* vsync.c added
  
	* vsyncarch.h added
  
	* c128/c128.c: mouse_init_resources removed (s. main.c) 

	* c64/c64.c: mouse_init_resources removed (s. main.c) 
  
	* crtc/crtc.c, drive/drive-snapshot.c, raster/raster.c,
	vdc/vdc.c, vic20/vic.c, vicii/vicii.c: 
	added an explicite cast to get rid of warnings
  
	* screendriver/bmp.c: added string.h
  
	* sound.h: added stdlib.h
  
2000-07-10  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.24.

	* arch/unix/c128ui.c (screenshot_submenu): Changed window
	numbers.

	* drive/drive.c (drive_sync_found): Only the 2 LSB of the
	previous byte are significant if 0xff is read.

2000-07-06  Andreas Matthies  <andreas.matthies@gmx.net>

	* arch/msdos/c64ui.c: implemented cartridge freezer in
	the reset submenu

	* arch/win32/res.h: new menu IDs for screenshot and
	soundshot

	* arch/win32/resc128.rc,resc64.rc,rescbm2.rc,respet.rc,
	resvic.rc: new menu items in the snapshot menu

	* arch/win32/screendrv.dsp: removed png.c from the project
	files to make VICE compile with MSVC

	* arch/win32/ui.c: new hotkeys ALT-C (screenshot) and
	ALT-U (soundshot)
	(ui_display_statustext) new function to display message
	in the left statusbar corner
	(save_snapshot_trap),(load_snapshot_trap) uses hwnd to
	avoid switching to VDC window after load/save
	(handle_wm_command) handles the new menu messages
	IDM_SCREENSHOT and IDM_SOUNDSHOT

	* arch/win32/ui.h: new prototype (ui_display_statustext)

	* arch/win32/uisnapshot.c: new includes screenshot.h,sound.h
	(ui_save_snapshot) receives template-id as parameter to make
	it usable for saving screenshots and soundshots
	new functions (ui_screenshot_save_dialog),
	(ui_soundshot_save_dialog)

	* arch/win32/uisnapshot.h: new corresponding prototypes

	* c128/c128.c(machine_screenshot): changed indices of the
	screens (now 0=VDC, 1=VIC-II) so that it fit with the order
	they are initialized and so the order of the corresponding
	windows

2000-06-28  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* sounddrv/soundacorn.c: turned frequency adaption into a
	function.

	* arch/riscos/ui.c: adjust sound frequencies to exact values
	using the frequency adaption function in sounddrv/soundacorn.c

2000-06-27  Andreas Boose  <boose@linux.rz.fh-hannover.de>

        * Version 1.4.23.

	* arch/unix/x11/gnome/uicolor.c (uicolor_convert_color_table):
	Fixel pixel value.

	* arch/unix/x11/video.c: Removed obsolete code.

2000-06-26  Andreas Matthies  <andreas.matthies@gmx.net>

	* arch/win32/res.rc: added "Create TAP image" button to
	the OPENTAPE template

	* arch/win32/uilib.c(tape_hook_proc): handles new button
	by calling disk_image_create(filename, DISK_IMAGE_TYPE_TAP)
	(hook_proc): default disk image name now 'vice' (no capital)

	* diskimage.c,diskimage.h: new DISK_IMAGE_TYPE_TAP, only
	supported by (disk_image_create) to create an empty tap

2000-06-25  Andreas Matthies  <andreas.matthies@gmx.net>

	* arch/beos/console.c: just a copy of the UNIX console makes
	the monitor work

	* arch/beos/constants.h: more id's for the new ui elements

	* arch/beos/main.cc: use different application signatures for
	each emulator to avoid problems running them at the same time

	* arch/beos/ui.cc: traps for monitor start and snapshots
	(ui_dispatch_events) implements monitor,fliplist and snapshots

	* arch/beos/ui_file.cc,ui_file.h: handles file actions for
	loading and saving snapshots

	* arch/beos/vicemenu.cc: more menu entries for fliplist,
	monitor and snapshots

	* arch/beos/vicewindow.cc: calls suspend_speed_eval after
	showing an alert box
	creates a second filepanel, this one in save mode
	ViceWindow::MessageReceived: checks for a focused menubar and
	in this case unsets the focus to avoid misterious problems
	with the keyboard input

	* arch/beos/video.cc: uses the new video_frame_buffer_t
	(canvas_resize): corrects width and height in the canvas_t
	(canvas_refresh): checks if destinations area fits the canvas
	to avoid crashes

	* arch/beos/vsync.c: uses Dag's new vsync.c; additional test
	if hardware can keep up with speed is not implemented so far

	* arch/win32/ui.c(handle_wm_command): fixed call to
	(flip_remove)

2000-06-24  pottendo  <pottendo@utanet.at>

	* arch/unix/x11/gnome/gnomevideo.c 
	(ui_finish_canvas): Unref old drawable in case there's one.
	(video_frame_buffer_alloc): Check if we have a dangling canvas,
	and update sizes in case.

	* arch/unix/x11/video.c 
	(canvas_resize): Set canvas width/height to new values, and update
	drawable of canvas.
	(canvas_create): Initialize canvas with 0.
	(video_frame_buffer_free): Remember canvas in a global
	`dangling_canvas'. 

2000-06-24  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.22.

	* vicii/vicii.c, vicii/vicii.h, vdc/vdc.c, vdc/vdc.h,
	vic20/vic.c, vic20/vic.h, crtc/crtc.c, crtc/crtc.h: Changed
	`*_get_raster' to return canvas pointer.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c,
	cbm2/cbm2.c: Do not inlcude "raster.h".
	(machine_canvas_screenshot): Use `*_get_canvas'.

2000-06-23  Dag Lem  <resid@nimrod.no>

	* arch/unix/vsync.c: Warn if the hardware cannot keep up with
	the vsync frequency.

2000-06-22  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* crtc/crtc.{c,h}, vdc/vdc.{c,h}, vic20/vic.{c,h},
	vicii/vicii.{c,h}: Added new function
	<video-chip>_get_raster() to retrieve the raster associated
	with the chip.

	* machine.h, c128/c128.c, c64/c64.c, cbm2/cbm2.c, pet/pet.c,
	vic20/vic20.c: alternative screenshot function that selects
	the window via the canvas: machine_canvas_screenshot().

	* screenshot.c: support making screenshots by canvas.

	* uiapi.h, main.c: new function ui_init_finalize(), called
	after all other modules have been initialized.

	* screenshot.c, sound.c, arch/riscos/ui.c: moved
	initialization of RISC OS specific drivers to arch module
	(ui_init_finalize()).

2000-06-21  Dag Lem  <resid@nimrod.no>

	* arch/unix/vsync.c: Total rewrite to improve frame rate
	calculation and display.
	
	* arch/unix/vsidui.c: Added calls to suspend_speed_eval.
	* arch/unix/uicommands.c: Likewise.
	* arch/unix/x11/gnome/ui.c: Likewise.
	* arch/unix/x11/x11/ui.c: Likewise.

	* sound.c (closesound): Update menus in vsid mode.

2000-06-18  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.21.

	* arch/unix/x11/xaw/uicolor.c, arch/unix/x11/gnome/uicolor.c,
	color.c: Added support for system colors.

	* arch/unix/x11/videoarch.h, arch/msdos/videoarch.h,
	arch/win32/videoarch.h, arch/riscos/videoarch.h,
	arch/os2/videoarch.h, arch/beos/videoarch.h: Removed
	`VIDEO_FRAME_BUFFER_POINTER_FIXUP' macro.

2000-06-18  pottendo  <pottendo@utanet.at>

	* arch/unix/x11/gnome/uiscreenshot.c:
	(ui_screenshot_dialog): Fixed error check to fn instead of
	name. Added feedback messages on success/failure of screenshot
	saves.
 
2000-06-18  Dag Lem  <resid@nimrod.no>

	* vicii/vicii.c: Moved call on clk_guard_set_clk_base from
	vic_ii_init to vic_ii_change_timing to allow change of PAL/NTSC
	time base.

2000-06-17  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.20.

	* drive/wd1770.c (wd1770_handle_job_code): Fixed typo.

	* arch/unix/x11/xaw/uicolor.c, arch/unix/x11/gnome/uicolor.c
	(uicolor_alloc_color): Return error if color allocation
	failed.

	* color.c (color_alloc_colors, color_alloc_new_colors): Error
	handling.

	* raster/raster.c, raster/raster.h (raster_set_palette):
	Return error code.

	* vicii/vicii.c, crtc/crtc.c, vic20/vic.c, vdc/vdc.c: Better
	error handling.

	* c128/z80mem.c: Fixed loading ROM.

	* arch/unix/x11/xaw/ui.c, arch/unix/x11/xaw/uicolor.c,
	arch/unix/x11/fullscreen.c, arch/unix/x11/gnome/ui.c:
	arch/unix/x11/gnome/uicolor.c: `display' made static.

2000-06-16  pottendo  <pottendo@utanet.at>

	* main.c (MAIN_PROGRAM): Chaged LOCALEDIR to NLS_LOCALEDIR.

	* arch/unix/x11/gnome/uiscreenshot.c: New File.

	* arch/unix/x11/gnome/Makefile.am (libgnomeui_a_SOURCES): Added
	`uiscreenshot.c'.

	* Makefile.am (INCLUDES): Removed @NLS_LOCALEDIR@.

2000-06-14  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* screenshot.c: added initialization of RISC OS sprite driver.

	* arch/riscos/spritedrv.c: (new file) RISC OS sprite driver.

	* arch/riscos/ui.c: added ui support for screenshots.

	* arch/riscos/ui.c, arch/riscos/uiconfig.h,
	arch/riscos/uiconfig.c: moved configuration data structures
	and prototypes to new files uiconfig.* to cut down the size of
	ui.c somewhat.

	* arch/riscos/videoarch.h, arch/riscos/video.c: added function
	canvas_number_for_handle().

2000-06-14  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.19.

	* color.c: Added dither bit.

	* arch/unix/x11/video.c (video_convert_color_table): Changed
	to new color management code.

	* arch/unix/x11/gnome/uicolor.c: New file.

	* arch/unix/x11/gnome/ui.c: Moved color allocation code to
	`arch/unix/x11/gnome/uicolor.c'.

	* arch/unix/x11/xaw/uicolor.c (uicolor_alloc_color): Fixed bug
	in 16bpp and 32bpp mode.

	* arch/unix/x11/uicolor.h: Moved to main source.

2000-06-13  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.18.

	* screenshot.c, screenshot.h: Added proper screen height
	calculation.

	* arch/unix/c64ui.c, arch/unix/c128ui.c, arch/unix/vic20ui.c,
	arch/unix/petui.c, arch/unix/c610ui.c: Cosmetic fixes.

	* screendrv/png.c (png_save): Fixed memory leak.

	* raster/raster.c (raster_set_palette): Rebuild the color
	tables of the video chips instead of just repainting the
	framebuffer.

	* color.c (color_alloc_new_colors, color_free_old_colors,
	color_fill_pixel_return, color_copy_list_without_owner): New
	function.  (color_add_owner_from_other_list): Bugfix.

	* arch/unix/x11/xaw/uicolor.c (uicolor_alloc_color,
	uicolor_free_color): New functions.

2000-06-13  Daniel Sladic  <dsladic@cs.cmu.edu>

	* arch/unix/Makefile.am: Removed file uiscreenshot.c.

	* arch/unix/c64ui.c, arch/unix/c128ui.c, arch/unix/vic20ui.c,
	arch/unix/petui.c, arch/unix/c610ui.c: Modified screenshot
	menu code to call a screenshot dialog.

	* arch/unix/uiscreenshot.c: Removed. Moved to arch/unix/x11/xaw.

	* arch/unix/uiscreenshot.h: Exposed function is now
	ui_screenshot_dialog instead of save_screenshot callback.

	* arch/unix/x11/xaw/Makefile.am: Added uiscreenshot.c.

	* arch/unix/x11/xaw/uiscreenshot.c: Moved file here from
	arch/unix and added the dialog for screenshots.

	* screendrv/png.c: Added PNG code.

	* screenshot.c, screenshot.h: Added code to iterate over the
	registered screen drivers so the menu code can be tailored on
	the fly.

2000-06-12  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.17.

	* color.c, color.h: New files.

	* arch/unix/x11/xaw/uicolor.c: Call new color management code.

2000-06-12  pottendo  <pottendo@utanet.at>

	* arch/unix/uicommands.c (ui_update_flip_menus): Added
	`USE_GNOMEUI' around drive-settings menu entry, since this
	just works under Gnome. This fixes the reported failure:
	`Maximum number of menus reached!' from uimenu.c.

	* Makefile.am (INCLUDES): Removed `-I$(top_srcdir)/intl'.
	(common_libs): Removed `@INTLLIBS@'.

2000-06-12  Dag Lem  <resid@nimrod.no>

	* raster/raster.c: Added checks for console_mode and vsid_mode
	to fix crashes.

2000-06-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.16.

	* arch/unix/ui.h, arch/unix/x11/ui-resources.c: Moved resource
	specific code to resource file.

	* crtc/crtc.c, vicii/vicii.c: #include "video.h".

	* arch/unix/x11/xaw/uicolor.c, arch/unix/x11/uicolor.h: New
	files.

	* arch/unix/ui.h, arch/unix/x11/xaw/ui.c, arch/unix/video.c,
	arch/unix/x11/gnome/ui.c (ui_open_canvas_window,
	ui_canvas_set_palette): Pass pointer to canvas.

	* arch/unix/c128ui.c: Added VDC palette UI entry.

	* arch/unix/uisettings.c, arch/unix/c64ui.c,
	arch/unix/c128ui.c, arch/unix/petui.c, arch/unix/c610ui.c:
	Fixed loading custom CRTC palette.

2000-06-10  Dag Lem  <resid@nimrod.no>

	* c64/c64.c: Removed PAL hardcoding.
	* c128/c128.c: Likewise.
	* vicii/vicii.c: Likewise.

	* sound.c, sound.h (sound_set_machine_parameter): New function for
	PAL/NTSC.

	* arch/unix/x11/gnome/uimenu.c (_ui_menu_toggle_helper,
	_ui_menu_radio_helper): Removed unused variable buf.

2000-06-10  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.15.

	* screenshot.c, screenshot.h: Fixed some screen constants.
	Use pixel width and height to calculate snapshot size.

	* arch/unix/uiscreenshot.c, arch/unix/uiscreenshot.h: New
	files.

	* arch/unix/c64ui.c, arch/unix/c128ui.c, arch/unix/vic20ui.c,
	arch/unix/petui.c, arch/unix/c610ui.c, arch/unix/uicommands.c:
	Added machine specific screenshot handling.

	* arch/unix/x11/videoarch.h, arch/msdos/videoarch.h,
	arch/win32/videoarch.h, arch/riscos/videoarch.h,
	arch/os2/videoarch.h, arch/beos/videoarch.h: Changed type
	definition of `canvas_t'.

	* video.h, raster/raster.c, arch/unix/x11/xaw/x11video.c,
	arch/unix/video.c, arch/unix/x11/gnome/gnomevideo.c,
	arch/msdos/video.c, arch/win32/video.c, arch/riscos/video.c,
	arch/os2/video.c, arch/beos/video.cc: Changed to new
	`canvas_t' type definition.

	* vdc/vdc.c: #include "video.h".

2000-06-10  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.14.

	* raster/raster.c (raster_screenshot): Save some more screen
	constants.

	* screenshot.c (screenshot_line_data): Add `x_offset'.
	(screenshot_save): Calculate screen constants.

	* screenshot.h: Added screen constants to `screenshot_t'.

	* screendrv/bmp.c: Implemented BMP save functions.

	* utils.c, utils.h (dword_to_le_buf): New function.

	* arch/unix/uicommands.c, arch/unix/c128ui.c,
	arch/unix/vic20ui.c, arch/unix/petui.c, arch/unix/c610ui.c:
	More screenshot UI stuff.

2000-06-09  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.13.

	* arch/msdos/videoarch.h: Fixed frame buffer struct.

	* arch/riscos/ui.c (ui_redraw_window): Changed frame buffer
	type to `video_frame_buffer_t'.

	* screenshot.h: Added pointer to palette, pixel table and
	color map to `screenshot_t'.

	* screenshot.c (screenshot_line_data): New function.
	(screenshot_save): Setup color map.

	* screendrv/bmp.c, screendrv/png.c: Use new screenshot API.

	* raster/raster.c (raster_screenshot): Fill in palette.

2000-06-09  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/uimsgwin.c: the tab problem...

	* arch/riscos/video.c: fixed to run with new
	video_frame_buffer_t

	* raster/raster.c: fixed remaining accesses of frame buffer
	through canvas.

2000-06-08  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.12.

	* video.h, raster/raster.c, arch/unix/x11/video.c,
	arch/unix/x11/videoarch.h, arch/unix/x11/gnome/gnomevideo.c,
	arch/unix/x11/xaw/x11video.c, arch/win32/video.c,
	arch/win32/videoarch.h, arch/msdos/video.c, screenshot.h,
	arch/msdos/videoarch.h, arch/riscos/ui.c, arch/riscos/video.c,
	arch/riscos/videoarch.h, arch/os2/unused/video_gpi.h,
	arch/os2/unused/video_gpi.c, arch/os2/video.c,
	arch/os2/videoarch.h, arch/beos/videoarch.h, screendrv/bmp.c:
	Unified frame buffer access, better naming.

	* raster/raster.h: Use a pointer to the video frame buffer in
	`struct raster_s'.

	* video.h, arch/msdos/video.c, arch/win32/video.c,
	arch/unix/x11/video.c, arch/unix/x11/gnome/gnomevideo.c
	arch/unix/x11/xaw/x11video.c (video_frame_buffer_alloc,
	video_frame_buffer_free, canvas_refresh): Changed to new
	frame buffer layout.

	* vicii/vicii.c, crtc/crtc.c, vic20/vic.c: Fixed usage of
	`raster.frame_buffer'.

2000-06-08  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/console.c, arch/riscos/ui.c,
	arch/riscos/uimsgwin.c, arch/riscos/uimsgwin.h: redesigned
	monitor interface to be safe for internal use.

	* arch/riscos/ui.c: added configs for synchronous sound device
	and updated supported cartridges.

	* sounddrv/soundacorn.c: added synchronous sound device.

2000-06-07  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* screendrv.dsp is now added to makefile.am

2000-06-07  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.11.

	* arch/unix/x11/xaw/ui.c, arch/unix/x11/gnome/ui.c: Moved
	common resources and fullscreen code into a separate files.
	Use resource code instead of using globals.

	* arch/unix/x11/ui-resources.c, arch/unix/x11/fullscreen.c,
	fullscreen.h: New files.

	* main.c, arch/unix/uisettings.c, arch/unix/uicommands.c,
	arch/unix/x11/xaw/uimenu.c: Use new fullscreen API.

	* arch/unix/x11/xaw/uiarch.h: Removed fullscreen stuff.

	* arch/unix/x11/videoarch.h, arch/riscos/videoarch.h,
	arch/win32/videoarch.h, arch/msdos/videoarch.h,
	arch/os2/videoarch.h, arch/beos/videoarch.h:
	FRAME_BUFFER_POINTER_FIXUP: New macro.

	* arch/win32/video.c, arch/os2/unused/video_gpi.h,
	arch/os2/unused/video_gpi.c, arch/os2/video.c,
	arch/beos/videoarch.h: Framebuffer struct is called
	`frame_buffer_s'.

2000-06-06  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* added files to MS VC project files

	* fixed error in screendrv/bmp.c, so that it didn't compile
	under win32. Anyway, this most probably breaks RISCOS and X11
	ports.

2000-06-06  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* src/arch/win32/console.c: Logging the output to a file is
	toggled now by Alt+PrtScr

2000-06-05  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.10.

	* raster/raster.c, raster/raster.h (draw_blank): Fixed cast.
	(raster_init): Return error code.

	* vicii/vicii.c, vdc/vdc.c, crtc/crtc.c, vic20/vic.c
	(init_raster): Bail out on error.

	* arch/unix/x11/video.c, arch/unix/x11/videoarch.h
	(video_convert_func, video_convert_save_pixel,
	video_convert_restore_pixel, video_convert_color_table,
	video_refresh_func): New functions.
	(convert_8to16, convert_8to32, convert_8to8, convert_8toall,
	convert_8to1_dither, _convert_func: Made static.

	* arch/unix/x11/gnome/gnomevideo.c,
	arch/unix/x11/xaw/x11video.c (video_frame_buffer_alloc):
	Call `video_convert_func' instead of duplicating code.
	Separated some common X11 code.

	* arch/unix/uicommands.c (browse_manual): Retrive browser
	directory by resource code instead of using ugly globals.

	* arch/unix/x11/xaw/ui.c, arch/unix/x11/gnome/ui.c,
	arch/unix/ui.h: `_ui_resources' made static.  Moved command
	line options into a separate file.

	* arch/unix/x11/ui-cmdline-options.c: New file.

2000-06-03  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.9.

	* screendrv/Makefile.am, screendrv/bmp.c, screendrv/png.c: New
	files.

	* screenschot.c, screenschot.h (screenshot_init,
	screenshot_register, screenshot_save): New functions.

	* Makefile.am: Added `screendrv' directory.

	* arch/unix/uicommands.c, arch/unix/uicommands.h: Added
	screenshot entry (for experiments right now).

	* main.c (MAIN_PROGRAM): Call `screenshot_init'.

2000-06-03  Andreas Matthies  <andreas.matthies@gmx.net>

	* arch/beos/Makefile.am: some .c files changed to .cc

	* arch/beos/archdep.c: added missing functions

	* arch/beos/c128kbd.c,c610kbd.c,c64kbd.c,petkbd.c,
	vic20kbd.c,kbd.h: small changes in keyboard codes

	* arch/beos/c64ui.cc: some C64 specific ui stuff

	* arch/beos/constants.h: identifier for the menus

	* arch.beos/joystick.cc: implementation of hardware
	joystick and keyboard-emulation

	* arch/beos/ui.cc: more general ui stuff,
	message handler etc.

	* arch/beos/ui_file.cc: handles the attach and other
	file dialogs

	* arch/beos/vicemenu.cc: creates the menubar

	* arch/beos/vicewindow.cc: handles the window,
	menu updates, message queueing, ...

	* arch/beos/vsync.c: activated ui_dispatch_events,
	removed bug with fixed refresh handling

	* sound.h,sound.c: integrated sounddriver for beos

	* sounddrv/soundbeos.cc: implementation of the BeOS
	sounddriver

2000-06-02  Dag Lem  <resid@nimrod.no>

	* arch/unix/x11/xaw/uimenu.c (_ui_menu_toggle_helper,
	_ui_menu_radio_helper): Removed unused variable buf.

	* vsidui.h: Backed in prototype for vsid_ui_init.

	* arch/beos/vsidui.c, arch/msdos/vsidui.c, arch/os2/vsidui.c,
	arch/riscos/vsidui.c, arch/win32/vsidui.c: Cleaned up to reflect
	removal of GUI process.

2000-06-02  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/kbd.c, arch/riscos/ui.c, arch/riscos/ui.h:
	finished fliplist support.

	* arch/riscos/videoarch.h, arch/riscos/video.c: display
	currently active disk image in windowed and full screen mode.

	* arch/riscos/ui.c: allow long text in menus, added window for
	creating empty disk images, some code cleanup.

	* sound.c, sound.h, sounddrv/soundacorn.c: small cleanup of
	unused variables.

2000-06-01  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.8.

	* vicii/vicii.c, vicii/vicii.h (vic_ii_init): Return pointer
	to raster_t structure instead of canvas.
	* vdc/vdc.c, vdc/vdc.h (vdc_init): Changed likewise.
	* crtc/crtc.c, crtc/crtc.h (crtc_init): Changed likewise.
	* vic20/vic.c, vic20/vic.h (vic_init): Changed likewise.

	* Makefile.am: Added `screenshot.c' and `screenshot.h'.

	* screenshot.c, screenshot.h: New files.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c,
	cbm2/c610.c, machine.h (machine_screenshot): New function.

	* vicii/vicii.c, vicii/vicii.h (vic_ii_screenshot): New
	function.

	* vdc/vdc.c, vdc/vdc.h (vdc_screenshot): New function.

	* vic20/vic.c, vic20/vic.h (vic_screenshot): New function.

	* crtc/crtc.c, crtc/crtc.h (crtc_screenshot): New function.

	* raster/raster.c, raster/raster.h (raster_screenshot): New
	function.

	* arch/unix/x11/videoarch.h, arch/win32/videoarch.h,
	arch/riscos/videoarch.h, arch/os2/videoarch.h: Frame buffer
	struct is called `frame_buffer_s'.

2000-06-01  Dag Lem  <resid@nimrod.no>

	* arch/unix/x11/gnome/gnomekbd.c (kbd_event_handler): Hotkey
	handling in vsid mode.

2000-06-01  Dag Lem  <resid@nimrod.no>

	* arch/unix/x11/xaw/ui.c (ui_dispatch_events): Removed check for
	ui_menu_any_open(). This keeps the emulator running when menus are
	used.

	* arch/unix/uicommands.c: Pause = M-p, Exit = M-q.

	* arch/unix/uisettings.c, arch/unix/uisettings.h: Made
	sound_settings_submenu, set_sound_sample_rate_submenu,
	set_sound_oversample_submenu public.

	* arch/unix/c64ui.c, arch/unix/c64ui.h: Made sid_submenu public.

	* arch/unix/vsidui.c: Added menu item for the builtin monitor.
	
2000-05-31  Dag Lem  <resid@nimrod.no>

	* arch/unix/x11/gnome/gnomekbd.c, arch/unix/x11/gnome/ui.c,
	arch/unix/x11/gnome/uimenu.c, arch/unix/x11/video.c,
	arch/unix/x11/xaw/ui.c, arch/unix/x11/xaw/uimenu.c,
	arch/unix/x11/xaw/x11kbd.c, c64/c64.c, c64/psid.c, drive/drive.c,
	machine.h, main.c, raster/raster.c, sid/sid.c, sound.c,
	vicii/vicii.c, vsidui.h: Changed psid_mode to vsid_mode.
	Removed GUI process to simplify porting.

	* arch/unix/vsidproc.c, arch/unix/vsidproc.h: Removed.
	* arch/unix/Makefile.am: Removed vsidproc.c and vsidproc.h.

2000-05-31  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.7.

	* crtc/crtctypes.h, crtc/crtc.c: Made screen size variables
	unsigned again and fixed xoffset calculation.

	* arch/win32/ui.c: #include <string.h>.

	* arch/win32/petkbd.c: #include "keyboard.h".

	* drive/fdc.c, drive/fdc.h, drive/drive.h, drive/drive.c,
	diskimage.c, diskimage.h, gcr.c, gcr.h, parallel.h,
	raster/raster.c, vdrive/vdrive-dir.c, vdrive/vdrive-dir.h,
	drive/drivemem.c, drive/drivemem.h, drive/wd1770.c,
	drive/wd1770.h, drive/drive-snapshot.c, vdrive/vdrive-bam.c,
	vdrive/vdrive-bam.h, vdrive/vdrive.c, vdrive/vdrive.h: Fixed
	variable types.

2000-05-30  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/console.c, arch/riscos/ui.{c,h},
	arch/riscos/uimsgwin.{c,h}: changed new monitor interface.

	* arch/riscos/uimsgwin.{c,h}: now handles all sorts of text
	windows.

	* arch/riscos/ui.c: added fliplist support.

	* arch/riscos/video.c: fixed double size reset bugette.

	* utils.c: fixed getline() bug (used to fail on empty lines).

2000-05-28  Andreas Matthies  <andreas.matthies@gmx.net>

	* src/arch/Makefile.am: sets subdir 'beos' when compiling
	for BeOS

	* src/arch/beos: new directory with new files Makefile.am,
	archdep.c,archdep.h,beos.h,c128kbd.c,c128ui.c,c128ui.h,
	c610kbd.c,c610ui.c,c610ui.h,c64kbd.c,c64ui.c,c64ui.h,console.c,
	constants.h,joystick.c,joystick.h,kbd.c,kbd.h,main.cc,main.h,
	main_exit.c,main_exit.h,mouse.c,mouse.h,petkbd.c,petui.c,
	petui.h,print.c,types.h,ui.cc,ui.h,ui_file.cc,ui_file.h,
	uicmdline.c,uicmdline.h,vic20kbd.c,vic20ui.c,vic20ui.h,
	vicewindow.cc,vicewindow.h,video.cc,videoarch.h,vsidui.c,vsync.c
	This is a start!! Most files are copied from the win32 port, 
	most implementations of the functions are empty

	* src/interrupt.h: some explicit type casts for cpu_int
	for C++

	* raster-changes.h: changed identifier 'new' to 'newone' to 
	avoid trouble with C++

	* raster-changes.h: includes beos.h when compiled for BeOS

2000-05-26  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.6.

	* crtc/crtctypes.h: Use signed variables for screen size for
	now.

2000-05-24  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* console.h: added console_flush()

	* monitor/mon.{c,h}: alternative monitor interface with
	separate calls to open the monitor, process a command and
	close the monitor.

	* arch/riscos/ui.{c,h}, arch/riscos/console.c: changed monitor
	to a GUI window.

2000-05-23  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/uiconsole.c: file was missing after last
	contribution (from 2000-05-21)

2000-05-22  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.5.

2000-05-21  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/console.c: deleted some debugging stuff

	* arch/win32/console.c: the output of the console can now be
	output into a file

	* arch/win32/res.h, arch/win32/res.rc, arch/win32/uiconsole.c,
	arch/win32/arch.dsp: additions for "save as" dialog box which
	is used to determine where to store the log file of the
	console (see above)

	* arch/win32/ui.h, arch/win32/ui.c: added
	ui_ensure_extension() for console "save as" dialog and
	snapshot "save as" dialog

	* arch/win32/uisnapshot.c: fixed error: when the user enters a
	file name w/o extension, the default extension should be
	added. The implementation did not work in case the path to the
	file contained a period (like in "C:\VICE.WORK\HELLO"). Now,
	ui_ensure_extension() performs this task.

2000-05-19  Dag Lem  <resid@nimrod.no>

	* resid/: Version 0.9 of reSID (fixed filter output weighting bug).

2000-05-14  Andre Fachat   <a.fachat@physik.tu-chemnitz.de>

	* vdrive/vdrive-bam.c (vdrive_bam_create_empty_bam): fix last
	track number for 8050 format.

2000-05-14  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.4.

2000-05-01  Pottendo  <pottendo@utanet.at>

	* vice.h: Added gettext instrumentation macros. This comes from a
	gnome package, so it should work.

	* main.c:
	Added `#include <locale.h>'. This is necessary when building with
	the included gettext package.
	(MAIN_PROGRAM): Added initialization of the gettext
	package.

	* arch/unix/x11/xaw/uimenu.c (make_menu_label): Call `_'
	explicitely for translation if we have NLS.

	* arch/unix/x11/gnome/ui.c (archdep_ui_init): Removed
	intl-initialization. This is now in main.c.

	* arch/unix/uicommands.c: Removed NLS-stuff. This now is in
	vice.h.

	* Makefile.am (INCLUDES): Added `@NLS_LOCALEDIR@'. Uncommented
	`@INTLLIBS@'. 

2000-04-23  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.3.

	* Commented out `@INTLLIBS@'.

	* arch/unix/uicommands.c: Fixed define.

2000-04-28  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/gnome/uimenu.c (make_menu_label): Explicitly call
	translation on menu item strings. 

	* arch/unix/x11/gnome/ui.c (archdep_ui_init): Added NLS
	initializaition. Note about `LOCALEDIR'; This is currently not
	defined, and has to be provided on the make commandline. This is
	also a temporay hack.
	Started instrumenting the textstrings for translation.

	* arch/unix/uicommands.c:
	Added local hack to check NLS. Started (not finished yet)
	instrumenting the textstrings for translation.

	* Makefile.am (INCLUDES): Added `-I$(top_srcdir)/intl' as proposed
	in the gettext info page.
	(common_libs): Added `@INTLLIBS@' 

2000-04-26  Nathan Huizinga  <nathan.huizinga@chess.nl>

	* c64/c64mem.c: Allow REU being enabled with atleast the Super
	Snapshot V5 & Expert Cartridge. (These will coexist with the
	REU, others I don't know...)

2000-04-23  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.2.

	* zfile.c, zfile.h (zclose_all): Removed.

	* t64.c (t64_seek_to_next_file): Only exit without error if a
	normal record is found.

	* arch/win32/uiattach.c, arch/win32/ui.c: Added DOS GZIP file
	extensions.

2000-04-22  Andreas Matthies  <andreas.matthies@arcormail.de>

	* arch/msdos/archdep.c,arch/os2/archdep.c,arch/unix/archdep.c,
	arch/win32/archdep.c,arch/riscos/archdep.c: new functions
	archdep_make_name,archdep_tmpnam

	* arch/msdos/menudefs.c,uiattach.h: directory browsers
	also show .gz and .lzh files

	* arch/win32/archdep.c(archdep_default_sysfile_pathlist):
	enabled code that returns the absolute path which should
	make x64 startable from every directory

	* arch/win32/ui.c,arch/win32/uiattach.c: new directory filters
	for zipped files in the attach dialogs

	* archapi.h: new prototypes archdep_make_name,archdep_tmpnam

	* zfile.c: completely reformated; removed NAME_NEED which
	is now implemented in archdep_make_name
	tmp_name is not static char[L_tmpname] but now allocated by
	archdep_tmpnam
	(try_uncompress_archive): rewritten the part that finds the 
	first file in the zip; should work now even if the filename is
	not at the end of the line
	valid_archives[]: removed pkunzip which seems to be unable to
	write only the zipped files without any messages to stdout,
	added 'unzip' and 'lha' for MSDOS

2000-04-21  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.1.

	* drive/drive.c (drive_load_1541, drive_do_1541_checksum.
	drive_setup_rom_image): Cope with expanded ROM images.
	* drive/drivemem.c (drive_mem_init): Changed likewise.

	* ciacore.c: Removed debugging cruft.

	* c128/c128mem.c: Renamed debugging macro.

	* c128/c128mem.c, crtc/crtctypes.h, aciacore.c, parallel.h,
	parallel.c, tpicore.c, c64/psid.c, cmdline.c, diskimage.c,
	crtc/crtc.c, drive/drive.c, drive/drivecpu.c, drive/fdc.c,
	viacore.c, autostart.c, c128/z80.c, kbdbuf.c, rsuser.c, t64.c,
	utils.c, pet/petsound.c, vdc/vdctypes.h, vdrive/vdrive-bam.c,
	vdrive/vdrive-bam.h, imagecontents.c, vic20/vic-snapshot.c,
	vicii/vicii-draw.c, vicii/vicii-sprites.c, vdc/vdc-draw.c,
	mem.h: Fixed variable types.

2000-04-12  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.4.

	* raster/raster-sprite-status.c (raster_sprite_status_init):
	Fixed initialization of different pointer types.

2000-04-10  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* raster/raster-sprite-status.c 
	(raster_sprite_status_init): Added check wether num_sprites >
	0. This avoids calling `xmalloc(0)' in xvic.

	* arch/unix/x11/gnome/uimenu.c 
	(ui_menu_create): Added initialization to keep compiler silent.

	* arch/unix/x11/gnome/uicartridge.c 
	(ui_cartridge_dialog): New Function. Implementation of cartridge
	save dialog.

	* arch/unix/x11/gnome/Makefile.am (libgnomeui_a_SOURCES): Added
	`uicartridge.c'.

2000-04-08  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.3.6.

2000-04-07  Markus Brenner  <markus@brenner.de>

	* cartridge.h: Introduced new CRT type for C64GS cart, added
	CARTRIDGE_OCEAN_HUGE type

	* c64/c64cartridge.c: changes for huge Ocean and GS carts

	* c64/c64cartmem.c: changes for huge Ocean and GS carts

2000-04-05  Andreas Matthies  <andreas.matthies@arcormail.de>

	* ciacore.c (mycia_reset): CIA-TOD is stopped at startup

2000-04-05  Nathan Huizinga  <nathan.huizinga@chess.nl>

	* arch/unix/Makefile.am: uicartridge.h added.

	* arch/unix/c64ui.c: Cartridge control sub-menu moved from
	cartridge attach sub-menu to ui_cartridge_commands_menu. Save
	expert cartridge image dialog added to cartridge control
	sub-menu.

	* arch/unix/uicartridge.h: new file.

	* arch/unix/uicommands.c: META-F9 (Alt-F9) hotkey added for
	soft-reset button.

	* arch/unix/vsidui.c: META-F9 (Alt-F9) hotkey added for
	soft-reset button.

	* arch/unix/x11/xaw/Makefile.am: uicartridge.c added.

	* arch/unix/x11/xaw/uicartridge.c: new file for save cartridge
	image dialog.
	
	* c64/c64cartmem.c: Address decoding a little optimized. Also
	cartridge_save_image function added to dump the expert
	cartridge contents to a .crt file.

	* c64/c64cartridge.c: Added expert cartridge .crt support. Also
	replaced all hardcoded values by their equivalent defines from
	cartridge.h for better maintainability of the code.

	* c64/c64mem.c: Address decoding a little optimized.

	* cartridge.h: extern cartridge_save_image function prototype
	added.

2000-04-05  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.3.5.

	* raster/raster.c (update_sprite_collisions): Fixed
	calculation of fake framebuffer line.

	* vdrive/vdrive-bam.c (vdrive_bam_calculate_track): Fixed 1571
	block available map.

	* vdrive-command.c (vdrive_command_validate): Map out track 53
	for D71 disk images.

2000-03-29  Andreas Matthies  <andreas.matthies@arcormail.de>

	* raster/raster.c (raster_emulate_line): Fix calculation of
	`raster->blank_enabled'.

2000-03-29  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.3.4.

	* keyboard.c (joystick_latch_matrix, joystick_set_value_*):
	New functions.

	* arch/unix/x11/kbd.c (check_set_joykeys, check_clr_joykeys):
	Use common joystick functions to modify joystick value.

	* arch/win32/joystick.c (handle_keyset_mapping,
	joystick_handle_key): Changed likewise.

	* ciacore.c (mycia_reset): TOD is latched on startup.

2000-03-28  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* vicii/vic-draw.c, vicii/viciitypes.h: removed #13
 
	* arch/os2/archdep.c: \sem32\vice\spawn replaced by random
	semaphore

	* arch/os2/config.h: HAVE_MOUSE defined
  
	* arch/os2/dialogs.h: mouse support added, commandline option
	dlg added
  
	* arch/os2/dialogs.rc: font added for every dialog, mouse
	support added, commandline option dlg added
                
	* arch/os2/dialogs/dlg-cmdopt.c added
  
	* arch/os2/dialogs/dlg-contants.c: image=NULL bug solved, 
	WM_ADJUSTWINDOWPOS added

	* arch/os2/dialogs/dlg-emulator.c: mouse support added
  
	* arch/os2/dialogs/dlg-monitor.c: WM_COMMAND deleted, 
	WM_ADJUSTWINDOWPOS added

	* arch/os2/doc/Vice_for_os2.txt: adapted
 
	* arch/os2/install.cmd: small bugs corrected
 
	* arch/os2/joystick.c: semaphore name replaced by random
	semaphore name
 
	* arch/os2/mouse.[ch] added
 
	* arch/os2/pm/scrollbars.[ch] --> unused/pm
 
	* arch/os2/pm/winaddon.[ch] --> unused/pm
 
	* arch/os2/pm_cmdline.[ch] --> unused
 
	* arch/os2/ui.c: winaddon.h removed
 
	* arch/os2/uicmdline.c: uses resource dialog now
 
	* arch/os2/incl/archdep.icc: mouse.c added, ui_status.c
	removed
 
	* arch/os2/incl/dialogs.icc: dlg-cmdopt.c added
 
	* arch/os2/video.c: store window position support added
 
	* arch/os2/kbd/kbd-c128.c, arch/os2/kbd/kbd-c610.c,
	arch/os2/kbd/kbd-c64.c, arch/os2/kbd/kbd-pet.c,
	arch/os2/kbd/kbd-vic20.c: corrected
 
2000-03-23  Andreas Matthies  <andreas.matthies@arcormail.de>

	* datasette.c(datasette_set_motor): don't call
	ui_display_tape_motor_status if no tape is attached

2000-03-20  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.3.3.

	* arch/win32/ui.c (handle_wm_command): Added "*.prg" to
	autostart dialog.

	* pet/pet.c, cbm2/c610.c: #include "tape.h".

2000-03-14  Andreas Matthies  <andreas.matthies@arcormail.de>

	* tap.c(tap_close): uses write_dword to write the new tap size
	with little endian

	* c64/c64.c,c128/c128.c,vic20/vic20.c,cbm2/c610.c,pet/pet.c
	(machine_shutdown): detaches tape images

2000-03-14  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/gnome/ui.c:
	(var fixedfontname): Changed font name.
	(archdep_ui_init): Added fontpath handling.
	(ui_exit): ditto.

2000-03-12  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.3.2.

	* drive/fdc.c (fdc_detach_image): Fixed messages.

	* vicii/viciitypes.h: Set video standard offset to `0'.

2000-03-10  Nathan Huizinga  <nathan.huizinga@chess.nl>

	* arch/unix/c64ui.c: UI added for Expert cartridge
	emulation.

	* c64/c64cart.h: Added prototypes for (partrial) address
	decoding and for nmi/reset handling.

	* c64/c64cartmem.c: Expert cartridge emulation added.

	* c64/c64cartridge.c: Resource added to hold the cartridge
	mode.

	* c64/c64mem.c: Address decoding added for expert emulation.

	* cartridge.h: Added defines CARTRIDGE_EXPERT,
	CARTRIDGE_MODE_OFF, CARTRIDGE_MODE_PRG & CARTRIDGE_MODE_ON.

	* interrupt.h: New struct member `reset_trap_func'.

	* interrupt.c (interrupt_cpu_status_init) Initialize
	`reset_trap_func'.
	(interrupt_set_reset_trap_func): New function.

2000-03-06  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.3.1.

	* c64/c64iec.c (iec_init): Corrected initialization of
	`iec_info.drive_port'.
	* c128/c128iec.c: Changed likewise.

	* fsdevice.c, imagecontents.c, drive/drive-snapshot.c,
	vdrive/vdrive-command.c, c64/reu.c, arch/unix/x11/xaw/ui.c:
	Fixed some types.

	* palette.c, interrupt.c, main.c, imagecontents.c, parallel.c,
	imagecontents.h, parallel.h, interrupt.c, interrupt.h,
	drive/fdc.c, sound.h, sid/sid.c, vic20/vic20sound.c,
	pet/petsound.c, vic20/vic20via1.c, vic20/vic20via2.c,
	vic20/vic20ieeevia1.c, vic20/vic20ieeevia2.c, pet/petvia.c:
	Reamed shadow variables.

	* arch/unix/x11/xaw/x11video.c, arch/unix/x11/xaw/ui.c,
	arch/unix/x11/video.c, arch/unix/x11/xaw/uiarch.h,
	arch/unix/vsidproc.c, arch/unix/x11/gnome/gnomevideo.c,
	arch/unix/x11/gnome/ui.c, arch/unix/ui.h: `screen', `depth'
	and `display' are static now.

2000-03-04  Andreas Matthies  <andreas.matthies@arcormail.de>

	* raster/raster-sprite-status.c(raster_sprite_status_init)
	initialize mc_sprite_color_1 and mc_sprite_color_2

2000-02-29  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.3.

	* arch/os2/Makefile.am, arch/os2/vac++/Makefile.am: Fixed
	makefiles.

	* arch/unix/vic20ui.c: Commented out unused code.

2000-02-28  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/gnome/ui.c 
	(fliplist_popup_cb): Added contents menu handling for right
	click. 
	(tape_popup_cb): Ditto.
	(ui_set_tape_status): Added (still incomplete) handling for the
	tape status widget.
	(ui_display_tape_current_image): Set `last_attached_tape'.
	(UI_CALLBACK ui_popup_selected_file): New function. Autostart
	selection from rightclick popup.
	(menu_set_style): New function. Helper to set CBM font for popup
	contents menu.
	(rebuild_contents_menu): New function. Gather image contents of
	unit and create a popup mene for drive- and tape status widgets.
	(ui_fill_preview): Change message to upper case, to be readable
	with CBM font. Added clist width setting also for last line.

2000-02-28  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* fliplist.h: FLIP_NEXT, FLIP_PREV defined

	* monitor/mon_parse.c: warning for __IBMC__ removed
  
	* arch/os2/archdep.c: minor changes.

	* arch/os2/console.c: monitor handling enhanced
  
	* arch/os2/dialogs/*.*: small reorganisation, drive dialog
	enhanced, reset-dialogs added, fliplist feature implemented,
	minor changes, new drives implemented, promp handling added to
	monitor-dialog
  
	* arch/os2/dialogs/dlg-reset.c added
  
	* arch/os2/install.cmd: extension-handling added
  
	* arch/os2/kbd.c: key for fliplist added
  
	* arch/os2/ui.c: minor changes, drive status implemented (old
	one removed)
  
	* arch/os2/ui_status.c -> unused/ui_status.c
  
	* arch/os2/ui_status.h: make fit to new status handling
  
	* arch/os2/video.c: problems with wrong window width fixed
  
	* arch/os2/vsync.c: new status handling implemented

2000-02-28  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.32.

	* info.c: Updated.

	* c64/reu.c: Removed comment inside comment.

	* arch/unix/x11/xaw/ui.c (ui_set_speedmenu): Fixed prototype.

	* arch/unix/vic20ui.c: Commented out unused code.

2000-02-22  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/gnome/uimenu.c: 
	(all): Reworked checkmark code to be able
	to remove menus (used for dynamic generated popup menus,
	e.g. fliplists). GNOME_MENUS code won't build anymore, and will be
	discarded soon.

	* arch/unix/x11/gnome/uiarch.h: New prototype.
	* arch/unix/x11/xaw/uiarch.h: ditto.
	* arch/unix/x11/xaw/ui.c (ui_set_speedmenu): Added dummy for
	`ui_set_speedmenu(). 

	* arch/unix/x11/gnome/ui.c: 
	(fliplist_popup_cb): update menu before popping up the flipmenus.
	(speed_popup_cb): New Function.
	(ui_set_speedmenu): New Function.
	(ui_create_status_bar): Added speed popup menu to speedlabel.

	* arch/unix/uicommands.c (ui_update_flip_menus): Removed HASH_MENU
	code. Added menu item `Drive Settings' to popup menu.

	* arch/unix/c64ui.c (c64_ui_init): Initialize speedmenu.
	* arch/unix/c610ui.c (c610_ui_init): ditto.
	* arch/unix/petui.c (pet_ui_init): ditto.
	* arch/unix/c128ui.c (c128_ui_init): ditto.
	* arch/unix/vic20ui.c (vic20_ui_init): ditto.

2000-02-20  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* imagecontents.c 
	(image_contents_to_string): Changed all literal strings to
	uppercase in case we build for Gnome. Don't convert the strings to
	petscii, since the Gnome port now support CBM fonts for image
	preview.

	* arch/unix/x11/gnome/uiarch.h 
	(ui_unblock_shells): New prototype.
	(ui_block_shells): ditto.

	* arch/unix/x11/gnome/ui.c: 
	Started CBM font handling.
	(ui_init_finish): Check wether CBM font can be loaded, otherwhise
	use a fixed font as a fallback.
	(ui_fill_preview): In case we don't have a CBM font convert the
	strings into ascii.
	(ui_unblock_shells): Made function global (was static).
	(ui_block_shells): ditto.
	(build_show_text): Reworked to use scrolled window for textwidget.

	* arch/unix/x11/gnome/about.c 
	(ui_about): Reworked to be more GTK/Gnome sane.

2000-02-20  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.31.

	* attach.c (attach_disk_image): Fixed memory leak.

	* interrupt.h: New struct member `nmi_trap_func'.

	* interrupt.c (interrupt_cpu_status_init) Initialize
	`nmi_trap_func'.
	(interrupt_set_nmi_trap_func): New function.

2000-02-17  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/gnome/ui.c:
	(build_file_selector): Moved autostart button to buttonbox of
	fileselector. Fixed `orphan' scrollbars. Store fileselection and
	autostart button on static globals.
	(ui_fill_preview): Set OK button for default on new fileselection.
	(ui_select_contents_cb): Set Autostart button as default when
	selection in preview is done. Handle Doubleclicks on selection.

2000-02-13  Andreas Matthies  <andreas.matthies@arcormail.de>

	* vicii/vicii.c(vic_ii_set_geometry): uses
	vic_ii.row_25_start_line instead of vic_ii.screen_borderheight
	as y-coordinate for gfx_position of the raster_geometry

2000-02-13  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/gnome/ui.c:
	(ui_jam_dialog): Change to Gnome Dialog.
	(filesel_autostart_cb): Rewritten, contents preview uses GtkClist
	now.
	(ui_fill_preview): ditto.
	(ui_select_contents_cb): New function. Set index of selected file
	for autostart.
	(ui_select_file): Add `destroy' handler for WM destroy event. 
	Fixed event-handler code accordingly.
	(ui_popup): Disable popup center code. Use WM to place the window
	properly.
	(build_file_selector): Reworked to place contents preview widget
	next to file widget. This makes the fileselector expand in
	X-direction where we normally have more resolution. The code is
	messing a bit with the stock GTK fileselector widget, which might
	fail in future versions of GTK+.
	(UI_CALLBACK enter_window_callback): Set `_ui_top_level' to
	toplevel window. This was a bug.

2000-02-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.30.

	* arch/unix/x11/xaw/ui.c, arch/unix/x11/xaw/uisnapshot.c,
	arch/unix/x11/xaw/uiedisk.c: Fixed `ui_select_file' prototype.

2000-02-10  Markus Brenner  <markus@brenner.de>

	* vdc-mem.c: fixed blockmove/copy behaviour

	* cartridge.h: added Final Cartridge 1 CRT type 13

	* c64/c64cartridge.c: added FC1 support

	* c64/c64cartmem.c: added FC1 support

	* info.c: added my contribution information

2000-02-06  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/gnome/ui.c: 
	Implemented 2 Led drive UI.
	Change almost all dialogs to gnome-dialogs.
	(filesel_autostart_cb): Changed assertion to normal `if'.
	(ui_open_canvas_window): Connect `enter-notify-event' to proper
	callback. This makes centering of popup relative to last visitied
	shell (only visible in x128).
	(ui_select_file): Enhanced to give control about autostart and
	preview widgets. 
	Adopted other files accordingly (c64ui.c, etc.)

2000-02-04  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/joystick.c: added missing include

2000-02-04  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.29.

	* drive/drive.h: Fixed 1541 ROM checksum.

	* monitor/mon_parse.y: Define `__yy_memcpy' from `__IBMC__'.

	* arch/msdos/menudefs.c: Added missing drive types.

	* arch/msdos/statusbar.c: #include "raster.h".

	* arch/msdos/ui.c (ui_draw_drive_status): Added missing
	parentheses.

	* arch/msdos/petui.c, arch/msdos/c610ui.c: Added disk and
	datasette submenu.

	* arch/win32/res.rc: Updated contributors.

	* arch/win32/resc64.rc, arch/win32/res.h, arch/win32/c64ui.c:
	Added SS5 cart.

2000-02-04  Andreas Matthies  <andreas.matthies@arcormail.de>

	* arch/msdos/c128ui.c,arch/msdos/c64ui.c: new menu-items
	and corresponding callback functions for VideoStandard,
	includes drive.h for this

	* arch/msdos/menudefs.c: removed sync factor from the drive
	settings menu
	new menuitem for Printer 4 in "Other settings"
	changed Statusbar callback to support automatic mode

	* arch/msdos/statusbar.c(statusbar_enabled): handles automode
	(statusbar_to_screen): new parameters x_offset,x_width for 
	variable use and corresponding changes in the calls
	new functions (statusbar_set_height) and (statusbar_prepare)

	* arch/msdos/statusbar.h: new prototypes, new definitions for
	modes of statusbar

	* arch/msdos/ui.c(set_statusbar_enabled): calls 
	statusbar_enabled() so implement auto mode
	new default for ShowStatusbar is STATUSBAR_MODE_AUTO

	* arch/msdos/video.c(canvas_resize): sets the height of status
	simply by checking the VGA mode for >200 lines; this may be
	improved later

2000-01-30  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.28.

	* maincpu.c, datasette.c, c64/c64.c, c128/c128.c,
	vic20/vic20.c, pet/pet.c, cbm2/c610.c: Moved datasette
	specific stuff where it belongs to.

	* 6510core.c: Simplified drive CPU defines.

	* arch/unix/x11/gnome/about.c, arch/unix/x11/xaw/about.c,
	arch/msdos/menudefs.c, info.c: Updated contributors.

	* arch/os2/vac++/Makefile.am: Fixed filenames.

2000-01-30  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* fsdevice.c: reordered #ifdef __IBMC__ includes

	* vdc/vdctypes.h, vicii/vicii.c: removed char-12
  
	* sounddrv/sounddart.c, soundmmos2.c: minor changes (see
	below)
  
	* arch/os2/archdep.c: "right" way to determin exe-filename
	with OS/2, name of config- and logfile changed,
	problems with archdep_make_backup_filename solved,
	archdep_spawn now in background,
	Semaphore for archdep_spawn added

	* arch/os2/config.h, arch/os2/console.c, arch/os2/dialogs.c,
	arch/os2/dlg-attach.c, arch/os2/dlg-create.c,
	arch/os2/dlg-sound.c, arch/os2/joystick.[ch],
	arch/os2/kbd.[ch], arch/os2/main_exit.c,
	arch/os2/pm_cmdline.c, arch/os2/rs232.c, arch/os2/sounddrv.c,
	arch/os2/types.h, arch/os2/ui.h, arch/os2/ui_status.c,
	arch/os2/video.c, arch/os2/videoarch.h: minor chnages (mainly
	reorganization of include statements)

	* arch/os2/types.h: include <os2.h> deleted

	* arch/os2/dialogs.[h,rc], dlg-datsette.c: Datasette control
	enhanced

	* arch/os2/dlg-reset.c added

	* arch/os2/dlg-drive.c: Image-history -> ui_status

	* arch/os2/dlg-emulator.c #define VIDEO_CACHE --> const char
	definition

	* arch/os2/doc/Vice_for_OS2.txt added

	* arch/os2/install.cmd: cbm/2, Vice_for_os2.txt added

	* arch/os2/makeclean.cmd added

	* arch/os2/makedist.cmd: vice_for_os2.txt added

	* arch/os2/ui.c: some reorganisation, reset-uis --> dlg-reset.c,
	tape-uis redirected to tape-dialog, display_drive_image
	handles the imageHist now

	* arch/os2/ui_status.h: imageHist, lastTapeStatus,
	lastTapeCtrlStatus to ui_status_t added

	* arch/os2/vac++: RESID.ICC renamed to reSID.ICC, VICE_INF.ICC
	-> Vice_inf.ICC 
         
	* arch/os2/vsync.c: kbd_buf_flush added to do_vsync

2000-01-30  Andre Fachat  <a.fachat@physik.tu-chemnitz.de>

	* arch/unix/uisettings.c (set_drive0_type_submenu): added 3040 and
	4040 disk drives

	* drive/drive-cmdline-options.c (cmdline_options): added -dos2040,
	-dos3040 and -dos4040 options.

	* drive/drive-resources.c (dos_rom_name_2040, dos_rom_name_3040,
	dos_rom_name_4040): new
	(set_drive0_type, set_drive1_type): add 2040/3040/4040 disk types
	(set_dos_rom_name_2040, set_dos_rom_name_3040, set_dos_rom_name_4040):
	new
	(resources): add DosName2040, DosName3040, and DosName4040
	
	* drive/drive-snapshot.c (drive_write_snapshot_module, 
	drive_read_snapshot_module): use DRIVE_IS_OLDTYPE instead of explicit 
	drive type tests. Add support for 2040/3040/4040 disk drives

	* drive/drive.c (drive_rom2040, drive_rom3040, drive_rom4040): new
	(rom2040_loaded,  rom3040_loaded, rom4040_loaded): new
	(drive_set_active_led_color, drive_set_clock_frequency,
	drive_set_disk_drive_type): add 2040/3040/4040 support
	(drive_load_2040, drive_load_3040, drive_load_4040): new
	(drive_load_rom_images): load 2040/3040/4040 images
	(drive_setup_rom_image, drive_check_image_format): add 
	2040/3040/4040 support
	(drive_match_bus): use DRIVE_IS_IEEE() instead of explicit drive
	type check
	(drive_check_type): add 2040/3040/4040 support 

	* drive/drive.h (DRIVE_ROM2040_SIZE, DRIVE_ROM3040_SIZE, 
	DRIVE_ROM4040_SIZE, DRIVE_TYPE_2040, DRIVE_TYPE_3040, DRIVE_TYPE_4040):
	new
	(DRIVE_IS_IEEE, DRIVE_IS_OLDTYPE, DRIVE_IS_DUAL): add support for 
	new disk types
	(drive_rom2040, drive_rom3040, drive_rom4040, rom2040_loaded, 
	rom3040_loaded, rom4040_loaded, drive_load_2040, drive_load_3040,
	drive_load_4040): new extern definitions.

	* drive/drivecpu.c (drive_jam): add 2040/3040/4040 support
	(drive_cpu_write_snapshot_module, drive_cpu_read_snapshot_module):
	use DRIVE_IS_OLDTYPE instead of explicit drive type tests.

	* drive/drivemem.c (drive_mem_init): add 2040/3040/4040 support
	Use DRIVE_IS_OLDTYPE where appropriate
	
	* drive/fdc.c (DOS_IS_80, DOS_IS_40, DOS_IS_30, DOS_IS_20): new tests
	(fdc_reset): use DRIVE_IS_OLDTYPE
	(fdc_do_job): better error reporting in debug mode
	Add support for DOS3040/DOS4040 ROMs
	(int_fdc): add support for 3040/4040 ROMs
	(fdc_attach_image, fdc_detach_image): add support for D64, G64 
	and X64 images, for 3040/4040 disk drives

2000-01-29  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* c64/reu.c: fixed an error when comparing host memory to REU
	memory; now 17xxTester works w/o reporting a defective REU.

2000-01-29  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.27.

	* vicii/vicii.c (vic_ii_raster_draw_alarm_handler):
	canvas_set_border_color is only avaiable on the MSDOS port.

	* cartridge.h, c64/c64cartridge.c, c64/c64cartmem.c: New REX
	fastload module.

2000-01-29  Andreas Matthies  <andreas.matthies@arcormail.de>

	* arch/msdos/Makefile.am: add raster to include paths

	* arch/msdos/statusbar.c(statusbar_disable): calls
	raster_mode_change to force a repaint of the bitmap

	* src/arch/msdos/tuifs.c: checks for defintions of 
	OSTYPE_WIN98 for compatibility with Allegro 3.00
	
	* arch/msdos/videoarch.h(canvas_refresh): back to older
	scroll-functions for compatibility with Allegro 3.00

	* datasette.c: new function (datasette_start_motor)
	(datasette_control): calls datasette_start_motor at PLAY,
	FF or REWIND to fix a bug that occured when stop and 
	restart the datasette

	* vicii/vicii.c: removed all #ifndef __MSDOS__
	(vic_ii_set_geometry) calls video_ack_vga_mode for MSDOS
	to reset the canvas size for current VGA-mode

2000-01-24  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* monitor/mon.c, monitor/mon.h, 6510core.c:
	fixed bug regarding 'next' and 'return' monitor commands,
	where these sometimes did not return to the monitor.

2000-01-23  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* info.c: Updated my contribution.

	* arch/unix/x11/gnome/uisnapshot.c 
	(ui_snapshot_dialog): Make use of ui_popdown() to properly
	unblock the shells.

	* arch/unix/x11/gnome/uiedisk.c 
	(ui_empty_disk_dialog): Make use of ui_popdown() to properly
	unblock the shells.

	* arch/unix/x11/gnome/ui.c 
	(app_shell_type): Added field for shell local topmenu.
	(filesel_autostart_cb): New function. Callback for autostart a
	selected file from an image.
	(ui_init_finish): Select a fixed font for textdisplay.
	(ui_create_status_bar): Beautified. 
	(ui_open_canvas_window): Changed from `gtk_window()' to
	`gnome_app()'. This make menuhandling easier. -> One now can tear
	off the topmenu. 
	Removed handlers to `ui_hotkey_event_handler' on key-presses. This
	is called by the main kbd-handler now. See below. 
	Initialize topmenu for each shell.
	(ui_set_topmenu): Set topmen for all shells. This issues a GTK+
	warning when more than one shell is active (x128), but from
	reading the GTK+-code this is not a problem now.
	(ui_display_drive_current_image): Adjusted tooltip to new status bar.
	(ui_display_tape_current_image): ditto.
	(ui_fill_preview): New function. Callback when a fileselection is
	done. This fills the contents preview, which now can be selected
	and autostarted.
	(ui_select_file): Reworked to support inlined contents preview +
	selection autostart.
	(ui_block_shells): Block any events for all shells.
	(ui_unblock_shells): Unblock all shells.
	(ui_popup): Block/Unblock shells. This fixes the `multiple popup
	by hotkey' bug.
	(ui_popdown): ditto. 
	(build_file_selector): Reworked to inline image contents preview.
	(UI_CALLBACK exposure_callback): Added support for resizing issued
	by GTK+. This makes resizing after menu-tearoff/attach work
	correctly.

	* arch/unix/x11/gnome/gnomekbd.c: Fixed `meta_count' to be extern
	(kbd_event_handler): Call `ui_hotkey_event_handler' directly. So
	there's only one GTK+ keyboardhandler. This fixes the `keys passed
	on...' bug.
	
	* arch/unix/x11/gnome/about.c: Reworked, beautified. Added buttons
	for licence, warranty and contributors.

	* arch/unix/uicommands.c: 
	(ui_set_selected_file): New function. Called from specific UI to
	tell autostart file number.

2000-01-22  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.26.

	* vdrive/vdrive-rel.c (vdrive_rel_position): Set buffer
	length.

	* vdrive/vdrive-iec.c (vdrive_iec_read): Implemented
	`BUFFER_RELATIVE' mode.

	* sound.h: Added structure name.

	* pet/petsound.c: Fixed includes.

	* drive/drive.c, drive/drive.h, drive/drivecpu.c, c64/c64.c,
	parallel.c: Removed `drive_cpu_execute'.

	* prdevice.c: Fixed serial function prototypes.

2000-01-22  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* autostart.c: workaround for p00_check_name deleted (seems to
	work now)

	* crtc/resources.c: char-12 removed

	* fsdevice.c: minor changes

	* info.c: Thomas Bretz added

	* sid/resid.cc: unnecessary includes removed

	* monitor/mon.c: quit-command mapped to exit (for OS/2)

	* monitor/mon_lex.[cl], mon_parse.[cy]: made this compile
	without warnings on OS/2

	* raster/raster-changes.h, raster/raster-sprite-status.c,
	raster/raster.[ch]: char-12 removed

	* vic20/vic-cmdline-options.c, vic20/vic-resources.c,
	vic20/vic.c, vic20/vicii-mem.c: char-12 removed

	* vic20/vic.h: VIC_DUPLICATE_PIXLES undifined for OS2 (this is
	faster by hardware)
 
	* arch/os2/console.c: console_out: skip trailing '\n'
	console_in: ready for trigger_shutdown

	* arch/os2/dialogs/dialogs.[rc,hc]: added attach_dialog,
	create_dialog

	* arch/os2/dialogs/dlg-attach.c, dialogs/dlg-create.c added

	* arch/os2/dialogs/dlg-drive.c: drive type change added,
	create button added

	* arch/os2/kbd.c: ui_attach --> dlg-attach.c

	* arch/os2/ui.c: ui_file_dialog --> dlg_attach.c

	* arch/os2/kbd/kbd-pet.c: keyboard.h included

	* arch/os2/vac++/*.icc, vac++/incl/*.icc: updated

	* arch/os2/video.c: minor changes, 'undef __XVIC__' deleted

	* arch/os2/videoarch.h: workaround for xvic added

2000-01-22  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/archdep.h: changed MODE_READ_TXT from "r" to
	"rt", so CR/LF will be handled correctly.

	* monitor/mon.c: when open a file for playback, changed mode
	from MODE_READ to MODE_READ_TEXT so the file can be edited
	with a DOS style editor (i.e., using CR/LF instead of LF).

	* arch/win32/c64.dsp, arch/win32/vic20.dsp: changed filenames
	cartridge.c to c64cartridge.c or vic20cartridge.c, resp.

	* arch/win32/vdrive.dsp: added vdrive-rel.c

	* arch/win32/monitor.dsp: removed /GZ command line switch in
	debugging environment since MSVC++ 5.0 doesn't recognize it.

2000-01-21  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.25.

	* monitor/mon.c (mon_check_icount): Only skip JSR/RTS if
	skipping suboutines is enabled.

	* palette.c: (palette_load): If line length is zero do not
	touch the buffer.  Check all return values.

	* sysfile.c, sysfile.h, palette.c, arch/unix/x11/kbd.c,
	romset.c (sysfile_open): Open mode is specified now.

	* c64/reu.c, c64/reu.h (reu_deactivate): New function.

	* c128/c128mem.c, c64/c64mem.c (set_reu_enabled): Disable REU
	if REU support is switched off.

	* vdrive/vdrive-rel.c, vdrive/vdrive-rel.h: New files

	* attach.c (file_system_init): Clear side sector buffer.

	* vdrive/vdrive-iec.c (vdrive_iec_close): Close relative
	files.

	* vdrive/vdrive-command.c (vdrive_command_position): New
	function.

	* info.c: Updated.

2000-01-21  Dag Lem  <resid@nimrod.no>

	* arch/unix/x11/gnome/ui.c (archdep_ui_init): Do nothing in
	console mode.

	* arch/unix/x11/xaw/ui.c (archdep_ui_init): Do nothing in
	console mode.

	* arch/unix/x11/video.c (canvas_resize): Do nothing in
	console and vsid modes.

	* datasette.c (datasette_set_motor): Skip UI stuff in console and
	vsid modes.

	* drive/drive.c (drive_update_ui_status): Do nothing in console
	and vsid modes.

	* main.c (main): Moved check for -console and -vsid to the
	start. Disabled emulation of drive 8, which is enabled by default.

	* sid/sid.c (sid_store): Commented out PSID register (digital
	samples) warning.

	* sounddrv/sounduss.c (uss_bufferstatus): Changed comment on
	GETOSPACE warning.

2000-01-20  Andreas Matthies  <andreas.matthies@arcormail.de>

	* arch/msdos/menudefs.c: new datasette settins menu, updated
	datasette control menu

	* arch/msdos/statusbar.h: new colors for the statusbar

	* arch/msdos/ui.c: new function (ui_draw_drive_status) to 
	display status of drives in the statusbar
	(ui_enable_drive_status),(ui_display_drive_track),
	(ui_display_drive_led) update the statusbar
	(ui_draw_tape_status),(ui_display_speed): minor changes in 
	design
	
	* arch/msdos/video.c (canvas_set_palette): new statusbar color 
	are created

	* arch/win32/ui.c (handle_wm_command): datasette counter resets
	via (datasette_control)

	* datasette.c (datasette_control): handles even
	DATASETTE_CONTROL_RESET_COUNTER to simplify the datasette
	controls for the ports
	
	* datasette.h: new define DATASETTE_CONTROL_RESET_COUNTER

	* info.c: updated contributions

2000-01-20  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.24.

	* imagecontents.c (image_contents_to_string): `bufcat' returns
	a pointer to the new buffer if the old one was too small.

	* c1541.c (floppy_read_directory): Fixed usage of `bufcat'.

	* c64/Makefile.am, vic20/Makefile.am: Changed name of
	`cartridge.c'.

2000-01-19  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* vic20/vic.h: replaced // with /* ... */

2000-01-18  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* c64/reu.c: corrections of errors in reu_reset(), now it
	should be able to process reu sizes different from REUSIZE.

	* c128/c128mmu.c: now reu_dma(-1) is called when a write to
	$FF00 is detected, so the reu will work the $FF00 option.

2000-01-18  Nathan Huizinga  <nathan.huizinga@chess.nl>

	* c64/c64cart.h: Define C64CART_RAM_LIMIT added.

	* c64/c64mem.c: Use C64CART_RAM_LIMIT define for allocating
	export_ram0 buffer.

	* c64/c64cartmem.c: Use C64CART_RAM_LIMIT define for allocating
	the *static* export_ram0 buffer.
	Current SS5 emulation replaced by a more exact emulation and
	support added for 32Kb RAM expansion.

2000-01-18  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* c64/cartridge.c --> cartridge64.c

	* vic20/cartridge.c --> cartridge20.c

	* crtc/crtc.h: vice.h included

	* main.c: description for OS/2-"DoCoreDump" added

	* utils.c: better log_error for x/re/malloc

	* arch/os2/config.h: minor change

	* arch/os2/dialogs/dialogs.[hc,rc]: minor changes

	* arch/os2/dialogs/dlg-emulator.c: Emulator ID added

	* arch/os2/vac++/*.icc: minor changes

	* arch/os2/vac++/incl/resid.icc: added (needed, because extern
	"C" could not be optimized)

	* video.c: added resources and cmdline ptions for changing PM
	border

2000-01-18  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.23.

	* vdrive/vdrive.h: Changed `find_length' to `int'.

2000-01-17  Michael Klein  <michael.klein@puffin.lb.shuttle.de>

	* c1541.c (write_cmd): Fixed name conversion.

2000-01-16  Andreas Matthies  <andreas.matthies@arcormail.de>

	* arch/msdos/Makefile.am: new files statusbar.h, statusbar.c

	* arch/msdos/kbd.c: includes statusbar.h
	handles KCMD_TOGGLE_STATUSBAR to switch statusbar, currently
	ALT-F5 is used (is this okay?)

	* arch/msdos/menudefs.c: new entry "Show Statusbar" in 
	"Other settings"

	* arch/msdos/statusbar.c,arch/msdos/statusbar.h: new files to 
	implement the statusbar

	* arch/msdos/tuifs.c(file_list_read): recognizes WIN98 and
	WINNT for long filename support

	* arch/msdos/ui.c: includes datasette.h ,statusbar.h
	new resource ShowStatusbar and corresponding cmdline
	(ui_exit) calls statusbar_exit
	(ui_init) calls statusbar_init
	new function (ui_draw_tape_status),(ui_display_speed)
	implementations for (ui_set_tape_status),
	(ui_display_tape_motor_status),(ui_display_tape_control_status),
	(ui_display_tape_counter)
	
	* arch/msdos/video.c: new function (video_in_gfx_mode)
	(canvas_set_vga_mode): sets bitmaps and width for the statusbars
	update
	(canvas_set_palette): creates colors for statusbar
	(disable_text): updates statusbar

	* arch/msdos/videoarch.h (canvas_refresh): don't refresh
	region of  statusbar; calls (poll_scroll) and (request_scroll)
	instead of obsolete ...modex... variants

	* arch/msdos/vsync.c(do_vsync): calls ui_display_speed

2000-01-16  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* monitor/mon.c: Fill `strerror()' with dummy macro in case
	`errno.h' is missing.
	Report `#error' if `signal.h' is missing.

	* arch/unix/x11/gnome/uiedisk.c: Implemented missing dialog.
	* arch/unix/x11/gnome/uisnapshot.c: ditto.

2000-01-16  Dag Lem  <resid@nimrod.no>

	* arch/unix/vsid: Use exec to start x64.
	
	* arch/unix/x11/gnome/gnomekbd.c (kbd_event_handler): Skip
	keyboard handling in vsid mode.

	* arch/unix/x11/gnome/ui.c (ui_jam_dialog):
	Special handling of console and vsid modes.
	
	* arch/unix/x11/gnome/uimenu.c (_ui_menu_toggle_helper,
	_ui_menu_radio_helper): Pass data to UI process in vsid mode.

	* arch/unix/x11/gnome/uimenu.h: Removed const from string in
	_ui_menu_entry.
	
	* arch/unix/x11/xaw/uimenu.h: Removed const from string in
	_ui_menu_entry.
	
	* sounddrv/sounduss.c: Commented out GETOSPACE warning.

2000-01-16  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.22.

	* vdrive/vdrive-iec.c, vdrive/vdrive-command.c,
	vdrive/vdrive.h: Removed `read_only' from struct vdrive.

	* diskimage.c (disk_image_write_track,
	disk_image_write_sector): Check read only flag before writing.

	* parallel.c, parallel.h: Do not inline some functions.

	* serial.h, vdrive/vdrive-iec.h, vdrive/vdrive-iec.c,
	fsdevice.c, serial.c, c1541.c: Removed casting.

	* vdc/vdc.h, c128/c128mem.c, c128/z80mem.c, crtc/crtc.h,
	arch/unix/uicmdline.h, arch/unix/x11/xaw/uimenu.h,
	arch/unix/uicommands.h, arch/unix/x11/xaw/ui.c,
	arch/msdos/tuiimagebrowser.c, arch/msdos/tuifs.c,
	arch/msdos/tuimenu.h, arch/msdos/c128ui.c, arch/msdos/video.c,
	arch/msdos/c610ui.c, arch/msdos/c64ui.c, arch/msdos/sidui.c,
	arch/msdos/menudefs.c, arch/msdos/petui.c, arch/msdos/sidui.h,
	arch/msdos/tuimenu.c, arch/msdos/vic20ui.c,
	arch/msdos/tuifs.h, arch/msdos/uiattach.c, arch/msdos/sidui.c,
	arch/msdos/uicmdline.h, arch/msdos/videoarch.h,
	arch/msdos/uisnapshot.h, arch/msdos/uisnapshot.c,
	arch/msdos/uiattach.h, arch/win32/uicmdline.h,
	arch/win32/video.c, arch/riscos/uicmdline.h,
	arch/os2/uicmdline.h, arch/unix/x11/gnome/ui.c: Changed
	structures, fixed includes.

	* arch/unix/x11/kbdef.h, arch/unix/x11/kbd.c: Removed useless
	code.

	* keyboard.h, arch/unix/kbd.h, arch/win32/kbd.h,
	arch/riscos/kbd.h, arch/msdos/kbd.h, arch/os2/kbd.h: Moved
	common stuff to `keyboard.h'.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c,
	cbm2/c610.c, arch/unix/joystick.carch/msdos/joystick.c,
	arch/unix/mouse.c, arch/msdos/mouse.c, arch/win32/joystick.c,
	arch/win32/mouse.c, arch/riscos/joystick.c,
	arch/os2/joystick.c: Include `keyboard.h' instead of `kbd.h'.

2000-01-16  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* INSTALL: OS/2 added

	* vic20/vic.h: prepared to let the graphic driver makes
	x-stretching for OS/2.

	* arch/os2/archdep.c: added ifndef _PETCAT__ statements

	* arch/os2/*ui.[ch]* --> ui\*ui.[ch]

	* arch/os2/dialogs.[ch,rc] -> dialogs\dialogs.[ch,rc]

	* arch/os2/dialogs\c1541.rc added

	* arch/os2/install.cmd: minor changes

	* arch/os2/main_exit.c shuting down functions commented out

	* arch/os2/vsync.c: exit is now handled here.

	* arch/os2/makedist.cmd added

	* arch/os2/texi2ipf\* added

	* arch/os2/vac++/*.ICC Option settings reorganized

	* arch/os2/video.c: minor changes

	* arch/os2/log.c: __C1541__ added

2000-01-15  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.21.

	* cbm2/crtc610.c: Removed.

	* pet/petiec.c: Use logging instead of printf().

	* arch/os2/unused/Makefile.am: Fixed makefile.

	* arch/win32/c64ui.c: Removed unused variables.

	* palette.c, snapshot.c, romset.c, log.c, sysfile.c, t64.c,
	autostart.c, utils.c, zfile.c, drive/drive-snapshot.c,
	c64/psid.c: Use arch modes to open files.

	* datasette.c, datasette.h, vicii/vicii.h, c64/c64mem.c,
	c128/c128mem.c, tap.h, c128/z80mem.c, crtc/crtc.h,
	pet/petmem.c, cbm2/c610mem.c, raster/raster-sprite-status.h,
	raster/raster-sprite.h, raster/raster-sprite-status.c,
	raster/raster.c, raster/raster.h, vicii/vicii-mem.c,
	vicii/vicii-snapshot.c, vicii/vicii-sprites.c, vicii/vicii.c,
	raster/raster-modes.h, raster/raster-sprite-cache.h,
	vicii/vicii-draw.c, vdc/vdc-draw.c, vdc/vdc.c, arch/unix/ui.h,
	arch/unix/x11/videoarch.h, arch/unix/x11/xaw/uiarch.h,
	arch/unix/x11/xaw/ui.c: Changed structures, fixed includes.

2000-01-15  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/console.c: added test for ctrl+c and ctrl+break;
	when one is pressed, process_break() is called.
	ESCAPE key is handled likewise.

2000-01-13  Tibor Biczo  <crown@matavnet.hu>

	* arch/win32/c1541.dsp, arch/win32/monitor.dsp,
	arch/win32/petcat.dsp, arch/win32/vice.dsp,
	arch/win32/x128.dsp, arch/win32/x64.dsp, arch/win32/vice.dsp,
	arch/win32/x128.dsp, arch/win32/x64.dsp, arch/win32/xcbm2.dsp,
	arch/win32/xpet.dsp, arch/win32/xpet.dsp: Changed compilation
	flags for Debug target, so there should be no warning about
	unknown flags when compiling with MSVC5.

	* arch/win32/cbm2.dsp: Removed crtc.c.

	* arch/win32/ui.c: (status_hwnd) changed into array.
	(window_canvas_xsize, window_canvas_ysize): New variables.
	Updated every instance of using status_hwnd.
	(ui_resize_canvas_window): Handle case when window is maximized.
	(SetStatusWindowParts): Updated to handle multiple status
	windows.  Updated evey instance of SetStatusWindowParts.
	(ui_display_drive_track) (ui_display_drive_led)
	(ui_set_tape_status) (ui_display_tape_motor_status)
	(ui_display_tape_control_status) (ui_display_tape_counter):
	Handle multiple Status windows.
	(window_proc): Removed exposure_handler calls...

	* arch/win32/video.c (canvas_update): Added canvas centering.
	(canvas_refresh): Renamed function to real_refresh.
	canvas_refresh function now translates the window's client
	coordinate system to the canvas's coordinate system, including
	canvas centering on the window, then it calls real_refresh.

2000-01-12  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* crtc/crt-cmdline-options.c: REMOVED CHARACTER 0x0C from
	SRC-CODE!

	* pet/petmem.c: small enhancement of the 'couldnt load
	character rom' statement
 
	* arch/os2/archdep.c: added ifndef __C1541__ statements

	* arch/os2/dialogs.rc: Head added

	* arch/os2/kbd.c: made 4080col-key work

	* arch/os2/kbd/kbd-c610.c, c610ui.[ch]: added

	* arch/os2/kbd/kbd-vic20.c, vic20ui.[ch]: added

	* arch/os2/contentsdlg.[ch] --> unused/contentsdlg.[ch]

	* arch/os2/video_gpi.[ch] --> unused/video_gpi.[ch]

	* arch/os2/vsync_old.[ch] --> unused/vsync.[ch]

	* arch/os2/dlg-emulator.c: XVIC and XCBM support added

	* arch/os2/install.cmd: Pet, Xvic, C=1541 added

	* arch/os2/incl/*.icc added

	* arch/os2/vac++/* files includes incl/* know like real
	libraries

2000-01-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.20.

	* arch/unix/vic20ui.c, arch/unix/vsidproc.c: #include
	<stdlib.h>.

	* arch/unix/x11/xaw/uimenu.c: #include "vsidproc.h".

2000-01-09  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* raster/raster.c (realize_canvas): Pass frame_buffer to canvas
	create. Currently conditional to `USE_GNOMEUI'.

	* petcat.c (archdep_ui_init): New dummy function.

	* c1541.c (archdep_ui_init): New dummy function.

	* arch/unix/x11/xaw/x11video.c (ui_finish_canvas): New Function.

	* arch/unix/x11/xaw/uiarch.h: New File. Xaw specific declarations,
	macros, prototypes.
	
	* arch/unix/x11/xaw/ui.c: 
	Use XPM if detected.
	(archdep_ui_init): New (dummy) function.
	(ui_set_tape_menu): ditto.
	(ui_display_tape_current_image): ditto.
	(ui_set_application_icon): Attach xpm icon.
	(ui_canvas_get_drawable): Removed.
	Moved `ui_proc*' to `vsidproc' which is UI independent.
	(ui_dispatch_events): Replaced `ui_proc' stuff with call to
	`psid_dispatch_events()'.
	(ui_dispatch_drive_current_image2): Fixed image basename name
	memory leak.
	
	* arch/unix/x11/xaw/Makefile.am (libxawui_a_SOURCES): Removed
	`*.xpm', `ui.h' added `uiarch.h'

	* arch/unix/x11/videoarch.h: 
	(canvas_t): Added ui specific drawable field.
	Added inclusion of machine specific Xpm icon declaration.

	* arch/unix/x11/video.c (video_frame_buffer_free): Do not destroy 
	`x_image' when using Gnome/GTK+.
	Save old canvas structure to be able to resize the containing
	pixmap. 
	(canvas_create): Fill up canvas_t structur according to used
	ui. (Someday the #ifdefs might be removed...).
	(canvas_refresh): Pass framebuffer and canvas to refresh
	function. For Xaw those parameters aren't used, but won't hurt.

	* arch/unix/x11/kbd.c: Added `#include <string.h>'

	* arch/unix/x11/gnome/uimenu.h: Overall cleanup.
	Moved `CHECK_MENU' and
	`UI_MENU_CB_PARAM' to uiarch.h.

	* arch/unix/x11/gnome/uimenu.c: 
	(all): Added (but disabled) hashing of menus. This should be used
	to reuse menus-by-name when the same submenu should occur on
	different locations (e.g. toplevel menu, popup,
	etc.). Unfortunately this won't work so far, because the checkmark
	stuff is not adjusted yet.
	(ui_menu_create): Pass `list[i].string' as submenu name.

	* arch/unix/x11/gnome/uihotkey.c: Overall cleanup.

	* arch/unix/x11/gnome/uiarch.h: New File. Contains Gnome/GTK+
	specific declarations, macros, prototypes.

	* arch/unix/x11/gnome/ui.c: 
	(all):	Removed globals: canvas, pane.
	_ui_top_level references the first opened window. This might
	change in the future.
	Implemented tape status widget.
	Overall cleanup (Not finished yet).
	(ui_check_mouse_cursor): Reference _ui_top_level instead to canvas.
	(drive_status_widget): Reworked.
	(tape_status_widget): New widget.
	(app_shell_type): Added tape_status_widget.
	New colors: motor_running_pixel, tape_control_pixel.
	(archdep_ui_init): New function. Initialize Gnome here, to get
	atexit handlers attached before vice's atexit stuff.
	(ui_init): Moved gnome_init to `archdep_ui_init'.
	(tape_popup_cb): New Function.
	(ui_init_finish): Removed window creation stuff. This is
	completely handlede by `ui_open_canvas_window'.
	(ui_create_status_bar): Reworked completely.
	(ui_open_canvas_window): Reworked completely. Now handles window
	creation, locally. This fixes the x128 crash bug.
	(ui_set_topmenu): Added "Help" menu.
	(ui_set_application_icon): Implemented empty function to use xpm
	bitmap as application icon.
	(do_alloc_colors): Added allocation of 2 new colors for the tape
	widget.
	(ui_canvas_get_drawable): Removed. The canvas details are now
	hidden in the canvas_t structure.
	(ui_enable_drive_status): Adjusted to new drive_status_widget.
	(ui_display_drive_track): Added proper GTK cast.
	(ui_display_drive_led): Adjusted to draw into pixmap.
	(ui_display_drive_current_image): Changed image display to tooltip
	popup.
	(ui_set_tape_status): 
	(ui_display_tape_motor_status): 
	(ui_display_tape_control_status): 
	(ui_display_tape_counter): 
	(ui_display_tape_current_image): 
	New Functions. Implementation of the tape status widget.
	(ui_resize_canvas_window): Reworked. 
	(ui_set_drive9_menu): Fixed typo. Fixes a segfault.

	* arch/unix/x11/gnome/gnomevideo.c:
	(GDK_PUTIMAGE): Adjusted to use
	the canvas datastructure, instead of the global _ui_top_level.
	(video_frame_buffer_alloc): Removed MITSHM support; this is
	handeled by GDK. 
	Removed usage of toplevel window _ui_top_level.
	(ui_finish_canvas): New function. Initializes remaining fields gof
	the canvas_t structure. Needed to get rid of access to global
	_ui_top_level.

	* arch/unix/x11/gnome/Makefile.am (libgnomeui_a_SOURCES): Removed
	"ui.h" and "uihotkey.h", added "uiarch.h".

	* arch/unix/x11/*.xpm: Xpm pixmaps from xaw specific directory.

	* arch/unix/x11/Makefile.am (libx11ui_a_SOURCES): Added *.xpm
	icons.

	* arch/unix/vsidproc.h: New File. Interface for vsid ui.

	* arch/unix/vsidproc.c: New File. Code ripped out of xaw ui.

	* arch/unix/vic20ui.c (VIC20UI): 
	Replaced XPM specifics.
	(vic20_ui_init): Added initialization of tape popupmenu.
	(UI_CALLBACK set_common_memory_configuration):
	Recalculate memory blocks in any case. This fixes the vic20 Gnome
	UI bug.
	(UI_CALLBACK attach_cartridge): 
	Added support for remembering the last visited directory.
	(vic20_ui_init): Added initialization of tape popupmenu.

	* arch/unix/uisettings.c 
	(UI_CALLBACK select_user_keymap): 
	(UI_CALLBACK ui_load_palette): 
	(UI_CALLBACK ui_load_romset): 
	(UI_CALLBACK ui_load_rom_file): 
	(UI_CALLBACK ui_set_printer_dump_file): 
	Added support for remembering the last visited directory.

	* arch/unix/uihotkey.h: New File. independent declarations, macros,
	prototypes, etc. Neither Xaw nor Gnome/Gtk specifics should ever
	be added here!

	* arch/unix/uicommands.c 
	(UI_CALLBACK attach_disk): 
	(UI_CALLBACK attach_tape): 
	(UI_CALLBACK smart_attach): 
	(UI_CALLBACK load_snapshot_trap): 
	Added support for remembering the last visited directory.

	* arch/unix/ui.h: New File. UI independent declarations, macros,
	prototypes, etc. Neither Xaw nor Gnome/Gtk specifics should ever
	be added here!

	* arch/unix/petui.c:
	Replaced XPM specifics.
	(pet_ui_init): Added initialization of tape popupmenu.

	* arch/unix/c64ui.c 
	Replaced XPM specifics.
	(UI_CALLBACK attach_cartridge): 
	Added support for remembering the last visited directory.
	Added `#ifdef HAVE_MOUSE' around menu definition.
	(c64_ui_init): Added initialization of tape popupmenu.

	* arch/unix/c610ui.c:
	Replaced XPM specifics.
	(c610_ui_init): Added initialization of tape popupmenu.

	* arch/unix/c128ui.c: 
	Replaced XPM specifics.
	Added `#ifdef HAVE_MOUSE' around menu definition.
	(c128_ui_init): Removed tape_commands_menu.

	* arch/unix/archdep.c (archdep_startup): Added call to new
	function `archdep_ui_init()' to give gtk+ et al. a chance to
	register atexit handlers first. This fixed the shutdown segfault.

	* arch/unix/Makefile.am (libarch_a_SOURCES): Added `uihotkey.h'.

2000-01-09  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.19.

	* prdevice.c, arch/unix/uisettings.c, arch/riscos/ui.c: The
	printer device is called "Printer4Device".

2000-01-08  Tibor Biczo  <crown@matavnet.hu>

	* arch/win32/res.h: Removed IDC_CANCEL.

	* arch/win32/res.rc: Added IDCANCEL.
	Added IDC_ABOUT_VERSION to about dialog box, changed
	layout of copyright lines, and added 2000 to copyright.
	Changed Cancel buttons to use IDCANCEL instead of IDC_CANCEL.

	* arch/win32/resvic.rc: Use IDCANCEL instead of IDC_CANCEL.

	* arch/win32/ui.c (about_dialog_proc): Close dialog on
	IDCANCEL.

	* arch/win32/uidatasette.c (dialog_proc): Removed IDC_CANCEL.
	Handle only IDCANCEL.

	* arch/win32/uijoystick.c (keyset_dialog) (dialog_proc):
	Removed IDC_CANCEL, handle only IDCANCEL.

	* arch/win32/uilib.c (tape_hook_proc) (hook_proc): Replaced
	'MS Sans Serif' with NULL, when creating fonts, now the font
	is ok on Win95/98/2000.
	(TextDlgProc): Close Window on IDCANCEL (ESC key).

	* arch/win32/uisnapshot.c: Define OFN_ENABLESIZING if not yet
	defined.
	(ui_save_snapshot): Use OFN_ENABLESIZING when creating the
	save dialog box, so it will be resizable under Win98/2000.

	* arch/win32/uisound.c (dialog_proc): Handle IDCANCEL.

	* arch/win32/uivicset.c (dialog_proc): Handle IDCANCEL.

	* sounddrv/sounddx.c: Define DIRECTSOUND_VERSION as 0x0500.
	This is needed when compiling with DX7 SDK, but using
	the resulting binary on a system which has pre DX7 installed,
	otherwise sound will not work.
	(dx_init): Added some debug logging. Added error message for
	the case when the primary buffer can't be created.

2000-01-08  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.18.

	* vicii/vicii.c (vic_ii_update_memory_ptrs_external): New
	function.

	* c64/c64cartmem.c (cartridge_config_changed): Let the VIC-II
	recalculate its pointers changing ultimax mode.

	* diskimage.c (disk_image_write_sector,
	disk_image_write_track): Rewritten to work without GCR cache
	too.

	* gcr.c, gcr.h (gcr_write_sector): Rewritten to work without
	GCR cache too.

	* drive/drive.c (drive_gcr_data_writeback): Calculate track
	size.

	* drive/drive.h: Changed drive struct to eliminate the
	inclusion of "gcr.h" and "diskimage.h".

	* drive/drive-snapshot.c: #include "gcr.h".

	* vdrive/vdrive-bam.c, arch/unix/x11/xaw/uiedisk.c,
	vdrive/vdrive-command.c, vdrive/vdrive-iec.c, vdrive/vdrive.c,
	drive/drive-snapshot.c, arch/msdos/uiattach.c: #include
	"diskimage.h".

	* serial.h: Changed serial struct to eliminate the inclusion
	of "gcr.h" and "diskimage.h".

	* drive/fdc.c, drive/fdc.h, drive/wd1770.c, drive/wd1770.h,
	drive/drive.h, drive/drive.c:
	Unit is unsigned.

	* c64/c64cia2.c: #include "iecdrive.h".

	* snapshot.c, snapshot.h, interrupt.h, drive/drivetypes.h,
	mos6510.h, alarm.h, clkguard.h, palette.h: Changed structs to
	standard naming.

	* arch/unix/uicommands.c, maincpu.c, serial.c, tape.c, traps.c:
	#include "mos6510.h".

	* vicii/vicii.c, crtc/crtc.c, aciacore.c, vic20/vic.c:
	#include "clkguard.h".

	* pet/petpia1.ci, pet/petpia2.c, cbm2/c610tpi1.c: #include
	"interrupt.h".

	* raster/raster.h: Do not #include "palette.h".

	* arch/msdos/c64ui.c (attach_cartridge_callback): Set filter
	to "*.crt" if cartridge type is CRT.

	* arch/msdos/menudefs.c: #include <stdlib.h>.

	* arch/msdos/tuimenu.c, arch/msdos/tuiimagebrowser.c,
	arch/msdos/tuiview.c: #include <stdio.h>.

	* arch/msdos/tuifs.c, arch/msdos/vicesb.c: Do not #include
	<limits.h>.

2000-01-04  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.17.

2000-01-04  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* crtc/crtc.c, vdc/vdc.c, vicii/vicii.c: FALSE is not an ANSI
	C standard (or Vice, apparently). Replaced with 0.

2000-01-03  Markus Brenner  <markus@brenner.de>

	* vdc/vdc-mem.c: Added vdc_write_data(), fixed
	vdc_perform_fillcopy().

2000-01-03  Tibor Biczo  <crown@matavnet.hu>

	* arch/win32/Makefile.am (EXTRA_DIST): Added monitor.dsp.

2000-01-03  Andreas Matthies  <andreas.matthies@arcormail.de>

	* arch/win32/uidatasette.c (dialog_proc): now handles the
	cancel-messages

2000-01-02  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.16.

	* autostart.c, autostart.h (autostart_autodetect,
	autostart_disk, autostart_tape): The program to start can be
	specified by name or number now.

	* main.c, arch/unix/uicommands.c, arch/win32/ui.c,
	arch/win32/uiattach.c, arch/os2/dialogs/dlg-contents.c,
	arch/msdos/uiattach.c, arch/msdos/menudefs.c,
	arch/riscos/uiimage.c: Changed to new autostart API.

	* vic20/vic.c (init_raster): Fixed screen width.

	* vic20/vic.h: Define `VIC_DUPLICATES_PIXELS' for MSDOS too.

	* sound.c: Define `TRUE' and `FALSE' if not already defined.

	* arch/msdos/menudefs.c: #include "mon.h" and #include
	"interrupt.h".

	* console.h: Do not define `console_private_t' here.

2000-01-02  Tibor Biczo  <crown@matavnet.hu>

	* arch/win32/arch.dsp: Added 'monitor' to include search
	pathlist.
	Removed double entry for 'console.c'.

	* arch/win32/c128.dsp, arch/win32/c64.dsp, arch/win32/cbm2.dsp,
	arch/win32/drive.dsp, arch/win32/pet.dsp, arhc/win32/vic20.dsp:
	Added 'monitor to
	include search pathlist.

	* arch/win32/c64ui.c (c64_ui_cartridges): Array of cartridge
	attach parameters.
	(c64_ui_attach_cartridge): New function.
	(c64_ui_specific): Call c64_ui_attach_cartridge.

	* arch/win32/monitor.dsp: New project file for monitor library.

	* arch/win32/res.h: Added IDD_OPENTAPE_TEMPLATE.

	* arch/win32/res.rc: Define LBS_NOTIFY.
	Added LBS_NOTIFY flag for Preview listbox in IDD_OPEN_TEMPLATE.
	Added IDD_OPENTAPE_TEMPLATE.

	* arch/win32/ui.c (handle_wm_command): Added support for
	fileautostart.

	* arch/win32/uiattach.c (dialog_proc): Updated ui_select_file
	calls.

	* arch/win32/uilib.c: Include 'commctrl.h'.
	Define OFN_ENABLESIZING if not defined.
	(autostart_result) (get_filename_from_content): New variables.
	(ui_file_selector_style_type): New type.
	(styles): New array, contains file selector style definitions.
	(get_filename_from_disk) (get_filename_from_tape)
	(get_filename_from_disk_or_tape): New functions.
	(tape_hook_procedure): New function.
	(hook_proc): Changed font of Preview dialog. When creating new
	disk images, update current filter and select newly created
	image.
	Handle doubleclick from Preview box.
	Destroy font object, when dialog box closes.
	(ui_select_file): Parameters changed. New params 'style' can
	be used to customize the dialog box. 'autostart' selected
	filename will be sent back through this.
	Fixed title of dialog box.
	Handle styles.
	Added OFN_ENABLESIZING flag, dialog box can be resized under
	Win98, NT5/Win2000.

	* arch/win32/uilib.h (ui_cartridge_params): New struct for
	dialog box custom parameters when the dialog box is used to
	select a cartridge image.
	(ui_select_file): Updated prototype.
	(read_disk_image_contents) (read_tape_image_contents)
	(read_disk_or_tape_image_contents): Removed prototypes.
	Define dialog box styles.

	* arch/win32/uisnapshot.c (ui_snapshot_load_dialog): Updated
	ui_select_file call.

	* arch/win32/uivicii.c (dialog_palette_proc): Updated
	ui_select_file call.

	* arch/win32/vic20ui.c (vic20_ui_cartridges): Array of
	cartridge attach parameters.
	(vic20_ui_attach_cartridge): New function.
	(vic20_ui_specific): Call vic20_ui_attach_cartridge.

	* arch/win32/vice.dsw: Added 'monitor' project. Updated
	project dependencies.

	* arch/win32/x128.dsp, arch/win32/x64.dsp,
	arch/win32/xcbm2.dsp, arch/win32/xpet.dsp, arch/win32/xvic.dsp:
	Added 'monitor' to include search pathlist. Removed asn.c,
	mon.c, mon_lex.c, mon_parse.c.

2000-01-02  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/console.h: added pointer to console_private_t in 
	console_t, renamed console_shutdown() to console_close_all(),
	removed parameters from it.

	* arch/win32/console.c: removed MAX_CONSOLES, structures are now
	stored in linked lists. Removed castings between console_t and
	console_private_t, instead of using pointers; renamed TWindow
	to console_private_t; fixed memory-leakage on console_close_all().

	* arch/win32/video.c: in set_physical_colors(), the 2nd parameter
	to the call of IDirectDrawSurface_ReleaseDC() was wrong (pointer
	to the handle was given instead of the required handle). Fixed.
	(Any effects? Don't know, except for a compiler warning).

2000-01-01  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.15.

	* vic20/vic.c (init_raster): Fixed border shift.

	* arch/win32/console.c (allocate_window_memory): Use `memset'.
	(console_close_all): New name.  Commented out old code because
	it has to be rewritten.

	* mon.c, mon.h, mon_lex.l, mon_parse.y: Moved to own
	subdirectory.

	* monitor/Makefile.am: New file.

	* drive/Makefile.am, c64/Makefile.am, c128/Makefile.am,
	vic20/Makefile.am, pet/Makefile.am, cbm2/Makefile.am,
	Makefile.am, arch/os2/Makefile.am, arch/riscos/Makefile.am,
	arch/msdos/Makefile.am, arch/win32/Makefile.am: Added monitor
	to the include path.

	* maincpu.h, drive/drivecpu.h: Do not #include "mon.h".

	* c64/c64mem.c, pet/petmem.c: #include "mon.h".

	* vicii/vicii-mem.c, vicii/vicii-snapshot.c, c64/reu.c,
	arch/unix/x11/xaw/ui.c: #include "interrupt.h".

	* sid/sid.c: Define `TRUE' and `FALSE' if not already defined.

	* arch/win32/winmain.c (WinMain): Do not shut down the console
	here.

	* arch/win32/console.c (console_close_all): New name.

	* arch/msdos/console.c, arch/unix/console.c,
	arch/riscos/console.c, arch/os2/console.c (console_close_all):
	Stubs.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c,
	cbm2/c610.c (machine_shutdown): Close console on exit.

	* vic20/vic.c, vic20/vic-mem.c: Fixed debugging messages.

1999-12-31  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/console.c: 2 little modifications to avoid
	warnings.

1999-12-31  Mattias Engdegård  <f91-men@nada.kth.se>

	* arch/unix/x11/xaw/ui.c, arch/unix/x11/xaw/ui.h,
	arch/unix/x11/xaw/uimenu.c: Allow the use of another visual
	than the default when -displaydepth is used.

1999-12-31  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.14.

	* arch/unix/x11/xaw/uiedisk.c: New "G64" button.

	* vdrive/vdrive-command.c, vdrive/vdrive-command.h: Check for
	errors on disk access.

	* diskimage.h, diskimage.c, drive/drive.c, vdrive/vdrive.c,
	c1541.c, arch/win32/uilib.c, arch/msdos/uiattach.c: Changed
	name to `DISK_IMAGE_TYPE_G64'.

	* vdrive/vdrive.c (vdrive_internal_close_disk_image,
	vdrive_internal_create_format_disk_image,
	vdrive_internal_format_disk_image): Check for errors.

	* arch/msdos/c64ui.c: New "set cartridge as default" as menu
	entry.

	* arch/msdos/menudefs.c, arch/msdos/c64ui.c,
	arch/msdos/c128ui.c,  arch/msdos/vic20ui.c,
	arch/msdos/petui.c,  arch/msdos/c610ui.c: Separated video
	cache, palette and double scan settings.

	* arch/msdos/tuifs.c (file_list_sort_func): Use `strcasecmp'
	instead of `strcmp'.
	(file_list_read_lfn, file_list_read_nolfn): Use `FNM_NOCASE'
	as flag for `fnmatch'.

	* arch/msdos/menudefs.c: Use `o' as shortcut for ROM settings.
	Fixed datasette RECORD description.

	* main.c, console.h, arch/unix/console.c, arch/os2/console.c,
	arch/riscos/console.c, arch/win32/console.c,
	arch/msdos/console.c (console_init): New function.

1999-12-29  Andreas Matthies  <andreas.matthies@arcormail.de>

	* arch/win32/arch.dsp,arch/win32/xvic.dsp: updated project-files
	and include-paths

	* arch/win32/res.h: new IDs IDC_BLANK_IMAGE_NAME and ~ID

	* arch/win32/res.rc: improved "create new image" dialog; changed
	dialog font back to MS Sans Serif

	* arch/win32/ulib.c (hook_proc): handles new dialog controls to
	format new image with specified name and ID; preview listbox gets
	new font with fixed width

1999-12-29  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.13.

	* mon.c (mon_save_file): Do not close file when if start or
	end address is invalid.

	* zfile.c (zfopen): Also check `+' as write mode flag.

	* arch/win32/console.c (redraw_window): Use `LPPAINTSTRUCT'.

	* arch/win32/uiattach.c (init_dialog): Initialize printer
	dialog.

	* vdc/vdc-mem.c (vdc_perform_fillcopy): Copy 256 bytes if
	length is zero.

	* arch/os2/icons/Makefile.am: Fixed makefile.

1999-12-29  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* main.c: goto statement removed, archdep_startup_log_error
	calls made OS/2 conform

	* mon_lex.c: io.h included.

	* archdep.c: archdep_startup_log_error implemented

	* arch/os2/install.cmd added

	* arch/os2/console.c: function bodies implemented

	* arch/os2/dialogs/[all].c: minor changes

	* arch/os2/ui.c: minor changes

1999-12-28  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/console.c: added some minor changes for achieving
	ANSI C-conformity.

	* arch/win32/console.c: cursor-left and -right, DEL, HOME, END
	now work; INS toggles insert-mode. Cursor does not overwrite
	the current character and show if insert-mode or not. History
        function added (cursor-up and -down)

1999-12-28  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/print.c: included header file "string.h" to avoid
	warning about non-defined strcmp.

	* vic/vic20sound.c: included header file "string.h" to avoid
	warning about non-defined memset()

1999-12-28  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* corrections of project files for VC++:
	added console.c in project arch, added pruser.c, prdevice.c
	in project xvic.
	(2nd, corrected version)

1999-12-27  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/console.c: little fix that makes console compile
	on RISC OS again.

1999-12-26  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/res.rc, arch/win32/rescbm2.rc,
	arch/win32/resc128.rc, arch/win32/resc64.rc,
	arch/win32/respet.rc, arch/win32/resvic.rc,
	arch/win32/uidatasette.c, arch/win32/uijoystick.c,
	arch/win32/uisound.c, arch/win32/uivicset.c:
	accelerators modified or added for menus, dialog boxes, etc.;
	removed inconsistencies between different emulators;
	datasette, joystick and sound dialog boxes now can be quitted
	with ESCAPE.

1999-12-26  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* mon.c: don't close console when 'n' or 'z' command with
	parameter 1 or w/o parameter, but close it in every other
	event

	* mon_parse.y: mon_console_close_on_leaving = 1 when CMD_EXIT
	or CMD_QUIT removed

1999-12-26  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/console.c: rewritten, now the console uses an own
	window

	* arch/win32/console.h: added console_shutdown() to be called
	immediately before VICE ends (for cleanup)
	added comment that console_xres and console_yres might change
	at run-time.

	* arch/win32/ui.h: added CONSOLE_CLASS

	* arch/win32/winmain.c: call console_shutdown() before quitting

	* mon.c: console_log is initialized with NULL
	(this is necessary for console_shutdown() not crashing!)

1999-12-26  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.12.

	* vdrive/vdrive-command.c (vdrive_command_format): Changed the
	calling interface.

	* vdrive/vdrive.c: Created functions to open, close and format
	disk images for internal use.

	* imagecontents.c, arch/unix/x11/xaw/uiedisk.c:
	Use internal disk functions.

	* arch/unix/uicommands.c (attach_empty_disk): Do not use
	uninitialized memory.

	* vdrive/vdrive-bam.c (vdrive_bam_create_empty_bam): Do not
	expect a ":" as start of disk name.

	* vdrive/vdrive-command.c (vdrive_command_execute): Replaced
	completely bogus command line parsing by something that does
	not currupt memory.

	* arch/win32/uilib.c (hook_proc): Use new internal function to
	create and format disks.

	* arch/msdos/console.c: Fixed includes.

	* c1541.c (floppy_read_directory): Use `size_t'.

	* c128/c128mmu.c, vdc/vdc.c, vdc/vdc.h: Corrected name of
	`vdc_set_canvas_refresh'.

	* crtc/crtc-draw.c: Do not compile `draw_standard_line_2x'
	and `draw_reverse_line_2x' if `CRTC_NEED_2X' is not defined.

	* datasette.h: Do not redefine `PI' if it is already defined.

	* arch/unix/x11/xaw/Makefile.am, arch/win32/Makefile.am,
	arch/msdos/Makefile.am: Added `vdrive' to the include dir.

	* arch/msdos/uiattach.c, arch/msdos/uiattach.h: New files.

	* arch/msdos/menudefs.c: Attach disk menu entries moved to
	`uiattach.c'.

1999-12-26  Andreas Matthies  <andreas.matthies@arcormail.de>

	* datasette.c (datasette_read_bit): fixed bug in counter that
	appears when changing the direction during a long gap
	fixed text of +dsresetwithcounter cmdline

1999-12-25  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.11.

	* arch/win32/ui.c, arch/win32/res.h, arch/win32/resc64.rc,
	arch/win32/resc128.rc, arch/win32/resvic.rc,
	arch/win32/respet.rc, arch/win32/rescbm2.rc: List
	contributors, license, no warranty and command line options.

	* cmdline.c, cmdline.h (cmdline_options_string): New function.
	Use startup logging to report errors.

	* arch/win32/uicmdline.c, arch/win32/uicmdline.h
	(ui_cmdline_show_options): New function.

	* drive/drive-cmdline-options.c: Fixed typo.

	* drive/drive-resources.c: Do not initialize drive memory if
	drive is disabled.

1999-12-25  Manfred Spraul  <manfreds@colorfullife.com>

	* arch/win32/uilib.c, arch/win32/uilib.h (ui_show_text): New
	function.

	* arch/win32/res.rc, arch/win32/res.h : Text lister resources.

1999-12-24  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.10.

	* mon.c, mon.h: The console handle is a pointer now.

	* arch/unix/console.c, arch/msdos/console.c,
	arch/win32/console.c, arch/riscos/console.c,
	arch/os2/console.c: Report console size and attributes on
	`console_open'.

	* main.c: Use `archdep_startup_log_error' instead of fprintf.

	* arch/unix/archdep.c, arch/msdos/archdep.c,
	arch/win32/archdep.c,, arch/riscos/archdep.c,
	arch/os2/archdep.c (archdep_startup_log_error): New function.

	* arch/win32/ui.c (ui_error_string): New function.

1999-12-23  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* mon.c, mon_parse.y, mon.h: Don't close monitor window
	except when exiting.

1999-12-23  Spiro Trikaliotis  <Spiro.Trikaliotis@gmx.de>

	* arch/win32/ui.c, arch/win32/resc64.rc, arch/win32/resc128.rc,
	arch/win32/rescbm2.rc, arch/win32/respet.rc
	arch/win32/resvic.rc: Changed accelerators: freeze from Alt+F
	to Alt+Z, menu 'snapshot', and menu 'settings' (collision-
	avoidance between accelerators); changed menu key for 'REU
	emulation' from R to U (R conflictes with 'refresh rate'),
	changed menu key for 'Enable resid' from R to E in
	arch/win32/resc128.rc (R conflictes with 'refresh rate'; now
	it's consistent with arch/win32/resc64.rc and
	arch/win32/rescbm2.rc)

1999-12-22  Daniel Sladic  <dsladic@cs.cmu.edu>

	* mon_lex.l: Remove need for spaces after abbreviated commands.

	* mon.h: Added extra parameter in mon_cmd_lookup_index prototype.

	* mon.c (mon_cmd_array): Duplicated single letter commands in
	abbreviation field.
	(mon_cmd_lookup_index): Allow matching of abbreviated command names
	against the head of the input. The new parameter push_back returns
	the number of characters matched.
	(mon_print_help): Updated call to mon_cmd_lookup_index to new
	prototype.
	(mon_display_memory): Don't print newlines and other control chars.

1999-12-21  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/gnome/gnomevideo.c: Added `#include "log.h"'.

	* arch/unix/x11/gnome/ui.c:
	(ui_create_status_bar): Changed popup widget for fliplist from
	`button' to `event box'.
	(ui_display_drive_current_image): Removed update of fliplist menu.
	(fliplist_popup_cb): update proper fliplist menu.
	(ui_enable_drive_status): Reworked a to hide inaccessible disks
	drives.

	* arch/unix/uicommands.c (ui_update_flip_menus): Added a `Detach'
	menu entry.

1999-12-19  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/x11/xaw/ui.c (ui_set_topmenu): New (dummy) function.

	* arch/unix/x11/gnome/ui.c: 
	(ui_create_status_bar): Implemented a neat status bar.
	(ui_set_topmenu): New function, tie popup menu to a toplevel
	menu. 
	Implemented fliplist popup support.
	Removed drive_mapping code. Let GTK take care about widget
	mapping.
	Added (but deactivated) menu-code for the gnome-API (struct
	GnomeUIInfo based menu). To activat it add `-DGNOME_MENUS' to
	CFLAGS. But this won't work, well (Checkmark support is broken).
	Reworked resize and exposure code. Still not perfekt, but the
	constants (+-30) have been removed.

	* arch/unix/x11/gnome/uimenu.c: ALL: Added gnome-API menus
	(disabled, see above). 

	* arch/unix/x11/gnome/ui.h: Added gnome-API menus (disabled, see
	above). 

	* arch/unix/x11/gnome/dummies.c: Removed a few implemented
	functions.

	* arch/unix/uisettings.c: Removed erroneous `*' from
	sound_settings_submenu. Those items aren't checkmarks.

	* arch/unix/c128ui.c (c128_ui_init): Added call to
	`ui_set_topmenu()'.
	* arch/unix/c610ui.c (c610_ui_init): ditto.
	* arch/unix/vic20ui.c (vic20_ui_init): ditto.
	* arch/unix/petui.c (pet_ui_init): ditto.
	* arch/unix/c64ui.c (c64_ui_init): ditto.

1999-12-19  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.9.

	* arch/msdos/menudefs.c (create_special_submenu): Corrected
	virtual devices menu entry.

	* arch/win32/ui.c, arch/win32/res.h, arch/win32/resc64.rc,
	arch/win32/resc128.rc, arch/win32/resvic.rc,
	arch/win32/respet.rc, arch/win32/rescbm2.rc: Virtual devices
	menu entry.

	* drive/drive.h, arch/win32/res.rc, arch/win32/uidrive.c:
	Added drive expansion UI.

	* arch/win32/uiattach.c, arch/win32/res.h, arch/win32/res.rc:
	New printer dialog.

1999-12-19  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* arch/os2/dialogs/dlg-contents.c,
	arch/os2/dialogs/dlg-datasette.c,
	arch/os2/dialogs/dlg-drive.c, arch/os2/dialogs/dlg-emulator.c,
	arch/os2/dialogs/dlg-joystick.c,
	arch/os2/dialogs/dlg-monitor.c, arch/os2/dialogs/dlg-sound.c:
	added

	* dialogs.[ch]: moved dialogs to arch/os2/dialogs

	* dialogs.rc extended drive-dialog

	* fliplist.c removed goto statement

1999-12-18  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.8.

	* c64/cartridge.c: Delay memory mapping change by 3 cycles.

	* c64/c64.c (machine_init): Initialize cartridge emulation.

	* arch/unix/x11/xaw/about.c: #include "vsync.h".

	* arch/win32/console.c: Applied file open fix.

	* mon.c (mon): Use `console_in' instead of `readline'.

	* arch/unix/console.c, arch/win32/console.c,
	arch/msdos/console.c, arch/riscos/console.c,
	arch/os2/console.c: Use the old code for `console_in'.

	* arch/os2/Makefile.am: Added `petui.c' and `petui.h'.

1999-12-16  Nathan Huizinga  <nathan.huizinga@chess.nl>

	* arch/unix/c64ui.c: Menu entry added for Super Snapshot V5.

	* c64/c64cartmem.c: Support added for Super Snapshot V5.

	* c64/cartridge.c: Command line option: "-cartss5" added for
	Super Snapshot V5.  Small text change for ss4 from "64KB" to
	"32KB". It's a 32KB image...

	* cartridge.h: define CARTRIDGE_SUPER_SNAPSHOT_V5 added.

1999-12-15  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* arch/os2/archdep.c: minor changes, added workaround for
	p00_check_name

	* arch/os2/config.h: defined NAME_NEED_QM

	* arch/os2/dialogs.[hcrc]: added toggle, pause, sprite
	collision

	* arch/os2/kbd.c: minor changes

	* arch/os2/petui.[ch] added

	* arch/os2/ui.h: minor changes

	* arch/os2/vac++/Xpet.icc added

	* arch/os2/vac++/*.icc: made compile again.

	* arch/os2/vsync.c: added pause feature

	* autostart.c: workaround for p00_check_name (I hope to fix
	this in the future)

	* c128/z80mem.c: included string.h

	* pet/petsound.c: included string.h

	* sounddrv/sounddart.c: extended semaphore handling

	* utils.c: added return ti x[mc]alloc in case of size=0

	* zfile.c: added macro for OS which needs quotationmarks around

1999-12-15  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/{print,rs232}.c: fixed bug in resource setting
	function.

1999-12-14  Andreas Matthies  <andreas.matthies@arcormail.de>

	* configure.in: define HAVE_PRINTER for DOS,Win32 (next try)

	* win32/msvc/config.h: define HAVE_PRINTER

	* win32/print.c,msdos/print.c (set_printer_file): bugfix
	(print_putc): adds LF after CR

	* win32/archdep.c (archdep_open_monitor_console): title for
	console window; (archdep_close_monitor_console): closes
	mon-related files which should fix the 'iterated z' problem

	* win32/vdrive.dsp: add vdrive-snapshot.c to project files

	* win32/xpet.dsp,xcbm2.dsp,x64.dps,x128.dsp,xvic.dsp: add
	pruser.c and prdevice.c to project files

1999-12-14  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.7.

	* vdc/vdc-mem.c (vdc_store): Clear copy flag whenever the
	cursor is set.  The text blink frequency is adjustable now.

	* mon.c, mon.h, mon_parse.y: Use new console code.

	* arch/unix/archdep.c, arch/msdos/archdep.c,
	arch/win32/archdep.c, arch/riscos/archdep.c, archapi.h,
	arch/os2/archdep.c: Moved console code to `console.c'.

	* arch/unix/console.c, arch/msdos/console.c,
	arch/win32/console.c, arch/riscos/console.c,
	arch/os2/console.c, console.h: New files.

	* log.c (log_helper): Use default log if no logfile available.

	* main.c (MAIN_PROGRAM): Continue even if there is no logging
	system.

	* attach.c, arch/win32/uiattach.c, arch/msdos/menudefs.c,
	attach.h, vdrive/vdrive-iec.c, vdrive/vdrive-iec.h, serial.c,
	serial.h, fsdevice.c, fsdevice.h, fliplist.c, fliplist.h,
	c1541.c, uiapi.h, arch/unix/x11/xaw/ui.c, arch/msdos/ui.c,
	arch/win32/ui.c, arch/riscos/ui.c, arch/os2/ui.c,
	vdrive/vdrive-dir.h, vdrive/vdrive-dir.c,
	drive/vdrive-command.c: Use unsigned track and drive numbers.

1999-12-14  Daniel Sladic  <dsladic@cs.cmu.edu>

	* mon_parse.y: Added "until" command and added parameter to
	mon_add_checkpoint() calls.

	* mon.h: Changed mon_add_checkpoint prototype. Added a flag
	to the checkpoint structure to mark temporary ones.

	* mon.c (mon_cmd_array, print_checkpoint_info,
	mon_check_checkpoint, mon_add_checkpoint):
	Added "until" command support.
	(mon_symbol_table_lookup_addr, mon_add_name_to_symbol_table):
	Added support for using .PC as an address value.
	(mon_check_checkpoint): Open console to be able to perform
	output when a checkpoint is hit.

1999-12-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.6.

	* mon.c (mon_check_icount, mon): Disassemble instructions on
	monitor startup in single step mode.  Fixed usage of
	uninitialized file pointers.

	* vdc/vdc.c, vdc/vdc-draw.c, raster/raster-cache.h,
	vdc/vdctypes.h: Implemented reverse and flashing text
	attribute.

	* arch/unix/x11/video.c, arch/unix/x11/videoarch.h,
	arch/msdos/video.c, arch/msdos/videoarch.h,
	arch/riscos/video.c, arch/riscos/videoarch.h: Removed cruft.

	* arch/unix/x11/videoarch.h, arch/unix/x11/gnome/videoarch.h,
	arch/unix/x11/xaw/videoarch.h, arch/unix/x11/video.c,
	arch/unix/x11/xaw/x11video.c,
	arch/unix/x11/gnome/gnomevideo.c: Do not use global logging.

	* sound.c: Removed `warn' stuff.

	* arch/win32/uilib.c: #include <string.h>.

	* arch/unix/Makefile.am: Added `vsid' to `EXTRA_DIST'.

1999-12-11  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* fixpoint.h: removed OS/2 stuff again (sorry, meanwhile I
	found one not working sound-demo)

	* sounddrv/sounddart.c: added 'dart2' und mute functions.

1999-12-09  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.5.

	* vdrive/vdrive-snapshot.c: #include "attach.h".

1999-12-07  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/ui.c: added missing includes

1999-12-06  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/unix/uicommands.c: Sun compiler needs cast after add.

	* sounddrv/soundsun.c: removed final warn_t residual.

1999-12-06  Dag Lem  <resid@nimrod.no>

	* arch/unix/Makefile.am: Install vsid script.

	* arch/unix/vsid: New file; shell script to start x64 in vsid
	mode.

1999-12-05  Andreas Matthies  <andreas.matthies@arcormail.de>

	* win32/snapshot.c: removed old snapshot-saver

	* win32/res.h: new IDs for "Create Image" button and combobox

	* win32/res.rc: added these items to attach-dialog

	* win32/uilib.c: includes diskimage.h, message handler for
	"Create Image" button

1999-12-05  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.4.

	* vicii/vicii-snapshot.c (vic_ii_snapshot_read_module): Update
	`vic_ii.sprite_fetch_msk' too.

	* drive/drivecpu.c (JUMP): Fixed start of ROM.

	* vicii/viciitypes, vdc/vdctypes.h, crtc/crtctypes: New files.

	* vicii/vicii-cmdline-options.c, vicii/vicii-draw.c,
	vicii/vicii-mem.c, vicii/vicii-resources.c,
	vicii/vicii-resources.h, vicii/vicii-snapshot.c,
	vicii/vicii-sprites.c: #include "viciitypes.h".

	* c64/c64.c, c64/c64cia1.c, c64/c64cia2.c, c128/c128cia1.c,
	c128/c128.c: Fixed pending alarm call.

	* vdc/vdc-draw.c, vdc/vdc-mem.c, vdc/vdc-resources.c,
	vdc/vdc-snapshot.c, vdc/vdc.c: #include "vdctypes.h".

	* crtc/crtc.c, crtc/crtc-draw.c, crtc/crtc-mem.c,
	crtc/crtc-resources.c, 

	* c64/Makefile.am, c128/Makefile.am, pet/Makefile.am,
	cbm2/Makefile.am: Removed `raster' from include directory.

	* c128/c128mem.c: #include "log.h".

	* pet/petmem.c: #include <string.h>.

	* vdrive/Makefile.am: Removed `drive' from include directory.

	* interrupt.c, interrupt.h, drive/cia1571d.c, drive/riot2d.c,
	drive/cia1581d.c, drive/via1d.c, viacore.c, drive/via2d.c,
	vicii/vicii-snapshot.c, c64/c64cia1.c, c64/c64cia2.c,
	c64/reu.c, c128/c128cia1.c, pet/petpia1.c, pet/petpia2.c,
	cbm2/c610tpi1.c, drive/drivecpu.c, c128/c128cpu.c, c128/z80.c,
	drive/drive.c, maincpu.c: External function are called
	`interrupt_*' now.

	* vdrive/vdrive.h: Do not #include "attach.h".

	* drive/drive-snapshot.c, fsdevice.c, serial.c: #include
	"attach.h".

	* vdrive/vdrive-snapshot.c, vdrive/vdrive-snapshot.h: New
	files.

	* vdrive/vdrive.c (vdrive_init): Initialize snapshot module.

	* arch/unix/uicommands.c (ui_update_flip_menus): Removed
	debugging message.

1999-12-03  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.3.

	* raster/raster.c (update_sprite_collisions): Fixed pointer to
	fake frame buffer.

	* drive/drivemem.c, drive/drivemem.h: New files.
	(drive_mem_init): Implemented drive RAM expansion.

	* drive/drivecpu.c: Moved memory access functions to
	`drivemem.c'.
	(JUMP): Use `rom_start' for bank base calculation.

	* drive/drive-resources.c: Initialize drive memory if drive
	RAM expansion is switched on/off.

	* drive/drive.h: New variable `rom_start'.

	* arch/unix/uisettings.c: Added drive RAM expansion UI.

	* 6510core.c, maincpu.c, drive/drivecpu.c: Renamed `reset' to
	`cpu_reset'.

	* warn.c, warn.h: Removed.

	* sound.h, sounddrv/soundacorn.c, sounddrv/soundaix.c,
	sounddrv/soundallegro.c, sounddrv/sounddart.c, sid/sid.c,
	sounddrv/sounddummy.c, sounddrv/sounddump.c, sid/resid.cc,
	sounddrv/sounddx.c, sounddrv/soundfs.c, sounddrv/soundhpux.c,
	sounddrv/soundmidas.c, sounddrv/soundmmos2.c, sound.c,
	sounddrv/soundsb.c, sounddrv/soundsdl.c, sounddrv/soundsgi.c,
	sounddrv/soundspeed.c, sounddrv/soundsun.c, pet/petsound.c,
	sounddrv/sounduss.c, sounddrv/soundwav.c, vic20/vic20sound.c,
	Removed old warning cruft. Replaced by logging system.

1999-12-02  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/c64ui.c: removed stub functions now defined in
	vsidui.c

1999-11-29  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.2.

	* drive/drive-cmdline-options.h,
	drive/drive-cmdline-options.c: New files.

	* drive/drive.h: New pointer to drive RAM expansion.

	* drive/drive.c: New command line option for RAM expansion.

	* drive/drive-resources.c: New resources for RAM expansion.

	* drive/drivecpu.c: Added RAM expansion access functions.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c,
	cbm2/c610.c: #include "drive-cmdline-options.h".

	* arch/unix/x11/xaw/vsidui.c,arch/win32/vsidui.c,
	arch/msdos/vsidui.c, arch/riscos/vsidui.c, arch/os2/vsidui.c
	(vsid_set_tune): New function.

	* arch/unix/x11/xaw/ui.h (ui_proc_write_msg): Removed.

	* arch/win32/vsidui.c, arch/msdos/vsidui.c,
	arch/riscos/vsidui.c, arch/os2/vsidui.c

	* c64/psid.c: #include "vsidui.h".

1999-11-29  Andreas Matthies  <andreas.matthies@arcormail.de>

	* win32/x64.dsp,x128.dsp,xpet.dsp,xcbm2.dsp,xvic.dsp: added
	/i "..\..\" for resource-compiler

	* win32/res.rc: includes "config.h" again for MSVC_RC-definition
	disabled old save_snapshot-dialog and added new one as a 
	template for GetSaveFile

	* win32/uisnapshot.c: includes "utils.h"
	new functions (hook_save_snapshot),(ui_save_snapshot) to
	implement a windows-like snapshot-saver
	(ui_snapshot_save_dialog): uses new functions instead of old
	dialog

1999-11-27  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.1.

	* zfile.c (try_uncompress_archive): Fixed `free' calls.

	* arch/os2/Makefile.am: Removed commend within file list.

	* version.h.in: New file.

	* Makefile.am: Added `version.h.in' and `version.h'.

	* arch/unix/x11/gnome/ui.c, arch/unix/x11/gnome/about.c,
	arch/unix/x11/xaw/about.c, arch/win32/ui.c, main.c,
	arch/msdos/menudefs.c, arch/msdos/tui_backend.c,
	arch/msdos/ui.c, arch/win32/res.rc: #include "version.h".

	* arch/win32/msvc/config.h, arch/riscos/config.h: Removed
	PACKAGE and VERSION defines.

	* arch/os2/version.h: Removed.

	* arch/os2/Makefile.am: Removed `version.h'.

	* arch/unix/ui.h: New file.

	* arch/unix/Makefile.am: Added `ui.h' and `uimenu.h'.

	* arch/unix/c128ui.c, arch/unix/c610ui.c, arch/unix/c64ui.c,
	arch/unix/petui.c, arch/unix/vic20ui.c: Changed XPM includes.

	* arch/unix/x11/xaw/Makefile.am: Removed `uiedisk.h' and
	`uisnapshot.h'

1999-11-27  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* some changes of output to log-file in os2/*

	* os2/config.h: version definition --> version.h

	* os2/dialogs.rc: included version.h

	* os2/dialogs.c: prevent dialogs from opening when already
	open

	* os2/joystick.c: prevent joysticks from 'hanging' when
	switched off

	* os2/rs232.c added

	* os2/version.h added

	* os2/vsync.c: better system response in case of 100%CPU usage

	* c128iec.c: string.h included

	* c1541.c: changed order of string.h and memory.h include
	statements, included io.h, added definition for 'clk'

	* main.c: included version.h in case of OS2

1999-11-27  Dag Lem  <resid@nimrod.no>

	* arch/unix/x11/xaw/ui.c: Removed vsid debug output.
 
	* arch/unix/x11/xaw/uimenu.c: num_checkmark_menu_items made global
	to allow menu recreation.
 	
	* arch/unix/x11/xaw/vsidui.c: Tune selection menu created
	dynamically.
 
	* c64/c64.c (machine_init_resources): Initialize vsid specific
	resources. (machine_play_psid): psid_play_tune renamed to
	psid_set_tune.
 
	* c64/psid.c: New resource PSIDTune so specify tune number.
	(psid_init_tune): Choose PAL or NTSC.
 	
1999-11-25  Martin Pottendorfer <Martin.Pottendorfer@alcatel.at>

	* info.c: Updated my contribution to the project.

	* autostart.c (autostart_prg): Added `#ifdef HAVE_ERRNO_H'.

	* arch/unix/ui*.c
	Changed all instances of `call_data' to `CHECK_MENUS' and
	`client_data' to `UI_MENU_CB_PARAM' which are defined by the
	specific ui.

	* arch/unix/x11/gnome:
	Many Fixes.

	* arch/unix/x11/xaw, arch/unix:
	Moved generic ui-implementations into archdir.

1999-11-23  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.2.

	* arch/unix/x11/video.c: Provide prototype for `video_get_gc'
	and `video_add_handlers'.

	* arch/os2/Makefile.am, arch/os2/kbd/Makefile.am,
	arch/os2/vac++/Makefile.am: Fixed Makefiles.

	* arch/win32/msvc/config.h, arch/os2/config.h: Updated
	version.

	* arch/win32/print.c, arch/msdos/print.c:
	#include "cmdline.h".

1999-11-23  Andre Fachat  <a.fachat@physik.tu-chemnitz.de>

	* configure.in: define HAVE_PRINTER for msdos and windows

	* vice.texi: fix some documentation bugs:
	Add .d71, .d80, .d81, .d82 disk types to Supported file types
	Add IEEE488 cartridge to C64 cartridges; remove IEEE488 from
	I/O extension description
	Add bankname description (in terminology section) and bank,
	device and sidefx descriptions to monitor docs
	remove "create" from c1541 docs
	Add filetypes to "format" section in c1541 docs

	* arch/msdos/Makefile.am: add print.c

	* arch/msdos/print.c: new file - basically copied file from 
	RiscOS, which is C standard code. Only renamed "parallel:" to
	"LPT:"

	* arch/win32/print.c: file the same as for msdos

	* arch/win32/ui.c: add .d80 and .d82 files to list of filename 
	extensions

	* c1541.c: fix format help description

	* mon.c: fix "device" help description

1999-11-23  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* arch/os2/config.h type declarations -> arch/os2/types.h

	* added: arch/os2/kbd/kbd-c128.c, arch/os2/kbd/kbd-pet.c,
	arch/os2/kbd/kbd-c64.c

	* arch/os2/c64kbd.c deleted

	* added makefiles (*.icc) for Visual Age C++ 4.0 in
	arch/os2/vac++

	* added arch/os2/c128ui.c (dummy)

	* added arch/os2/rs232.c  (dummy)

	* arch/os2/kbd.c: added restore-key support


1999-11-22  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.33.

	* c64/c64mem.c, c128/c128mem.c (mem_get_screen_parameter):
	Fixed base address.

	* c128/z80.c: Renamed `reg_pc' to `z80_reg_pc'.

	* c128/c128mmu.c: Commented out debugging output.

	* mon.c (mon_display_screen): Specifiy type for `r' and `c'.

1999-11-22  Andre Fachat  <a.fachat@physik.tu-chemnitz.de>

	* parallel.c (ignoreown): new define to not print warning
	when unexpected change is initiated by virtual IEEE488 itself
	(Out1_nrfdhi): set IEEE488 bus value

1999-11-21  Daniel Sladic  <dsladic@cs.cmu.edu>

	* mon.c (mon_display_screen): New function.
	Also added support for "screen" command.

	* mon.y: Added mon_display_screen prototype.

	* mon_parse.y: Support for "screen" command.

1999-11-21  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.32.

	* c128/z80.c (DO_INTERRUPT): Implemented reset.

	* c128/c128.c (machine_reset): Initialize Z80 memory.

	* maincpu.c, maincpu.h (maincpu_reset): New function.

	* vdc/vdc-mem.c: Commented out debugging output.

	* vicii/vicii.h: Fixed NTSC constants.

	* Makefile.am: Removed `convio'.

	* zfile.c: Use own log instead of `LOG_DEFAULT'.

1999-11-20  Andreas Matthies  <andreas.matthies@arcormail.de>

	* win32/Makefile.am: new files uivicset.h,uivicset.c

	* win32/arch.dsp: new file uivicset.c

	* win32/res.h: new IDs ID._VIC_* for VIC-settings

	* win32/resvic.rc: added menu-entry for VIC-settings,
	added dialog resource for VIC-settings

	* win32/uivicset.c,uivicset.h: new files implementing the
	VIC settings i.e. memory-expansion

	* win32/vic20ui.c(vic20_ui_specific): added menu-handler
	for the VIC settings

1999-11-18  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/ui.c: added widgets for VDC double size and VDC
	double scan.

1999-11-18  Andreas Boose  <boose@linux.rz.fh-hannover.de>

        * Version 1.1.31.

	* c64/c64.h, c128/c128.h: Corrected NTSC constants.

	* arch/unix/vsync.c (vsync_set_machine_parameter): Call
	`set_timer_speed'.

	* arch/win32/res.h, arch/win32/resc128.rc,
	arch/win32/c128ui.c: Added menu entries of VDC 64KB memory,
	VDC double size and VDC double scan.

	* vicii/vicii.c (vic_ii_raster_draw_alarm_handler): Do not
	hardcode the start of display DMA.
	(vic_ii_reset): Also reset display y counter.

	* vicii/vicii.c, vicii/vicii.h, vicii-mem.c: Added some more
	coonstants for NTSC mode.

1999-11-18  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>
 
	* arch/unix/x11/xaw/x11kbd.c, arch/unix/x11/xaw/x11video.c:
	New files. Implementation of Xaw specific video code.
 
	* arch/unix/x11/xaw/Makefile.am: Removed `video.c', Added
	`x11video.c', `x11kbd.c'.
 
	* arch/unix/x11/videoarch.h: Moved from xaw/videoarch.h.
 
	* arch/unix/x11/video.c: Moved from xaw/video.c again.
	Replaced xaw specifics with `video_XXX()' functions which are
	resolved by the specific ui.
 	
	* arch/unix/x11/kbd.c, arch/unix/x11/kbdef.h:
	Changed a few static variables to globals. This are used by the
	uidepended `kbd_event_handler'. The extern declaration of those
	variables has been introduced to `kbdef.h'.
 	
	* arch/unix/x11/gnome/dummies.c: Updated dummy function list.

	* arch/unix/x11/gnome/*
	dummies.h, gnomekbd.c, gnomevideo.c:
	New files.
 
	* arch/unix/x11/gnome/*: 
	Makfile.am, checkmark.xbm, right_arrow.xbm, ui.c, ui.h,
	uihotkey.c, uihotkey.h, uimenu.c, uimenu.h, uisettings.c,
	uisettings.h
	Imported files from O. Schaertel's GTK+port.
 
	* arch/unix/videoarch.h: Fixed to use `USE_GNOMEUI'.
 
1999-11-18  Andreas Matthies <andreas.matthies@arcormail.de>
 
	* datasette.c: changed casts in (datasette_update_ui_counter)
	and (datasette_reset_counter) to start the counter at 000 
	even with gcc

1999-11-17  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.30.

	* sound.h: Added missing `extern'.

	* sound.c: Define `sound_state_changed' here.

	* vdc/vdc.c, vdc/vdc.h, vdc/vdc-draw.c,
	vdc/vdc-cmdline-options.c, vdc/vdc-resources.c: Implemented
	double size mode.  Removed `VDC_NEED_2X'.
	(vdc_set_geometry, vdc_resize): New functions.
	(vdc_raster_draw_alarm_handler, init_raster, vdc_init):
	Changed to support single and double size mode.

1999-11-17  Andreas Matthies  <andreas.matthies@arcormail.de>

	* win32/drive.dsp: updated filelist with last changes again

	* win32/video.c,win32/uivicii.c: implemented change of palette

1999-11-17  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* drivetypes.h, drivecpu.c: encapsulated the large data of the
	drive CPU in a new context struct drivecpud_context_t and
	moved that to the end of the drive context structure in order
	to minimize the average offset of context variables.

1999-11-16  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* os2/config.h, ui_status.c, video.c, vsync.c: minor changes

	* os2/contentsdlg.[ch], dialogs.[ch,rc]: added

	* os2/joystick.c: ability to use joystick twice added

	* os2/kbd.c: uses keyboard.[hc] now, added dialogs, made one
	function for attaching images out of two, added
	suspend_speed_eval to resets

	* os2/main_exit.c: added sound support

	* sounddrv/sounddart.c: made multithread safe, added
	get_/set_volume

	* os2/ui.c: changed default file dialog

	* sid.c, sound.c: changed handling of changing parameters to
	be multithreadsafe on OS/2

1999-11-16  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.29.

	* c128/z80.c: Added LD (BC) A, LD (DE) A, EXAFAF, HALT,
	AND (HL), XOR (HL), XOR #, EXX, OUT A, IN A opcodes.

	* vdc/vdc-draw.c, vdc/vdc.c: Replaced `% 2' by `& 1'.
	Only skip odd lines if double scan is off.

	* arch/unix/x11/xaw/c128ui.c: Added menu entries for VDC
	double size and double scan.

	* fsdevice.c: Use `vdrive_t' instead of `void' pointer.

	* charsets.c: Removed silly $7E<->$FF conversion rule.
	Removed some old and unused cruft.

	* petcat.c: Moved conversion tables here.

	* c64/c64mem.c, c128/c128mem.c, vic20/vic20,
	vic20/vic-snapshot.c: Fixed includes.

1999-11-15  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.28.

	* arch/unix/Makefile.am: Removed PHONY readline target.

	* ciatimer.c: #include <stdio.h>.

	* arch/unix/x11/xaw/uimenu.c (_ui_menu_radio_helper): Added
	missing cast.

	* arch/unix/x11/xaw/uicommands.c: #include "log.h".

1999-11-15  Markus Brenner  <markus@brenner.de>

	* vdc/vdc.h: Changed several screen constants

	* vdc/vdc.c: Adjusted vdc_raster_draw_alarm_handler()

	* vdc/vdc-draw.c: Adjusted drawing functions

1999-11-15  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* ciacore.c, ciacore.h, riotcore.c, riotcore.h: support
	compilation with shared code using the same approach employed
	in viacore.c .

	* drive/cia1571drive0.c, drive/cia1571drive1.c: unified into
	drive/cia1571d.c. The same for cia1581drive*, riot1drive*
	and riot2drive*.

	* drive/drivetypes.h: new file defining the exact layout of
	the drive context structure. Keep local to the drive module.

	* drivecpu.h: export the drive's monitor interface and int
	status through pointers (drive#_monitor_interface_ptr,
	drive#_int_status_ptr) to avoid external modules having to
	know the drive context layout (I don't think these are
	extremely time critical).

	* drive/{remaining files}: adapted for shared code changes.

	* emulated machines' main files (c64/c64.c, c128/c128.c,
	cbm2/cbm2.c, pet/pet.c, vic20/vic20.c): Use the pointers
	exported in drivecpu.h.

	* interrupt.h: Use pointers exported in drivecpu.h

1999-11-14  Andreas Matthies  <andreas.matthies@arcormail.de>

	* win32/drive.dsp: updated filelist with last changes

	* win32/arch.dsp: added vsidui.c to filelist
 
	* datasette.c: (datasette_update_ui_counter) and 
	(datasette_reset_counter) now check for attached image

1999-11-14  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.27.

	* vdrive/vdrive.c (vdrive_parse_name): Parse mode parameter.

	* fsdevice.c, fsdevice.h (fs_error): Made static and made
	memory read aware.
	(flush_fs): Implemented block read command.

	* vdrive/vdrive-command.c (vdrive_command_memory_read): New
	function.

	* vdrive/vdrive-iec.c (vdrive_open): Override mode if
	secondary is 0 or 1.
	* fsdevice.c (open_fs): Changed likewise.

	* vdrive/vdrive-command.c, vdrive/vdrive-command.h: New files.

	* vdrive/vdrive-iec.c (vdrive_flush): Do not set error code
	after executing the command interpreter.

	* drive/drive.c, drive/drive.h: Made drive firmware external.

	* c1541.c, prdevice.c: #include "log.h".

	* c1541.c, mon.h: #include "vdrive-command.h".

1999-11-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.26.

	* Makefile.am: Link PET and CBM2 libraries before linking with
	the drive library.

	* pet/petiec.c, cbm2/c610iec.c, pet/pet.c, cbm2/c610.c,
	iecdrive.h (iec_init): Added missing function.

	* drive/drive-snapshot.c, drive/drive-snapshot.h,
	drive/drive-resources.c, drive/drive-resources.h: New files.

	* drive/drive.c, drive/drive.h: Moved out snapshot and
	resource specifiy code.

1999-11-10  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.25.

	* drive/Makefile.am: Added `drivecpu.c', `via1.c' and
	`via2.c'.  Removed old soure files.

	* drive/drivecpu.h: Added `drive_mem_init'.

	* main.c: #include "drive.h".
	(MAIN_PROGRAM): Moved `drive_setup_context' before resource
	initialization.

	* drive/drivecpu.c, drive/via1.c, drive/via2.c, drive/viad.h,
	drive/drive.c: Changed the remaining `via[12]_*' functions to
	`via[12]d_*' to aviod duplicates.

1999-11-08  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* main.c: call to drive_setup_context() before the early init
	phase.

	* viacore.c: allow compiling with shared code depending on the
	definition of VIA_SHARED_CODE. If shared code is enabled,
	VIACONTEXT is the data type of the context pointer that will
	become the first parameter of all functions. Always access
	this parameter under the name ctxptr.

	* iecdrive.h: give the iec_info struct a name.

	* drivecpu.h, viad.h: changed for shared code. drivecpu.h
	defines the drive context structure drive_context_t.

	* drive/drivecpu0.c, drive/drivecpu1.c, drive/drivecpucore.c:
	unified into drivecpu.c. drive/via1drive0.c, drive/via1drive1.c
	unified into via1.c. drive/via2drive.c, drive/via2drive1.c
	unified into via2.c.

	* drive/{everything else}: minor changes for shared code.

1999-11-04  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* os2/archdep.c, os2/pm_cmdline, os2/video.c, os2/joystick.[ch],
	utils.c: minor changes

	* os2/vsync.c: solved the timer overflow

	* charset.[ch]: added two macros, speed up petconvstring and added
	return value

1999-10-31  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.24.

	* vdc/vdc.c (vdc_raster_draw_alarm_handler): Invert cursor if
	necessary.  (vdc_reset): Reset cursor.

	* vdc/vdc-mem.c (vdc_store): Implemented cursor registers.

	* vdc/vdc-draw.c (get_std_text): Draw cursor if visible.

	* c128/z80.c: Fixed ADDHLREG, ADDHLSP, SBCHLSP, SET A 0,
	RES A 0 and BIT A 0 opcodes.

	* alarm.c, alarm.h: Moved logging to `alarm.c'.

	* interrupt.c, interrupt.h: Moved logging to `interrupt.c'.

1999-10-30  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.23.

	* arch/unix: Moved X11 specific code to x11 directory.

	* arch/unix: Moved common header files from x11/xaw to this
	directory.

	* arch/unix/kbd.h: Removed X11 specific stuff.

	* arch/unix/joystick.c (new_joystick_init): Do not use `TRUE'.

	* arch/unix/x11/xaw/widgets/strnchr.c: Updated includes.

	* arch/unix/x11/xaw/Makefile.am,
	arch/unix/x11/gnome/Makefile.am,
	arch/unix/x11/xaw/widgets/Makefile.am: Fixed include path.

	* arch/unix/x11/xaw/video.h, arch/win32/video.h,
	arch/msdos/video.h, arch/riscos/video.h, arch/os2/video.h:
	Moved common code to `video.h' and renamed to `videoarch.h'.

	* arch/msdos/uisnapshot.c, arch/msdos/mouse.c: Added missing
	casts.

1999-10-30  Andreas Matthies  <andreas.matthies@arcormail.de>

	* arch/win32/res.rc: Use `AUTOCHECKBOX' instead of `CONTROL'.

1999-10-30  Dag Lem  <resid@nimrod.no>

	* arch/unix/xaw/ui.c (ui_jam_dialog): Handle CPU jam in vsid mode.

	* c64/psid.c (psid_play_tune): tune == -1 means stop playing.

	* sound.c (closesound): Log messages to console in console and
	vsid modes.
	(initsid): Set warp mode for non-realtime sound devices in vsid
	mode.

1999-10-29  Dag Lem  <resid@nimrod.no>

	* arch/unix/kbd.c (kbd_event_handler): No keyboard handling in
	vsid mode.

	* arch/unix/xaw/ui.c: Overdue vsid mode cleanup.
	* arch/unix/xaw/ui.h (ui_proc_read_msg): New parameter to block
	vsid mode main process in select().

	* arch/unix/xaw/uimenu.c (_ui_menu_toggle_helper,
	_ui_menu_radio_helper): Pass resource values to vsid main process
	in vsid mode.

	* arch/unix/xaw/vsidui.c: Made all menu options actually work.

	* c64/c64.c: Overdue vsid mode cleanup. (machine_play_psid):
	Choose tune in vsid mode.

	* c64/psid.c: Option -psid changed to -vsid. (psid_play_tune):
	Choose tune in vsid mode.
	* c64/psid.h (psid_play_tune): New function.

	* c610/c610.c (machine_play_psid): Dummy function.

	* c128/c128.c (machine_play_psid): Dummy function.

	* vic20/vic20.c (machine_play_psid): Dummy function.

	* pet/pet.c (machine_play_psid): Dummy function.

	* machine.h (machine_play_psid): New function.

	* main.c: Separate list of options for vsid mode. -vsid and
	-console options are checked before any UI initialization and
	normal command line parsing. This allows -console to start without
	any UI, and -vsid to have a separate set of command line options.
	SID tunes are no longer autodetected; -vsid is mandatory.

	* raster/raster.c (realize_canvas): Not realized in console mode.
	
1999-10-29  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.22.

	* arch/win32/Makefile.am: Added `uidatasette.c' and
	`uidatasette.h'.

1999-10-29  Martin Pottendorfer  <Martin.Pottendorfer@alcatel.at>

	* arch/unix/xaw/Makefile.am (libxawui_a_SOURCES): Added video.c,
	video.h.

	* arch/unix/gnome/*: New Files. Implementation of a gnome gui.

	* arch/unix/empty-ui/*: New files. This resolves everthing of 
	a new gui with dummy functions. It's not used in normal builds, no
	support is there in `configure.in' to enable the `empty-gui'.

	* arch/unix/Makefile.am: Check GNOMEUI and set SUBDIR
	accordingly.
	Removed video.c, video.h. Those are now in xaw.
	(gnome): New rule to build the gnomeui.

1999-10-27  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.21.

	* arch/riscos/config.h: Define `HAVE_LIMITS_H'.

	* fsdevice.c, imagecontents.c, vdrive/vdrive-bam.c,
	vdrive/vdrive-bam.h, vdc/vdc-draw.c: Removed some warnings.

1999-10-26  Andreas Matthies  <andreas.matthies@arcormail.de>

	* win32/arch.dsp: added uidatasette.c to project.

	* win32/res.h: new identifiers for datasette-settings-dialog:
	IDD_DATASETTE_SETTINGS_DIALOG,IDC_DATASETTE_RESET_WITH_CPU,
	IDC_DATASETTE_SPEED_TUNING,IDC_DATASETTE_ZERO_GAP_DELAY;
	deleted menu-id IDM_DATASETTE_RESET_WITH_CPU, new is
	IDM_DATASETTE_SETTINGS.

	* win32/res.rc: added resource-definition for
	datasette-settings-dialog.

	* win32/res64.rc,res128.rc,respet.rc,rescbm2.rc,resvic.rc:
	deleted "Reset with Main-CPU" in File-menu, added "Datasette
	settings" in the settings-menu.

	* win32/ui.c: includes uidatasette.h; no more toggle-menu
	"Reset with CPU"; 
	(handle_wm_command) new handler for the datasette-settings.

	* win32/uidatasette.h,uidatasette.c: new files to implement the
	datasette-settings in the style of uisound.

	* datasette.c: changed delay for motor acceleration from 10000
	to 1000 cycles, which seems to work better on some taps; maybe
	this should also become a resource in the future.

1999-10-26  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* arch/os2/kbd.c: added ui_attach_tape

	* arch/os2/config.h: #define FIXPOINT_ARITHMETIC added

	* arch/os2/pm/pbar.[ch]: deleted

	* arch/os2/pm/winaddon.[ch]: added

	* arch/os2/sounddrv.c: extended error handling

	* arch/os2/ui.c: added tape support, new log message

	* arch/os2/ui_status.[ch]: added some funtions to calculate
	rectangles, using them.

	* sounddrv/sounddart.c: function bodies addded

	* mon_lex.c: added stdlib-support for OS/2

	* utils.[ch]: using size_t for size at bufcat,
	#ifdef-OS2-block moved to os2/config.h

	* log.c: flush every msg direct to the file.

1999-10-25  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/petui.c: fixed some includes.

	* snapshot.c: removed RISC OS specific definition of off_t.

1999-10-24  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.20.

	* arch/win32/ui.c, arch/win32/video.c, arch/win32/vsync.c,
	arch/win32/winmain.c, c64/c64.c, ciacore.c, c64/c64cia2.c,
	c64/c64mem.c, c64/c64tpi.c, c64/psid.c, drive/drive.c, log.c,
	6510core.c, drive/drivecpucore.c, drive/fdc.c, riotcore.c,
	drive/riot1drive0.c, drive/riot1drive1.c, drive/riot2drive0.c,
	drive/riot2drive1.c, viacore.c, maincpu.c, kbdbuf.c, traps.c,
	imagecontents.c, fsdevice.c, datasette.c, utils.c, tape.c,
	t64.c, sysfile.c, sound.c, snapshot.c, serial.c, parallel.c,
	palette.c, ciatimer.h, raster/raster-cache.h, vicii/vicii.h,
	c64/reu.c, main.c, t64.h, findpath.c, diskimages.c, cmdline.c,
	petcat.c, c1541.c, prdevice.c, interrupt.c, keyboard.c,
	aciacore.c, rsuser.c, vicii/vicii.c, vdc/vdc.c, crtc/crtc.c,
	vic20/vic.c, sounddrv/soundfs.c, sounddrv/soundwav.c,
	sounddrv/sounduss.c: Removed some warnings.

	* c64/c64.c (machine_change_timing): Fixed typo.

	* tpicore.c, c64/c64tpi.h, cbm2/c610tpi.h: use REGPARM for
	register access.

	* pruser.h, sid/wave6581.h, sid/wave8580.h, vdc/vdc.h,
	vic20/vic.h, riotcore.h, arch/msdos/c64ui.c, arch/msdos/kbd.c,
	arch/msdos/vic20ui.c, arch/os2/archdep.c, arch/riscos/ui.c,
	arch/unix/xaw/ui.c, arch/unix/xaw/uicommands.c, c128/z80mem.c,
	arch/win32/ui.c, c128/c128mem.c, c128/c128mmu.c, c128/z80.c,
	c64/patchrom.c, c64/psid.c, c64/reu.c, c64/c64tpi.h, traps.c,
	drive/via1drive0.c, drive/via1drive1.c, drive/via2drive0.c,
	drive/via2drive1.c, pet/petvia.c, vdc/vdc-mem.c, vic20/vic.c,
	vic20/vic20ieeevia1.c, vic20/vic20ieeevia2.c, snapshot.c,
	vic20/vic20mem.c, vic20/vic20via1.c, vic20/vic20via2.c,
	arch/msdos/vmidas.c, arch/win32/kbd.c, arch/win32/mouse.c,
	arch/win32/video.c, raster/raster-sprite-status.c, attach.c,
	sounddrv/sounddx.c, sounddrv/soundwav.c, vdc/vdc-draw.c,
	vicii/vicii-draw.c, vicii/vicii-snapshot.c, arch/os2/kbd.c,
	arch/msdos/joystick.c, arch/msdos/tui_backend.c, c64/c64tpi.c,
	arch/msdos/tuiimagebrowser.c, arch/msdos/video.c, charsets.c,
	arch/os2/joystick.c, arch/os2/video.c, arch/os2/video_gpi.c,
	arch/riscos/kbd.c, arch/unix/kbd.c, arch/unix/video.c, main.c,
	arch/win32/joystick.c, c128/c128cia1.c, c128/c128iec.c, tap.c,
	c64/c64cartmem.c, c64/c64cia1.c, c64/c64cia2.c, c64/c64iec.c,
	cbm2/c610cia1.c, cbm2/c610tpi1.c, cbm2/c610tpi2.c, pet/pet.c,
	crtc/crtc-draw.c, drive/cia1571drive0.c, drive/riot1drive0.c,
	drive/cia1571drive1.c, drive/cia1581drive0.c, imagecontents.c,
	drive/cia1581drive1.c, drive/drivecpucore.c, petcat.c,
	drive/riot1drive1.c, drive/riot2drive0.c, drive/riot2drive1.c,
	prdevice.c, raster/raster.c, serial.c, sounddrv/soundsb.c,
	vdc/vdc-snapshot.c, vic20/vic-snapshot.c, vic20/vic20iec.c,
	arch/riscos/vic20ui.c: #include "types.h".	

	* c64/c64tpi.h, attach.c, c128/c128.c, c64/reu.c,
	crtc/crtc-snapshot.c, drive/drivecpucore.c, vic20/vic20.c,
	vic20/vic20mem.c: #include "snapshot.h".

	* sounddrv/sounddx.c, sounddrv/soundacorn.c: Use `xmalloc'.

	* mon_parse.y: #include <string.h>.

1999-10-20  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.19.

	* datasette.c (datasette_move_buffer_back): Return `1'.

	* arch/unix/main_exit.h, arch/win32/main_exit.h,
	arch/msdos/main_exit.h, arch/os2/main_exit.h: Removed includes
	that do not belong to those header files.

	* arch/unix/main_exit.c, arch/msdos/main_exit.c,
	arch/win32/main_exit.c, arch/os2/main_exit.c: Removed
	inclusion of `vicii.h'. Included `vice.h', `video.h' and
	`joystick.h' instead.

	* arch/unix/video.h, arch/msdos/video.h, arch/win32/video.h,
	arch/os2/video.h: Provide prototype for `video_free'.

	* arch/riscos/main_exit.h: Stub file.

	* cbm2/crtc.c: Commented out `do_update_memory_ptrs'
	prototype.

	* main.c: Do not #include "sound.h", "interrupt.h",
	"serial.h" and "vsync.h".

	* p00.c: Removed `//' comment.

	* arch/msdos/menudefs.c: #include <string.h> and "mem.h".

	* arch/msdos/ui.c: #include "vsync.h".

	* arch/msdos/c128ui.c, arch/msdos/c64ui.c, arch/msdos/c610ui.c,
	arch/msdos/menudefs.c, arch/msdos/tui.c, arch/msdos/petui.c,
	arch/msdos/uisnapshot.c: #include "tuifs.h".

	* arch/msdos/menudefs.c, arch/msdos/tui.c,
	arch/msdos/tui_backend.c, arch/msdos/tuiimagebrowser.c,
	arch/msdos/tuifs.c, arch/msdos/tuimenu.c, arch/msdos/ui.c,
	arch/msdos/tuiview.c, arch/msdos/video.c: #include
	"tui_backend.h" and #include <conio.h>.

	* arch/msdos/ui.c: #include <stdarg.h>.

	* sounddrv/soundacorn.c, ciatimer.c, fsdevice.c, log.c, mon.c,
	imagecontents.c, main.c, zfile.c, c1541.c, petcat.c,
	drive/drive.c, vdrive/vdrive-iec.c, vdrive/vdrive.c,
	vicii/vicii.c, vdc/vdc.c, c64/c64mem.c, c64/patchrom.c,
	arch/riscos/archdep.c, arch/riscos/archdep.h,
	arch/riscos/c128ui.c, arch/riscos/c610ui.c, arch/riscos/ui.h,
	arch/riscos/c64c128ui.c, arch/riscos/c64ui.c,
	arch/riscos/joystick.c, arch/riscos/kbd.c, arch/riscos/ui.c,
	arch/riscos/kbd.h, arch/riscos/petui.c, arch/riscos/print.c,
	arch/riscos/rs232.c, arch/riscos/uiimage.c,
	arch/riscos/vic20ui.c, arch/riscos/video.c,
	arch/riscos/vsync.c, arch/riscos/petdummy.c,
	arch/riscos/uimsgwin.c: Include "vice.h" instead of including
	<ROlib.h>, <limits.h> and "config.h" manually.

1999-10-20  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* arch/os2/archdep.c: archdep_spawn implemented.

	* sounddrv/soundmmos2.c: some changes for better synchronisation.

1999-10-20  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/*: compiles again after latest changes.

	* arch/riscos/ui.c: Added support for Datasette configurations
	and counter, Z80 Bios and the 4 new cartridge types.

	* arch/riscos/config.h: changed version, added HAVE_*_H macros
	for ANSI headers.

	* imagecontents.c: replaced C++ comment.

1999-10-20  Andreas Matthies  <andreas.matthies@arcormail.de>

	* datasette.h: deleted definition TAPV0_ZERO_GAP (now a resource)
	new definition DATASETTE_MAX_GAP to bound the gap of two alarms

	* tap.h: new flag has_changed in tap_t to notice if the size of
	the tap may need a correction.

	* datasette.c: new variable datasette_long_gap_pending, used
	when a long gap in the tap is splitted for a smooth counter
	new resources datasette_zero_gap_delay, datasette_speed_tuning,
	corresponding init-functions and cmd-options -dszerogapdelay,
	-dsspeedtuning
	(datasette_move_buffer_forward),(datasette_move_buffer_back)
	now check the io-calls and return a success-value
	(datasette_read_tap): handles problems with tap-buffer; uses
	resources datasette_zero_gap_delay and datasette_speed_tuning
	for calculation
	(datasette_read_bit): renamed v to speed_of_tape; changed type
	of gap from CLOCK to long; handles gaps longer than
	DATASETTE_MAX_GAP, splits them for a smooth datasette-counter
	(datasette_set_tape_image): added initialization of
	cycle_counter_total
	(datasette_reset): datasette_long_gap_pending is resetted
	(datasette_toggle_write_bit): sets current_image->has_changed

	* tap.c: (tap_open) initializes has_changed; size is now the
	size of the datablock (filesize - tap-header)
	(tap_close) writes new size to tap-header, if the tap
	has_changed

1999-10-17  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.18.

	* mem.h, c64/c64mem.c, c128/c128mem.c, vic20/vic20mem.c,
        pet/petmem.c, cbm2/c610mem.c (mem_get_screen_parameter): New
	function.

	* vicii/vicii-mem.h, vicii/vicii-mem.c, c64/c64mem.c, mem.h,
	c128/c128mem.c, c128/z80mem.c, sid/sid.h, sid/sid.c, traps.c,
	cbm2/c610mem.c, c64/psid.c, c64/patchrom.c, vic20/vic20mem.c,
	pet/petmem.c, c64/c64mem.h, c64/c64cia1.c, c64/c64cia2.c,
	c64/c64cia.h, c128/c128cia1.c, c64/reu.h, c64/reu.c,
	drive/ciad.h, drive/cia1571drive0.c, drive/cia1571drive1.c,
	drive/cia1581drive0.c, drive/cia1581drive1.c, cbm2/c610cia.h,
	drive/drivecpu0.c, drive/drivecpu1.c, drive/drivecpucore.c,
	drive/wd1770.h, drive/wd1770.c, drive/via1drive0.c, c64/c64.c,
	drive/via1drive1.c, drive/via2drive0.c, drive/via2drive1.c,
	drive/viad.h, vic20/vic20via.h, vic20/vic20via1.c, ciacore.c,
	vic20/vic20via2.c, vic20/vic20ieeevia1.c, pet/petvia.h,
	vic20/vic20ieeevia2.c, vic20/vic20ieeevia.h, pet/petvia.c,
	c64/c64tpi.h, c64/c64tpi.c, c128/c128.c, cbm2/c610tpi.h,
	c64/c64cartmem.c, cbm2/c610tpi1.c, cbm2/c610tpi2.c, piacore.c,
	pet/petpia.h, pet/pet.c, pet/petpia1.c, pet/petpia2.c,
	riotcore.c, drive/riot1drive0.c, drive/riot1drive1.c,
	drive/riot2drive0.c, drive/riot2drive1.c, drive/riotd.h,
	aciacore.c, c64/c64acia.h, c64/c64acia1.c, pet/petacia.h,
	pet/petacia1.c, cbm2/c610acia.h, cbm2/c610acia1.c,
	crtc/crtc-mem.h, crtc/crtc-mem.c, crtc/crtc-snapshot.c,
	vic20/vic-mem.h, vic20/vic-mem.c, vdc/vdc-mem.h,
	vdc/vdc-mem.c: Changed names of memory and IO access
	functions.

	* vic20/vic20datasette.c, vic20/vic20rsuser.c, vic20/vic20.c:
	#include "via.h".

	* c128/c128.c: #include "datasette.h".

	* mon.h, maincpu.h: Do not #include "mem.h".

	* drive/drivecpucore.c, mon.c, vicii/vicii-snapshot.c,
	vicii/vicii-snapshot.c, pet/pet.c, pet/petmem.c, cbm2/c610.c,
	cbm2/c610mem.c, kbdbuf.c, serial.c: #include "mem.h".

	* vicii/vicii-mem.h, vdc/vdc-mem.h, crtc/crtc-mem.h,
	vdrive/vdrive-bam.h, raster/raster-sprite-status.h,
	raster/raster.h, crtc/crtc-snapshot.c: #include "types.h".

	* c64/c64iec.c, c128/c128iec.c, vic20/vic20iec.c: #include
	"via.h".

1999-10-16  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.17.

	* datasette.c: #include <math.h>.
	(datasette_set_tape_image): Removed implicit cast.
	(datasette_read_bit): Initialize variables.

	* datasette.h: Removed nested comment.

1999-10-14  Andreas Matthies  <andreas.matthies@arcormail.de>

	* win32/res.h: two new menu-identifier for Datasette

	* win32/resc128,resc64,rescbm2,respet,resvic:
	new Datasette-Controls Reset, Reset Counter, Reset with Main CPU

	* win32/ui.c: connect menu-identifier IDM_DATASETTE_RESET_WITH_CPU
	with corresponding datasette-resource
	(handle_wm_command): new message handler for reset of Datasette-counter

	* c128/c128.c (machine_init): added initialation of datasette

	* c128/c128.c,c64/c64.c,pet/pet.c,cbm2/c610.c,vic20/vic20.c
	(machine_init_resources): added init for datasette-resources
	(machine_init_cmdline_options): added init for datasette-cmd-optns

	* datasette.c: new includes machine.h,resources.h,cmdline.h
	new variables for buffered reading of tap: tap_buffer[], next_tap,
	last_tap; new variables datasette_cycles_per_second and 
	datasette_counter_offset
	Resource "DatasetteResetWithCPU", corresponding cmdline-options
	+/-dsresetwithcpu
	(datasette_update_ui_counter): new realistic calculation of counter
	(datasette_reset_counter): new function to set counter to 000 even in
	the middle of the tap
	(datasette_move_buffer_forward),(datasette_move_buffer_back),
	(datasette_read_gap): new functions for buffered reading of datasette 
	gaps in both directions
	(datasette_read_bit): rewritten to set real timed alarms even at FF and
	REWIND
	(datasette_init): gets cycles per second for correct timing of counter
	(datasette_set_tape_image): reads length of tap for realistic REWIND
	(datasette_reset): resets the cycle_counter and datasette_counter_offset
	(datasette_control): now handles DATASETTE_CONTROL_RESET; sets the
	sense-line even at FF and REWIND
	(datasette_motor): sets the correct state of motor even at FF and REWIND
	(datasette_toggle_write_bit): increases size and cycle_counter_total
	if neccessary

	* datasette.h: definitions for TAP_BUFFER_LENGTH, TAPV0_ZERO_GAP and
	the parameters for the tape based on a standard SONY-90-minutes-tape
	prototype for public functions (datasette_reset_counter),
	(datasette_init_resources) and (datasette_init_cmdline_options)

	* maincpu.c: new include resources.h
	(reset): only resets the datasette if the DatasetteResetWithCPU-resource
	is set

	* tap.h: added cycle_counter and cycle_counter_total to tap_s for
	exact timing of the tape

1999-10-10  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.16.

	* drive/drive.c (set_sync_factor): Only update video standard
	if another standard has been selected.

	* vicii/vicii.c (init_raster, vic_ii_init): Return error value
	if something is wrong.
	* vdc/vdc.c, vic20/vic.c, crtc/crtc.c: Changed likewise.

	* pet/pet.c, cbm2/c610.c (machine_init): Check return value of
	`crtc_init'.

	* info.c: Updated.

	* vic20/vic20mem.c: Use logging system.

	* vice.h: Moved `APPLICATION_CLASS' to arch/win32/ui.h.
	Moved special type conversion to `fixpoint.h'.

	* sid/resid.cc: #include "fixpoint.h".

	* usleep.c: Do not #include <sys/param.h>.

	* crtc/crtc.c: #include "log.h".

	* vic20/vic20.c: #include "sound.h".

	* pet/petvia.h: #include "snapshot.h".

	* alarm.h, autostart.h, cmdline.h, datasette.h, machine.h,
	resources.h, warn.h, drive/riotd.h, c64/psid.h, vic20/vic.h,
	vic20/vic-draw.h, vic20/vic-mem.h, vic20/vic20iec.h, asm.h,
	vic20/vic20sound.h, pet/pet.h, pet/petmem.h, pet/petsound.h,
	pet/petvia.h, cbm2/c610cia.h, arch/unix/xaw/ui.h, c64/c64.h,
	arch/unix/xaw/uihotkey.h, arch/unix/xaw/uisnapshot.h,
	zipcode.h, log.h, raster/raster.h, raster/raster-modes.h,
	sid/resid.h, vic20/vic-cmdline-options.h, pet/pets.h,
	vic20/vic-resources.h, vic20/vic-snapshot.h, c64/c64mem.h,
	arch/unix/xaw/uiedisk.h: Added missing `extern'.

1999-10-10  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/msvc/config.h: Define HAVE_SIGNAL_H.

	* arch/win32/ui.c (status_partindex): New variable, translates
	drive index to status window index.
	(SetStatusWindowParts) (ui_display_drive_track)
	(ui_display_drive_led) (window_proc): Changed method of
	translating from drive index to status window index and back.

1999-10-09  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.15.

	* gcr.c, gcr.h, drive/drive.c, diskimage.c: Implemented error
	codes.

	* serial.c (serialattention): Flush read ahead buffer on
	UNLISTEN.

	* fsdevice.c (flush_fs): Check if argument is present before
	executing sratch or rename.

	* vdrive/vdrive.c: Replaced "OK" by " OK".

	* ciatimer.h, c128/z80.c, aciacore.c, pet/petsound.c,
	vic20/vic20sound.c, riotcore.c, sid/sid.c, c64/reu.c,
	ciatimer.c: Added missing casts.

	* vicii/vicii-resources.h, vicii/vicii.c: Do not provide
	double screen resource if VIC_II_NEED_2X is not defined.

	* palette.c, palette.h: Removed special riscos defines, use
	already existing arch defines instead.

	* sid/sid.c: #include "sound.h".

	* zipcode.h, tape.h, alarm.h, interrupt.h, mem.h, p00.h,
	parallel.h, sysfile.h, utils.h: Fixed external includes.

	* gcr.c, rsuser.h, emuid.h: #include "types.h".

	* 6510core.c: Removed old debugging cruft.

	* acia.h, keyboard.h: Protected against multiple inclusion.

	* alarm.h, maincpu.h, piacore.h: Do not #include "vice.h".

	* attach.h, cia.h, machine.h: Do not #include "types.h".

	* ciatimer.h: #include "snapshot.h".

	* arch/unix/types.h, arch/msdos/types.h, arch/riscos/types.h,
	arch/os2/types.h: #include "vice.h".

	* ciatimer.h: Do not #include "interrupt.h".

	* drive/drive.c, vdrive/vdrive-iec.c, raster/raster.c,
	crtc/crtc.c, sid/sid.c, vic20/vic.c, arch/unix/archdep.c,
	arch/msdos/archdep.c, attach.c, clkguard.c, cmdline.c,
	diskimage.c, gcr.c, kbdbuf.c, log.c, resources.c, romset.c,
	serial.c, sound.c, sysfile.c, t64.c, tap.c, tape.c, utils.c:
	#include <stdlib.h>.

	* arch/win32/msvc/config.h, arch/riscos/config.h,
	arch/os2/config.h, ciacore.h, tpicore.h, aciacore.c,
	autostart.c, c1541.c, c64/c64.c, c64/c64cartmem.c,
	c64/c64mem.c, c64/c64rsuser.c, c64/cartridge.c, c64/psid.c,
	c64/patchrom.c, c64/reu.c, charsets.c, cmdline.c,
	drive/drive.c, drive/riot1drive0.c, drive/riot1drive1.c,
	drive/riot2drive0.c, drive/riot2drive1.c, findpath.c,
	fsdevice.c, gcr.c, interrupt.c, kbdbuf.c, main.c, mon.c,
	mon_lex.l, mon_parse.y, palette.c, parallel.c, pet/pet.c,
	petcat.c, prdevice.c, pruser.c, resources.c, rsuser.c,
	serial.c, sid/sid.c, snapshot.c, sounddrv/sounddummy.c,
	sounddrv/sounddump.c, sounddrv/soundfs.c, maincpu.c,
	sounddrv/soundmmos2.c, sounddrv/soundspeed.c,
	sounddrv/soundwav.c, traps.c, vdc/vdc.c, vicii/vicii.c,
	warn.c, zfile.c, zipcode.c: Removed `STDC_HEADERS'.

1999-10-07  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.14.

	* diskimage.c (disk_image_read_sector): Translate disk image
	error code to drive error numbers.

	* vdrive/vdrive.c: Added missing error numbers.

1999-10-07  Andreas Matthies  <andreas.matthies@dzsh.landsh.de>

	* datasette.c (datasette_set_motor,
	datasette_toggle_write_bit): Fixed some bugs.

1999-10-03  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.13.

	* vdrive/vdrive-iec.c, vdrive/vdrive.c: #include <ctype.h>.

	* vdrive/vdrive.c (vdrive_get_block_parameters): Tolerate non
	alphanumeric chars at end of command.

	* diskimage.h: Added new member `error_info' to struct
	`disk_image_t'.

	* diskimage.c (disk_image_open, disk_image_close,
	disk_image_read_sector, disk_image_check_for_d64): Added
	support for error codes.

	* imagecontents.c, mon.c, drive/drive.c, vdrive/vdrive-bam.c,
	vdrive/vdrive.c: Adapted to new sector read return value.

	* vicii/vicii.c (vic_ii_reset_registers): New function.

	* c64/c64.c, c128/c128.c (machine_powerup): Reset VIC-II
	registers.

	* maincpu.c (mainloop): Print proper starting address.

	* vicii/vicii.h, cbm2/c610cia.h, sid/resid.h, crtc/crtc.h,
	viacore.h, mon.h, kbdbuf.h, ciacore.h, arch/unix/vsync.c,
	arch/msdos/vsync.c, arch/win32/vsync.c, arch/os2/vsync.c,
	cbm2/c610.c, pet/petsound.c, vic20/vic20.c, c128/c128.c
	vic20/vic20sound.c, c64/c64.c, sid/sid.h, sid/sid.c,
	crtc/crtc.c, vicii/vicii-mem.c, vicii/vicii.c, drive/wd1770.c,
	drive/drive.c, sounddrv/sounddump.c, sound.c, interrupt.c,
	datasette.c, autostart.c, alarm.c, diskimage.c, mon.c,
	c1541.c, vdrive/vdrive-bam.c, vdrive/vdrive-dir.c,
	vdrive/vdrive-iec.c, vdrive/vdrive.c: #include "types.h".

	* vicii/vicii.h, drive/drive.h: #include "snapshot.h"

        * drive/drive.h: Do not #include "drivecpu.h".

	* drive/drive.c, viacore.h, c64/c64.c, c64/c64cia2.c,
	c64/c64iec.c, c64/c64tpi.c, c128/c128.c, c128/c128iec.c,
	vic20/vic20.c, vic20/vic20iec.c, pet/pet.c, pet/petpia1.c,
	pet/petpia2.c, cbm2/c610.c, cbm2/c610cia1.c, cbm2/c610tpi1.c:
	#include "drivecpu.h".

	* interrupt.h: Removed special OS2 inclusion.

	* sid/sid.h: Do not #include "sound.h".

	* sid/resid.h, sid/resid.cc, c64/c64.c, c128/c128.c: #include
	"sound.h".

	* utils.h: #include "vice.h".

1999-10-02  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.12.

	* vicii/vicii.c (vic_ii_set_geometry): New function.
	#include "resource.h".

	* vsync.h: New file.

	* arch/unix/vsync.h, arch/msdos/vsync.h, arch/win32/vsync.h,
	arch/riscos/vsync.h, arch/os2/vsync.h: Removed.

	* arch/unix/vsync.c, arch/msdos/vsync.c, arch/win32/vsync.c,
	arch/riscos/vsync.c, arch/os2/vsync.c: Use new overflow code.
	(vsync_set_machine_parameter): New function.
	#include "maincpu.h".

	* arch/riscos/vsyncarch.h, arch/riscos/joystick.c,
	arch/riscos/kbd.c: Special riscos vsync stuff.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c,
	cbm2/c610.c (machine_init): Set vsync machine parameter.

	* pet/pet.c, cbm2/c610.c (machine_set_cycles_per_frame): Call
	`vsync_set_machine_parameter' instead of reinitializing vsync.

	* pet/petacia1.c, pet/petacia.h, c64/c64acia1.c,
	c64/c64acia.h, cbm2/c610acia1.c, cbm2/c610acia.h: Removed
	obsolete clock overflow code.

	* arch/unix/xaw/uisettings.c, arch/unix/xaw/c64ui.c,
	arch/unix/xaw/c128ui.c, arch/riscos/ui.c: Moved video standard
	settings to machine specific UI.

	* arch/win32/ui.c, arch/win32/res.h, arch/win32/resc64.rc,
	arch/win32/resc128.rc, arch/msdos/menudefs.c: New video
	standard settings.

	* c128/c128.c (machine_change_timing): Implemented.

1999-09-27  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.11.

	* c64/c64.h, c128/c128.h, drive/drive.h: New constants for old
	NTSC timing.

	* drive/drive.c (set_sync_factor): Call
	`machine_change_timing' when the user has changed timing.

	* machine.h, c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c,
	cbm2/c610.c (machine_change_timing): New function.

	* arch/unix/xaw/uisettings.c (set_custom_drive_sync_factor):
	Allow second NTSC setting.

	* vicii/vicii.c, vicii/vicii.h, vicii/vicii-mem.c,
	vicii/vicii-snapshot.c, vicii/vicii-draw.c, vicii-sprites.c:
	Added some NTSC timing support.

1999-09-26  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.10.

	* vdrive/vdrive.c, vic20/vic20sound.c, pet/petsound.c,
	imagecontents.c, arch/win32/archdep.c, c128/z80.c: #include
	<stdlib.h>.

	* mon.h, c64/cartridge.c, vic20/cartridge.c: Do not #include
	<assert.h>.

	* ciacore.h, drive/riot1drive0.c, drive/riot1drive1.c,
	drive/riot2drive0.c, drive/riot2drive1.c, drive/via1drive0.c:
	Do not #include <time.h>.

	* autostart.c, c1541.c, fsdevice.c, imagecontents.c, mon.c,
	romset.c, utils.c, zfile.c, arch/win32/archdep.c: #include
	<errno.h> if present.

	* c64/c64mem.c, c64/cartridge.c, vic20/cartridge.c: Do not
	#include <errno.h>.

	* findpath.c, snapshot.c, utils.c, zfile.c, drive/drive.c,
	arch/win32/dirent.c, arch/win32/lose32.h: #include <io.h> if
	present.

	* diskimage.c, fsdevice.c, sysfile.c, utils.c, c1541.c,
	sounddrv/soundsun.c, sounddrv/sounduss.c, c64/c64mem.c,
	c64/cartridge.c, vic20/cartridge.c: #include <sys/types.h> if
	present.

	* c64/c64mem.c, c64/cartridge.c, vic20/cartridge.c: Do not
	#include <sys/stat.h>.

	* sounddrv/soundsun.c, sounddrv/sounduss.c, fsdevice.c,
	sysfile.c, c1541.c, arch/win32/archdep.c: #include
	<sys/stat.h> if present.

	* fsdevice.c, gcr.c, utils.c, c1541.c, sounddrv/soundhpux.c,
	sounddrv/soundsun.c, sounddrv/sounduss.c,
	arch/win32/archdep.c: #include <fcntl.h> if present.

	arch/win32/archdep.c, mon.c, main.c: #include <signal.h> if
	present.

	* c64/cartridge.c, vic20/cartridge.c: Do not #include
	<fcntl.h>.

	* main.c, zfile.c, c1541.c, arch/win32/types.h: Do not
	#include <limits.h>.

	* arch/os2/config.h: Has `errno.h', `io.h', `sys/types.h',
	`sys/stat.h' and `signal.h'.
	* arch/win32/msvc/config.h: Changed likewise.

	* vice.h: CE does not need defining `alloca'.

	* arch/win32/kbd.c: Removed `key_ctrl_column4080'.
	Renamed `DEBUG' to `KBD_DEBUG'.

	* vic20/vic20mem.c: #include "ui.h".

	* arch/win32/archdep.c (archdep_default_sysfile_pathlist):
	Commented out unused code.

1999-09-26  Daniel Sladic  <dsladic@cs.cmu.edu>

	* mon.c: Fix enabling/disabling of checkpoints.
	(search_checkpoint_list) Fix typo for ranges.

	* mon.h: Fix enabling/disabling of checkpoints and sfx.

	* mon_parse.y: Fix enabling/disabling of checkpoints.
	Correctly treat breakpoint numbers as decimal.

1999-09-25  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.9.

	* c128/z80.c: Removed debugging stuff.

	* utils.c (subst): Added missing `const'.

	* cartridge.h, c64/cartridge.c, c64/c64cartmem.c: Added
	support for Westermann learning carts.

1999-09-25  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/arch.dsp: Added uicmdline.c.

	* arch/win32/*.dsp: Converted to MSVC6 format by MSVC6. (No idea if it
	still work with MSVC5. To check...) 

	* arch/win32/joystick.c (joystick_init): Call mouse_set_format.

	* arch/win32/mouse.c (mouse_data): New struct for receiving data
	from mouse device.
	(mouse_objects) (mouse_data_format): New structs for defining
	the format of incoming mouse data.
	(mouse_set_format): New function, sets up the data format for
	the mouse.
	(mouse_update_mouse): Update data receival.

	* arch/win32/mouse.h (mouse_set_format): New prototype.

	* arch/win32/msvc/config.h: Define DWORD_IS_LONG.

	* arch/win32/types.h: Use DWORD_IS_LONG when defining DWORD.

	* c128/z80mem.c: Turn off optimizations around function
	z80mem_initialize when compiling with MSVC.

	* sounddrv/sounddx.c: Include <windows.h> <mmsystem.h> only
	when compiling with GCC2.95 or above.
	(dx_init): Expanded DSBCAPS_CTRLDEFAULT, as DX7 doesn't has this
	define.

	* sysfile.c: Don't include <unistd.h> twice! Include it only when
	HAVE_UNISTD_H is defined.

1999-09-17  Andreas Matthies  <andreas.matthies@arcormail.de>

	* uiapi.h: Added prototypes for tape-ui:
	  (ui_set_tape_status), (ui_display_tape_motor_status),
	  (ui_display_tape_control_status), (ui_display_tape_counter)

	* win32/ui.c:
	  New variables for brushes (tape_motor_on_brush, tape_motor_off_brush)
	  (ui_init): initialize the brushes
	  New variables (tape_enabled, tape_motor, tape_counter, tape_control)
	  (ui_set_tape_status): new function
	  (ui_display_tape_motor_status): new function
	  (ui_display_tape_control_status): new function
	  (ui_display_tape_counter): new function
	  (SetStatusWindowParts): Added StatusWindow-part for tape-ui
	  (window_proc): added message-handler for tape-part of StatusWindow

	* msdos/ui.c, unix/xaw/ui.c, os2/archdep.c, riscos/ui.c:
	  dummy-definitions for tape-uiapi

	* datasette.c:
	  New function (datasette_update_ui_counter) 
	  (datasette_read_bit): now updates the ui-counter;
	  call (datasette_control) when tape reaches begin or end;
	  make the tape 10 times faster in REWIND and FORWARD-mode to reach
	  the speed of a real datasette
	  (datasette_set_tape_image): updates the ui
	  (datasette_reset): updates the ui-counter
	  (datasette_control): updates the ui-control
	  (datasette_set_motor): updates the ui-motor
	  (datasette_toggle_write_bit): updates the ui-counter

1999-09-19  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.8.

	* c128/z80.c: Fixed IM and LDIA opcodes.

	* c64/cartridge.c (cartridge_attach_image): New cartridge
	`CARTRIDGE_EPYX_FASTLOAD'.
	* cartridge.h: Likewise.
	* c64/c64cartmem.c (cartridge_read_io2, cartridge_attach):
	Likewise.

	* arch/unix/xaw/c64ui.c, arch/msdos/c64ui.c, arch/win32/res.h,
	arch/win32/resc64.rc, arch/win32/c64ui.c: Added UI controls
	for Epyx fastload cartridge.

	* Makefile.am: Added `uicmdline.o' to `c1541_LDADD' and
	`petcat_LDADD'.

1999-09-17  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.7.

	* c128/z80mem.c (z80mem_initialize): Fixed banking.

	* c128/z80.c: Reordered some opcodes.

	* findpath.c, fsdevice.c, snapshot.c, utils.c, zfile.c: Fixed
	inclusion of `dirent.h', `direct.h' and `io.h' for non-OS2
	systems.

	* arch/os2/Makefile.am: Added `Snippets' to subdirs.

	* arch/os2/Snippets/Dirport.H: Renamed to `dirport.h'.

	* arch/os2/Snippets/Dirport.C: Renamed to `dirport.c'.

1999-09-17  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* Some explicite castings in many files
	* fopen(*,"r") -> fopen(*,"rb")
	* fixed a minor bug in imagecontents.c (please have a look at it)
	* cmdline.c: cmdline_show_help --> arch\xxx\uicmdline.c
	* some changes so that the project compiles with VAC++ 4.0
	* added sound-support for Vice/2 (mmos2)
	* added joystick-support
	* added some hot-keys and information-windows
	* added dive-support (direct video)
	* new outfit for the percentage bar

1999-09-15  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.6.

	* c128/z80.c: Fixed CCF, SCF, ADD, SBC, BIT, CPI, CPIR, DEC,
	INC, IN, RRA, RRCA and SUB opcodes.
	(ADC n): New opcode.

1999-09-15  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/joystick.c: Include "ui.h".
	  (joystick_init): Init mouse device.
	  (joystick_close): Destroy mouse device.

	* arch/win32/mouse.c: Include "dinput.h" and "ui.h".
	  (mouse_acquired) (di_mouse): New variables.
	  (GUID_SysMouse) (GUID_XAxis) (GUID_YAxis) (GUID_ZAxis): Define
	  consts when no dxguid.lib is available.
	  (set_mouse_enabled): Call mouse_update_mouse_acquire.
	  (mouse_update_mouse): Changed to handle mouse through DirectX.
	  (mouse_set_cooperative_level): New function.
	  (mouse_update_mouse_acquire): New function.

	* arch/win32/mouse.h (mouse_update_mouse): Updated prototype.
	  (mouse_set_cooperative_level) (mouse_update_mouse_acquire): New
	  prototypes.

	* arch/win32/msvc/config.h: Define HAVE_GUIDLIB.

	* arch/win32/types.h: Define DWORD as unsigned long, when compiling
	  with MSVC or GCC2.95 or higher.

	* arch/win32/ui.c (ui_active) (ui_active_window): New variables.
	  (window_proc): Handle WM_ACTIVATE. Handle WM_ENTERMENULOOP.
	  Call mouse_update_mouse_acquire when handling WM_ENTERSIZEMOVE.
	  Handle WM_EXITMENULOOP, WM_EXITSIZEMOVE.
	  Removed handling of Mouse messages.
	  When handling WM_CLOSE, call dialog box so that it locks down
	  all windows of the task. (This has to be changed at all dialog
	  box calls.)

	* arch/win32/ui.h (ui_active) (ui_active_window): Added variable
	  definitions.

	* arch/win32/uiattach.c: Introduced using DUMMYUNIONNAME to enable
	  compiling with older and newer Mingw32 headers.

	* arch/win32/uicbm2set.c: Same here.
	
	* arch/win32/uidrive.c: Same here.

	* arch/win32/uipetset.c: Same here.

	* arch/win32/uivicii.c: Same here.

	* arch/win32/vsync.c: Include "mouse.h"
	  (do_vsync): Call mouse_update_mouse.

	* arch/win32/x128.dsp, arch/win32/x64.dsp, arch/win32/xcbm2.dsp,
	  arch/win32/xpet.dsp, arch/win32/xvic.dsp: Link with dxguid.lib.

	* sounddrv/sounddx.c: Define IID_IDirectSoundNotify when no dxguid.lib
	  is available.
	  (pbuffer): New variable for primary soundbuffer.
	  (dx_init): Set cooperative level to DSSCL_EXCLUSIVE.
	  Create primary sound buffer, and set it's format to the requested
	  sound output format.

1999-09-12  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.5.

	* c128/z80.c: Fixed SBCHLREG and SBCHLSP.
	(LDSPHL, LD(HL)#, CPIR, CCF, LDIFFA, LDAIFF, IM0, IM1, IM2,
	CPI, FDPREFIX, LDxx(WORD), LD(WORD)xx, SFC, BIT, INC(HL),
	DEC(HL)): New opcodes.
	(opcode_fd): New function.
	Added some debugging stuff.

	* c128/c128mem.c (z80mem_update_config): New function.

	* c128/c128mmu.c (mmu_store): Update Z80 memory pointers.

	* maincpu.c (mainloop): Trigger a reset instead of calling
	some reset functions.

	* c128/c128cpu.c: Changed `DMA_ON_RESET' to invoke Z80.

	* vdc/vdc-mem.c (store_vdc): Only bits 5..7 of register 28 set
	the chargen address.

1999-09-12  Dag Lem  <resid@nimrod.no>

	* Removed all SUBDIRS = . in Makefile.am files

1999-09-10  Markus Brenner  <markus@brenner.de>

	* vdc/vdc-draw.c: fixed draw_std_text(), added draw_std_bitmap()

1999-09-10  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* Replaced C++ commentaries in z80.c with C ones.

1999-09-09  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.4.

	* c128/z80.c: Fixed CALL, ADD and SUB opcodes.
	(JUMP_COND, RRCA, RRA, RLCA): New copcodes.

	* c128/z80.c, c128/z80.h, 6510core.c, drive/drivecpucore.c,
	maincpu.c, c128/c128cpu.c: Pass alarm and cpu struct to Z80
	emuation.

	* c128/c128mem.c (read_rom, store_rom): Added Z80 bios.

	* arch/win32/msvc/config.h: Added header files.

	* arch/win32/ui.c: Use `HAVE_COMMCTRL_H'.

	* arch/win32/uiattach.c: Use `HAVE_SHLOBJ_H'.

	* arch/win32/uicbm2set.c, arch/win32/uidrive.c,
	arch/win32/uipetset.c, arch/win32/uivicii.c: #include
	<shlobj.h>.

1999-09-08  Michael Schwendt  <sidplay@geocities.com>

	* sid/sid.c (setup_sid): Voice 3 cannot be turned off if
	it is has filter enabled.

1999-09-07  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.3.

	* c128/z80.c, c128/z80.h (z80_reset): New function.
	Added lots of opcodes.

	* c128mem.c (machine_reset): Reset Z80 emulation.

	* arch/win32/uiattach.c (dialog_proc): Added D80 and D82 disk
	images.

1999-09-06  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/Makefile.am: Added mouse.c, mouse.h to sources.

	* arch/win32/arch.dsp: Added mouse.c to project file.

	* arch/win32/c128.dsp: Added z80.c, z80mem.c to project file.

	* arch/win32/c128ui.c: Added IEEE488, and Mouse menu items.

	* arch/win32/c64ui.c: Added mouse menu item.

	* arch/win32/mouse.c: New file.

	* arch/win32/mouse.h: New file.

	* arch/win32/msvc/config.h: Define HAVE_MOUSE.

	* arch/win32/res.h (IDM_IEEE488) (IDM_MOUSE): Added command values for
	  new menuitems.

	* arch/win32/resc128.rc: Added IEEE488, and 1351 Mouse emulation to
	  menu.

	* arch/win32/resc64.rc: Added 1351 Mouse emulation to menu.

	* arch/win32/resvic.rc: Added IEEE488 to menu.

	* arch/win32/ui.c: Include "mouse.h".
	  (window_proc): Handle mouse events.

	* arch/win32/vic20ui.c: Added IEEE488 to menu.

1999-09-05  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.2.

	* c128/z80.c (z80_mainloop, z80mem_read_base,
	z80mem_read_limit, opcode_ed): Z80 core implementation.

	* c128/z80mem.h: Memory pointers have to be extern.

	* c128/z80mem.c (z80mem_initialize): Bank MMU to 0xff page.
	Added IN/OUT memory space.
	(mem_load): Removed Z80 startup hack.

	* c128/c128mmu.c (mmu_read, mmu_store): Added some debugging
	output.
	(mmu_switch_cpu): Switch off Z80 if 8502 gets control.
	(mmu_init): Activate Z80 on startup.

	* 6510core.c (DO_INTERRUPT): Activate DMA on reset if defined.
	* maincpu.c, c128/c128cpu.c, drive/drivecpucore.c: Changed
	likewise.

	* vdc/vdc-draw.c (draw_std_text): Removed debugging cruft.

1999-09-05  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.1.

	* imagecontents.c (image_contents_read_disk): Always copy all
	16 bytes of the filename.
	(image_contents_to_string): Convert the raw 16 char filename
	to printable string here.

	* vdrive/vdrive.c (vdrive_parse_name): Do not use string
	functions on CBM filenames as they can contain `\0'.

	* drive/drive.c (drive_init): Check for drive ROM.

	* c128mmu.c (mmu_switch_cpu): New function.
	(mmu_init): Initialize current CPU.  Use own logging system.
	(mmu_set_ram_bank): New function.

	* c128/c128cpu.c: Define `DMA_FUNC'.

	* 6510core.c (DO_INTERRUPT): Switch to other bus master DMA
	hosts like z80 CPU if `IK_DMA' is set.

	* interrupt.h (set_dma, ack_dma): New functions.

	* maincpu.c: If `DMA_FUNC' is not defined some generic DMA is
	used.  (maincpu_generic_dma): New function.
	* drive/drivecpucore.c: Changed likewise.

	* c128/z80.c, c128/z80.h, c128/z80mem.c, c128/z80mem.h: New
	files.

	* c128/Makefile.am: Added new files.

	* c128/c128mem.c (mem_set_ram_bank): Removed.

	* c128/c128mem.h: `ram_bank' is extern now.

	* romset.c, maincpu.h, cbm2/crtc.c, cbm2/c610cpu.c,
	arch/unix/xaw/widgets/FileSel.c,
	arch/unix/xaw/widgets/DirMgr.c,
	arch/unix/xaw/widgets/RegExp.c, arch/unix/readline/editline.h:
	Include "vice.h".

1999-08-31  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.1.

	* vicii/vicii.c (vic_ii_raster_draw_alarm_handler) [__MSDOS__]:
	Pass canvas and color value to `canvas_set_border_color'.
	Only set border color if this canvas is displayed.

	* vdc/vdc.c (vdc_raster_draw_alarm_handler) [__MSDOS__]: Call
	`canvas_set_border_color'.  Only set border color if this
	canvas is displayed.
	(init_raster): Initialize border color.

1999-08-31  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/res.h (IDC_SELECT_DRIVE_TYPE_1001)
	  (IDC_SELECT_DRIVE_TYPE_8050) (IDC_SELECT_DRIVE_TYPE_8250):
	  New commands for extra drive types.

	* arch/win32/res.rc (IDD_DRIVE_SETTINGS_DIALOG): Added radio
	  buttons for extra drive types.

	* arch/win32/uidrive.c (init_dialog) (dialog_proc): Added code
	  to handle extra drive types.

	* arch/win32/video.c (frame_buffer_alloc) (frame_buffer_free)
	  (frame_buffer_clear) (canvas_refresh): Changed frame_buffer
	  organization into linear buffer.

	* arch/win32/video.h (_frame_buffer): Frame buffer is now
	  one linear memory buffer.
	  (FRAME_BUFFER_LINE_START): Updated macro.

1999-08-30  Ettore Perazzoli  <ettore@comm2000.it>

	* vicii/vicii.c (vic_ii_raster_draw_alarm_handler) [__MSDOS__]:
	Set the border color if the viewport is smaller than the screen
	graphics area.

1999-08-29  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.65.

	* info.c: Added Dirk Farin.

	* maincpu.c: Do not define `TRACE'.

	* c128/c128iec.c (iec_fast_cpu_write, iec_fast_drive_write):
	Do not use fast IEC for now.

1999-08-29  Ettore Perazzoli  <ettore@comm2000.it>

	* ciacore.c (mycia_read_snapshot_module): Reset first.

	* vicii/vicii.c (vic_ii_prepare_for_snapshot): Unset the raster
	IRQ alarm as well.
	(vic_ii_set_raster_irq): Always recalculate the raster IRQ alarm
	if currently not set.

1999-08-26  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/c128ui.c (c128_ui_menu_toggles) (SidType)
	  (c128_ui_res_values): New structs for c128 specific resource
	  dependant menu entries.
	  (c128_ui_init): Register above structs for UI.

	* arch/win32/c610ui.c (cbm2_ui_menu_toggles) (SidType)
	  (cbm2_ui_res_values): New structs for cbm2 specific resource
	  dependant menu entries.
	  (c610_ui_init): Register above structs for UI.

	* arch/win32/c64ui.c (c64_ui_menu_toggles) (SidType)
	  (c64_ui_res_values): New structs for c64 specific resource
	  dependant menu entries.
	  (c64_ui_init): Register above structs for UI.

	* arch/win32/petui.c (pet_ui_menu_toggles): New struct for pet
	  specific resource dependant menu entries.
	  (pet_ui_init): Register above struct for UI.

	* arch/win32/ui.c (toggle_list): Changed type of struct. Removed
	  machine specific entries.
	  (res_possible_values): Removed typedef.
	  (RefreshRateValues) (SpeedValues) (SyncFactor): Changed type of
	  struct.
	  (SidType): Removed array. Moved into machine specific modules.
	  (value_list): Changed type of struct. Removed machine specific
	  entries.
	  (led_red) (led_green) (led_black): New variables.
	  (ui_init): Create Brushes for drive leds.
	  (machine_specific_toggles) (machine_specific_values): New variables.
	  (ui_register_menu_toggles): New function. Registers machine
	  specific resource menu toggle entries.
	  (ui_register_res_values): New function. Registers machine specific
	  menu entries with multiple state.
	  (update_menus): Handle machine specific entries.
	  (handle_wm_command): Handle machine specific toggle menus.
	  (window_proc): Use led_* variables when drawing drive leds.

	* arch/win32/ui.h (ui_menu_toggle) (ui_res_possible_values)
	  (ui_res_value_list): New typedefs.
	  (ui_register_menu_toggles) (ui_register_res_values): New prototypes.

	* arch/win32/vic20ui.c (vic20_ui_menu_toggles): New struct for vic20
	  specific resource dependant menu entries.
	  (vic20_ui_init): Register above for UI.

1999-08-25  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.64.

	* zfile.c (try_uncompress_zipcode): Only check the first two
	bytes of a disk image if there is a valid file name.

1999-08-24  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/c128kbd.c: Bind Run/Stop to ESC key.

	* arch/win32/c610kbd.c: Bind Run/Stop to ESC key.

	* arch/win32/c64kbd.c: Bind Run/Stop to ESC key.

	* arch/win32/petkbd.c: Bind Run/Stop to ESC key for 3032/4032 models.
	  Bind ESC to ESC key for 8032 models.

	* arch/win32/vic20kbd.c: Bind Run/Stop to ESC key.

1999-08-25  Ettore Perazzoli  <ettore@comm2000.it>

	* raster/raster.c (update_for_minor_changes_with_sprites): Draw
	sprites after drawing the area between the border and the start of
	active graphics.  Moreover, avoid fixing the border if it is
	redrawn from scratch because of sprites anyway.

1999-08-23  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.63.

	* arch/win32/uisnapshot.c (ui_snapshot_save_dialog_proc): Add
	".vsf" to the snapshot name if not present.

1999-08-23  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/archdep.c (archdep_make_backup_filename): Fixed, it
	  wasn't working right due to a 8.3 file naming convention.

	* arch/win32/res.h: Added identifiers for Swap joystick, and Emulator
	  identificator menu entries.

	* arch/win32/resc128.rc, arch/win32/resc64.rc, arch/win32/rescbm2.rc,
	  arch/win32/respet.rc, arch/win32/resvic.rc: Added Swap joystick,
	  and Emulator identificator menu entries.

	* arch/win32/ui.c: Added EmuID to the list of togglable resource
	  entries. Added accelerator key for Swap joystick menu entry.
	  (handle_wm_command): Handle Swap joystick menu entry.

	* arch/win32/uijoystick.c (ui_joystick_swap_joystick): New function.
	  Swaps joysticks.

	* arch/win32/uijoystick.h (ui_joystick_swap_joystick): New prototype.

	* arch/win32/video.c (canvas_update): Fixed a bug which caused
	  bad memory accesses. The pointer used was not always valid.
	  (canvas_refresh): Don't cache framebuffer addresses, always use
	  the one from the raster struct.
	
	* arch/win32/video.h (canvas_t): Removed framebuffer pointer.

	* fsdevice.c (flush_fs): Call unlink before rename calls on WIN32.

	* resources.c (resources_save): Same as above.

	* utils.c (make_backup_file): Same as above.
	  (get_line): Delete all newline characters from end of lines, both
	  0x0d and 0x0a chars.

	* zfile.c (compress): Call unlink before rename calls on WIN32.

1999-08-22  Andreas Boose  <boose@linux.rz.fh-hannover.de>

        * Version 1.0.62.

	* c64/c64.c, c128/c128.c, vic20/vic20.c (machine_init):
	Initialize IEC bus.

	* iecdrive.h, c64/c64iec.c, c128/c128iec.c, vic20/vic20iec.c
	(iec_init): New function.

	* vic20/vic20iec.c (iec_calculate_data_modifier,
	iec_calculate_data_modifier2): New functions.

	* diskimage.c: Exclude `sys/types.h' for RISC/OS.

1999-08-17  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.61.

1999-08-16  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/Makefile.am: Added raster to include directories.

	* arch/win32/arch.dsp: Added raster to include directories.

	* arch/win32/msvc/config.h (MSVC_RC): Added definitions.

	* arch/win32/resh.h: Added IDM_TOGGLE_CRTCDOUBLESIZE,
	  IDM_TOGGLE_CRTCDOUBLESCAN, IDM_TOGGLE_CRTCVIDEOCACHE definitions.

	* arch/win32/res.rc: Fixed about box, when using MSVC's Resource
	  Compiler.

	* arch/win32/rescbm2.rc, arch/win32/respet.rc: Updated Video Cahce,
	  Double Size, Double Scan menu entries.

	* arch/win32/ui.c (toggle_list): Added CRTC values for VideoCache,
	  DoubleSize, DoubleScan.
	  (window_proc): Handle WM_SYSKEYDOWN, WM_SYSKEYUP to intercept
	  F10 keypresses.
	  Call canvas_update instead of exposure_handler in WM_PAINT.

	* arch/win32/uilib.c (hook_proc): Override Open button to Attach
	  button when building the dialog box with content viewer enabled.

	* arch/win32/video.c: Include "raster.h".
	  Removed main_fbuff and main_canvas variables.
	  Added video_number_of_canvases and video_canvases variables.
	  Added raster_cache and number_of_rasters variables.
	  (video_register_raster): New function to import raster data.
	  (find_raster_for_canvas): New function, finds raster data for
	  canvas.
	  (canvas_find_canvas_for_hwnd): New function, finds canvas for
	  window handle.
	  (clear): New function, clears area to black.
	  (canvas_update): New function, updates screen from framebuffer.
	  (canvas_refresh): Stores framebuffer for canvas.

	* arch/win32/video.h (canvas_t): Added framebuffer pointer to struct.
	  (canvas_update): Added prototype.

	* crtc/crtc.c (crtc_resize): Call raster_set_pixel_size before
	  calling raster_resize_viewport.

	* raster/raster.c (raster_init) (raster_new): Call
	  video_register_raster when compiling for Windows. This is a
	  WORKAROUND.

	* vdc/vdc.c (vdc_resize): Call raster_set_pixel_size before
	  calling raster_resize_viewport.

	* vic20/vic.c (vic_resize): Call raster_set_pixel_size before
	  calling raster_resize_viewport.

	* vicii/vicii.c (vic_ii_resize): Call raster_set_pixel_size before
	  calling raster_resize_viewport.

1999-08-16  Ettore Perazzoli  <ettore@comm2000.it>

	* raster/raster.c (update_for_minor_changes_with_sprites): Ooops.
	Always draw sprites over the graphics when graphics has changed,
	even if sprites have not.

1999-08-15  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.60.

	* c64/c64mem.c (initialize_memory): Initialize CPU port with
	`0'.

	* vic20/vic.c (exposure_handler): Renamed to
	`vic_exposure_handler'.

	* vic20/vic.h: Removed `exposure_handler'.

	* vic20/vic-resources.c (set_double_scan_enabled): Notify the
	raster code.

1999-08-15  Ettore Perazzoli  <ettore@comm2000.it>
 
	* raster/raster.c (handle_blank_line): Draw one more pixel on the
	right for double-scan lines in the upper/lower borders.
 
1999-08-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>
  
  	* Version 1.0.59.

1999-08-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.59.

	* drive/drive.c: Name of 1541-II firmware is `d1541II'.

	* sounddrv/Makefile.am, drive/Makefile.am, vdrive/Makefile.am,
	raster/Makefile.am, vicii/Makefile.am, vdc/Makefile.am,
	crtc/Makefile.am, sid/Makefile.am, c64/Makefile.am,
	c128/Makefile.am, vic20/Makefile.am, pet/Makefile.am,
	cbm2/Makefile.am, arch/unix/xaw/widgets/Makefile.am,
	arch/unix/readline/Makefile.am, arch/win32/Makefile.am,
	arch/msdos/Makefile.am, arch/riscos/Makefile.am,
	arch/os2/pm/Makefile.am: Define `SUBDIRS'.

1999-08-10  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/res.rc (IDD_OPEN_TEMPLATE): Added workaround for Windres
	bug.

1999-08-08  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.58.

	* arch/win32/ui.c (handle_wm_command) [IDM_AUTOSTART]: Do not use
	"*" for program name as this does not work for tapes.

	* arch/win32/res.rc: Fixed version string.

	* arch/win32/kbd.c (kbd_handle_keydown): Added 40/80 column key
	support.

	* vic20/vic20.c, vic20/vic20mem.c: Added missing includes.

	* vic20/vic20ieeevia1.c, vic20/vic20ieeevia2.c (store_pcr): Return
	byte.

	* crtc/crtc-draw.c (DRAW): Align offset as suggested by Dirk Farin.

	* crtc/crtc-resources.c, crtc/crtc-resources.h: Fullscreen double
	size resources.
	* vic20/vic-resources.c, vic20/vic-resources.h: Likewise.

1999-08-07  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/ui.c (ui_update_menus): Removed HWND parameter,
	  function is empty now.
	  (update_menus): New function. Updates menu entries.
	  (handle_wm_command): Removed calls for ui_update_menus.
	  (window_proc): Call update_menus instead of ui_update_menus, when
	  user access the menu.

	* arch/win32/uilib.c (hook_proc): Cast SendMessage paramater.

1999-08-07  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.57.

	* vdrive/vdrive-bam.c (vdrive_bam_alloc_next_free_sector):
	Rewritten as the old implementation had too many bugs.
	(vdrive_bam_alloc_down, vdrive_bam_alloc_up): New functions.

1999-08-07  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/Makefile.am (EXTRA_DIST): Added vdc.dsp and vdrive.dsp.

	* arch/win32/c128.dsp: Added '..\..\vdc' to include dirs.
	  Removed vdc.c. Added c128mmu.c .

	* arch/win32/c1541.dsp: Added '..\..\vdrive' to include dirs.
	  Added diskimage.c. Removed vdrive-iec.c, vdrive.c.

	* arch/win32/c64c128.dsp: Added reu.c.

	* arch/win32/c64ui.c (c64_ui_specific): Updated ui_select_file calls.

	* arch/win32/drive.dsp: Added '..\..\vdrive' to include dirs.

	* arch/win32/pet.dsp: Removed crtc.c.

	* arch/win32/petcat.dsp: Added '..\..\vdrive' to include dirs.

	* arch/win32/res.h: Added IDD_OPEN_TEMPLATE, IDC_PREVIEW resource
	  values.

	* arch/win32/res.rc: Added DS_3DLOOK, DS_CONTROL, WS_CHILD, WS_VISIBLE,
	  WS_CLIPSIBLINGS, WS_BORDER, WS_HSCROLL, LBS_NOSEL defines.
	  Added IDD_OPEN_TEMPLATE dialog box.

	* arch/win32/ui.c: Include "imagecontents.h". New variables:
	  hwnd_titles, window_handles, exposure_handler, number_of_windows.
	  (ui_init): Do not create the window here.
	  (ui_open_canvas_window): Create the window here.
	  (ui_update_menus): Added window handle to parameters. Update menu
	  of the passed window.
	  (ui_error) (ui_message) (ui_extend_image_dialog): Use first created
	  window as parent window for dialog boxes.
	  (ui_display_speed): Update all window titles with speed values.
	  (save_snapshot_trap) (load_snapshot_trap): Use first created
	  window as parent.
	  (ui_get_main_hwnd): Return first created window handle.
	  (ui_dispatch_next_event): Use transalator table of the window, to
	  which the message was sent.
	  (handle_wm_command): Pass window handle as parameter. Use it in
	  every call, which needs a window handle. Update ui_select_file
	  calls with the appropriate content viewer procedure.
	  (window_proc): Find the index of the window whose message is being
	  processed. Use its registered exposure_handler.

	* arch/win32/uiattach.c: Include 'imagecontents.h'.
	  (dialog_proc): Updated ui_select_file calls with appropriate
	  content viewer procedure.

	* arch/win32/uilib.c: Include 'imagecontents.h' and 'res.h'.
	  (read_content_func): New variable.
	  (read_disk_image_contents) (read_tape_image_contents)
	  (read_disk_or_tape_image_contents) (create_content_list)
	  (hook_proc): New functions.
	  (ui_select_file): Add content viewer dialog, if content viewer
	  procedure is not NULL.

	* arch/win32/uilib.h (ui_select_file): Updated prototype.
	  (read_disk_image_contents) (read_tape_image_contents)
	  (read_disk_or_image_contents): Added new prototypes.

	* arch/win32/uisnapshot.c (ui_snapshot_load_dialog): Updated
	  ui_select_file call.

	* arch/win32/uivicii.c (dialog_palette_proc): Updated ui_select_file
	  call.
	
	* arch/win32/vdc.dsp: New file. MSVC project file for vdc library.

	* arch/win32/vdrive.dsp: New file. MSVC project file for vdrive
	  library.

	* arch/win32/vic20.dsp: Added vic20ieeevia1.c and vic20ieeevia2.c.

	* arch/win32/vic20ui.c (vic20_ui_specific): Updated ui_select_file
	  calls.

	* arch/win32/vice.dsw: Added vdc and vdrive library to project
	  workspace. Updated project dependencies.

	* arch/win32/video.c: Moved directdraw object creation to video_init.
	  (canvas_refresh) Set clipping regions for the actual window being
	  drawn.

	* arch/win32/x128.dsp, arch/win32/x64.dsp, arch/win32/scbm2.dsp,
	  arch/win32/xpet.dsp, arch/win32/xvic.dsp: Added '..\..\vdrive' to
	  include dirs. Added diskimage.c. Removed vdrive-iec.c vdrive.c.

	* diskimage.c: Include <sys/types.h>.

	* vicii/vicii-resources.c (set_fullscreen_double_size_enabled)
	  (set_fullscreen_double_scan_enabled): Compile only when
	  USE_VIDMODE_EXTENSION is defined.

1999-08-06  Dirk Farin  <farin@ti.uni-mannheim.de>

	* arch/unix/video.c, arch/unix/video.h: New MIT-SHM code.

1999-08-04  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/ui.c: new configuration window for C128 settings.

1999-08-02  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.56.

	* drive/drive.c, drive/drive.h (drive_check_type): New function.

	* arch/unix/xaw/uisettings.c (radio_Drive8Type, radio_Drive9Type):
	Check drive type.

	* vicii/vicii-resources.c: Added fullscreen resources.

	* vdc/vdc.h: Fixed last text line.

1999-07-30  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* NEWS: add Cycle-exact CRTC emulation

	* c128/c128mem.c, c64/c64mem.c, cbm2/c610mem.c, pet/petmem.c,
	vic20/vic20mem.c:
	to disable traps, set "VirtualDevices" to 0, not 1

	* crtc/crtc-snapshot.c (crtc_read_v0_snapshot_module): new function
	to read VICE 1.0 and earlier CRTC snapshots
	(crtc_read_snapshot_module): call crtc_read_v0_snapshot_module()
	when found

	* crtc/crtc.c (crtc_reset): set alarm relative to clk value

1999-07-30  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.55.

	* arch/unix/xaw/c64ui.c (attach_cartridge): Update UI.

	* c64/cartridge.c (cartridge_attach_image): Caller has to update
	the UI.

	* c64/reu.c (store_reu): Disable some REU hack.

1999-07-30  Dirk Farin  <farin@ti.uni-mannheim.de>

	* arch/unix/xaw/ui.c: Changed `led*' variables to `driveled*'.

1999-07-29  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* arch/unix/xaw/vic20ui.c (toggle_IEEE488, vic20_io_submenu, 
	vic20_io_settings_menu): new (unused) stuff for the VIC-1112 interface

	* drive/via1drive0.c, drive/via1drive1.c: removed some parallel_debug
	comment prints

	* interrupt.h (I_IEEEVIA1FL, I_IEEEVIA2FL): new entries for 
	IEEE488 VIAs

	* parallel.c (parallel_set_eoi, parallel_clr_eoi): add some
	debug prints

	* vic20/Makefile.am: add vic20ieeevia.h, vic20ieeevia1.c and
	vic20ieeevia2.c

	* vic20/vic20.c (machine_init): init IEEE VIAs
	(machine_reset): reset IEEE VIAs
	(machine_write_snapshot, machine_read_snapshot): handle IEEE VIAs

	* vic20/vic20iec.c (iec_available_busses): allow IEEE drives
	when IEEE488 resource is set

	* vic20/vic20ieeevia.h, vic20/vic20ieeevia1.c, vic20/vic20ieeevia2.c:
	new files for VIC-1112 interface

	* vic20/vic20mem.c (set_ieee488_enabled, ieee488_enabled, resources,
	cmdline_options): new stuff for the IEEE488 interface
	(read_emuid, store_emuid): do not check address anymore
	(read_io2, store_io2, read_io3, store_io3): new functions for the
	expansionport IO2 and IO3 lines. They call IEEE VIAs and emuid stuff
	(initialize_memory): setup mem for IO2/IO3 areas

1999-07-29  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.54.

	* c64/reu.c (reset_reu): Do not load image if no image name is
	given.

	* utils.c (load_file): Check for NULL pointer.

1999-07-28  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* Makefile.am (x128-all): add libraster

	* arch/unix/xaw/c610ui.c (c610_ui_init): use crtc settings

	* c128/c128cia1.c, drive/cia1571drive0.c, drive/cia1571drive1.c,
	drive/cia1581drive0.c, drive/cia1581drive1.c
	(store_sdr): write "cia_shifter" instead of cia[CIA_SDR]

	* cbm2/c610.c (machine_init): set correct hardware options

	* ciacore.c: fix shift register handling, at least a bit...

	* ciacore.h (cia_shifter, cia_sdr_valid): new variables for 
	the shift register

1999-07-28  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.53.

	* vdc/vdc.h: Fixed VDC screen geometry.

	* vdc/vdc.c (vdc_raster_draw_alarm_handler): Adjusted memory
	pointers on line 0.

	* raster/raster.h (ycounter): Made int.

	* autostart.c, c64/c64mem.c, c128/c128mem.c, vic20/vic20mem.c,
	pet/petmem.c, cbm2/c610mem.c, arch/msdos/menudefs.c: Renamed
	`NoTraps' to `VirtualDevices'.

	* vdrive/vdrive.c (get_block_parameters): Allow '#' as parameter
	separator.  Renamed to `vdrive_get_block_parameters'.
	(vdrive_parse_name): Do not exit on ',' if `FAM_READ' or
	`FAM_WRITE' is already set.

1999-07-27  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* c128/c128mem.c (mem_set_exrom): new function

	* c64/c64iec.c (iec_available_busses): use carttype to 
	determine possible disk drives

	* c64/c64mem.c (mem_set_exrom): new function to set state
	of EXROM line

	* c64/c64tpi.c (store_pc): call mem_set_exrom()

	* c64/cartridge.c (carttype): make exported
	(attach_ieee488, cmdline_options): new function, added
	cmdline option to attach IEEE488 image

	* ciatimer.h (ciat_update): fix hangup

	* crtc/crtc.c (clk_overflow_callback): new function
	(crtc_init): add clock guard callback
	(crtc_reset): reset clock values
	(crtc_raster_draw_alarm_handler): handle CRTC frame length
	and call machine_set_cycles_per_frame()

	* crtc.h (crtc_t): add frame_start, cycles_per_frame

1999-07-25  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.52.

	* vdc/vdc-mem.c (store_vdc): Added debugging messages.
	(vdc_perform_fillcopy): Check VDC RAM limit.
	(read_vdc): Implemented auto increment.

	* vdc/vdc-draw.c (get_std_bitmap): Added register 26 support.

	* raster/raster-cache.h (raster_cache_data_fill_const): New
	function.

	* arch/unix/xaw/c128ui.c: New VDC settings.

	* vdc/vdc.h: Removed `VDC_ADDRESS_MASK'.

	* vdc/vdc-resources.c, vdc/vdc-resources.h: New resource to set
	the VDC memory size.

	* vdc/vdc-cmdline-options.c: New command line options to set the
	VDC memory size.

	* c64/c64cartmem.c (cartridge_read_io2, cartridge_store_io2,
	cartridge_attach, cartridge_detach, cartridge_init_config): Moved
	IEEE488 cart access here.

	* arch/unix/xaw/c64ui.c: Moved IEEE488 interface to cart section.

	* arch/win32/res.h, arch/win32/resc64.rc, arch/win32/c64ui.c,
	arch/msdos/c64ui.c: Added IEEE488 controls.

	* arch/win32/res.h, arch/win32/resc64.rc, arch/win32/resc128.rc,
	arch/win32/ui.c: Added REU UI controls.

1999-07-24  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.51.

	* c64/reu.c (read_reu): Added missing `break'!

	* c64/Makefile.am: Added REU support to C128 library.

	* arch/unix/xaw/c128ui.c, arch/msdos/c128ui.c: Added REU UI
	controls.

	* c128/c128mem.c (set_reu_enabled, store_io2, read_io2): Added REU
	support.
	* c128/c128.c (machine_init): Likewise.

	* interrupt.h, interrupt.c (trigger_reset, ack_reset,
	trigger_trap, do_trap, monitor_trap_on, monitor_trap_off): Moved
	out of the header file.

	* mon.c (mon_watch_push_store_addr): Fixed typo.

	* 6510core.c: Removed some cruft.

	* c1541.c (format_cmd): Fixed number of arguments.

1999-07-21  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.50.

	* mon.c (mon_watch_push_load_addr, mon_watch_push_store_addr):
	Limit number of watchpoint hits to 10.

1999-07-21  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/ui.c: added support for 40/80 key and 8050/8250
	drive types.

	* arch/riscos/video.c: some changes to the handling of frame
	buffers and active windows.

1999-07-19  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* doc/vice.texi: Remove IeeeFS docs, rename "NoTraps" to 
	"VirtualDevices"

	* arch/unix/xaw/uisettings.c (VirtualDevices, NoTraps, IeeeFS):
	remove IeeeFS, and rename NoTraps to VirtualDevices

	* c128/c128.c, c64/c64.c, cbm2/c610.c, pet/pet.c
	(machine_init_resources, machine_init_cmdline_options): do not call
	parallel_init_*()

	* parallel.c (set_paremu_enabled, resources, parallel_init_resources,
	cmdline_options, parallel_init_cmdline_options): removed
	(parallel_bus_enable): new function

	* traps.c (no_traps_enabled, traps_enabled): named former to latter.
	fix all occurances
	(resources, cmdline_options): rename "NoTraps" to "VirtualDevices"

1999-07-18  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* doc/vice.texi: add RIOT 6532 module description

	* riotcore.c (ti_N, ti_write_clk, ti_divider, ti_irqen):
	new values to save the timer state
	(update_irq): new function to update the IRQ line.
	(update_timer): new function to update timer to current clk.
	(myriot_reset, store_myriot, read_myriot): handle timer
	read/writes
	(myriot_read_snapshot_module, myriot_write_snapshot_module):
	load/save timer snapshot.

1999-07-18  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.49.

	* vic20/vic.h: Removed comma at end of enumeration.

	* vicii/vicii.h: Enumeration has to be called
	`_vic_ii_video_mode'.
	* vdc/vdc.h: Changed likewise.

	* vicii/vicii-mem.c: Added some missing casts.

	* vdc/vdc-draw.c: Removed single CR at end of lines.

	* crtc/crtc-snapshot.c (crtc_read_snapshot_module): Removed unused
	variables.

	* crtc/crtc.h (crtc_enable_hw_screen_blank): Added prototype.

	* pet/petmem.c (set_eoiblank_enabled): Return 0.

	* arch/unix/xaw/ui.c: Removed stray `;'.

	* arch/unix/xaw/uicommands.c (ui_update_flip_menus): Initialize
	variables.  Added missing casts.

	* autostart.c, main.c, c1541.c: Added missing casts.

1999-07-18  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* doc/vice.texi: add info about dual disk drives.
	Add IeeeFS docs

	* arch/unix/xaw/uisettings.c (IeeeFS, peripheral_settings_submenu):
	new entry to enable/disable use of IEEE488 filesystem engine

	* c128/c128.c, c64/c64.c, cbm2/c610.c, pet/pet.c
	(machine_init_resources, machine_init_cmdline_options):
	add calls to parallel_init_*()

	* c64/c64iec.c (iec_available_busses): return IEEE488 only if
	IEEE488 interface is enabled

	* drive/fdc.c (fdc_t): add last_wps variable.
	(int_fdc): check write protect switch and "send" to IPC

	* parallel.c (set_paremu_enabled, resources, parallel_init_resources,
	cmdline_options, parallel_init_cmdline_options): new stuff
	to make "parallel_emu" a resource.

	* parallel.h (parallel_init_resources, parallel_init_cmdline_options):
	new prototypes

1999-07-18  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.48.

	* diskimage.c (disk_image_check_for_x64): New function.
	(disk_image_read_sector, disk_image_write_sector,
	disk_image_check_sector, disk_image_sector_per_track,
	disk_image_create): Added X64 support.

	* vdrive/vdrive.c (vdrive_attach_image, vdrive_detach_image):
	Added X64 support.

	* drive/drive.c (drive_read_image_d64_d71, drive_attach_image,
	drive_check_image_format, drive_detach_image,
	drive_GCR_data_writeback): Added X64 support.

	* c1541.c (format_cmd): Added X64 support.

1999-07-18  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* arch/msdos/ui.c, arch/os2/archdep.c, arch/win32/ui.c 
	arch/unix/xaw/ui.c (ui_display_drive_track): add "drive_base"
	parameter, either 0 or 8 depending on whether dual drives are
	displayed (0) or different units (8)

	* uiapi.h (ui_display_drive_track): added drive_base to prototype

	* drive/drive.c (set_drive0_type): if dual disk type selected,
	disable second unit
	(set_drive1_type): if first drive is dual drive, do not enable
	(drive_enable, drive_disable): enable drive status of second
	unit as second drive when first unit is dual drive
	(drive_update_ui_status):if first unit is dual drive, update
	second drive too.
	(drive_num_leds): if first unit is dual drive, return 2 LEDs
	for the second drive

	* drive/drive.h (DRIVE_IS_IEEE, DRIVE_IS_OLDTYPE, DRIVE_IS_DUAL):
	new defines

	* drive/fdc.c (fdc_do_job): if dual disk drive setup drive 
	appropriately

	* drive/riot2drive0.c (drive0_riot_set_atn): use DRIVE_IS_OLDTYPE()
	macro
	(undump_prb, store_prb): if unit is dual drive, update drive 1
	LED status too

	* drive/riot2drive1.c (drive1_riot_set_atn): use DRIVE_IS_OLDTYPE()
        macro

1999-07-18  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* doc/vice.texi (Video Options): Move PaletteFile here, add
	Crtc-specific resources and cmdline options

	* arch/unix/xaw/petui.c (pet_ui_init=: use ui_crtc_video_settings_menu
	instead of ui_video_settings_menu

	* arch/unix/xaw/uisettings.c (ui_crtc_video_settings_menu,
	crtc_video_settings_submenu): new entries for Crtc-specific 
	options

	* arch/unix/xaw/uisettings.h (ui_crtc_video_settings_menu): new 
	prototype

	* crtc/crtc-cmdline-options.c (cmdline_options): prefix cmdline
	options with "crtc"

	* crtc/crtc-resources.c (resources): prefix resources with "Crtc".

1999-07-17  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.47.

	* raster/raster.h: Added new flag `update_canvas' to
	`raster_viewport_t'.

	* raster/raster.c (update_canvas, update_canvas_all): Refresh
	canvas if `update_canvas' is set.
	(raster_set_canvas_refresh): New function.

	* vicii/vicii.c, vdc/vdc.c, vic20/vic.c (init_raster): Init
	canvas refresh flag.
	* crtc/crtc.c (crtc_init): Likewise.

	* c128/c128mmu.c (set_column4080_key): Set active canvas on
	architectures providing only one active canvas.
	(mmu_init): New function.

	* vdc/vdc.c (vdc_set_set_canvas_refresh): New function.

	* vicii/vicii.c (vic_ii_set_set_canvas_refresh): New function.

1999-07-16  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* arch/unix/xaw/uisettings.c (set_drive0_type_submenu): add 8050 and
	8250 entries

	* /drive/drive.c: anywhere where DRIVE_TYPE_1001 appears, add 
	DRIVE_TYPE_8050 and DRIVE_TYPE_8250 accordingly

	* drive/drive.h (DRIVE_TYPE_8050, DRIVE_TYPE_8250): new defines

	* drive/drivecpucore.c (reset): directly give the drive type to 
	fdc_reset()
	anywhere where DRIVE_TYPE_1001 appears, add
        DRIVE_TYPE_8050 and DRIVE_TYPE_8250 accordingly

	* drive/fdc.c (fdc_t): add drive_type element
	(fdc_reset): record drive type
	(int_fdc): if 8050 disk drive then use only one side
	(drive/riot2drive0.c, drive/riot2drive1.c): anywhere where 
	DRIVE_TYPE_1001 appears, add DRIVE_TYPE_8050 and DRIVE_TYPE_8250 
	accordingly

1999-07-16  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* /doc/vice.texi: add descriptions for some missing PET resources
	and cmdline options
	Add quick snapshot descrition
	Add description of new CRTC snapshot module

	* crtc/crtc-mem.c (store_crtc): remove print

	* crtc/crtc-snapshot.c (crtc_read_snapshot_module,
	crtc_write_snapshot_module): fix some bugs

	* crtc/crtc.c (crtc_reset_screen_ptr): handle change to/from
	reverse mode
	(crtc_raster_draw_alarm_handler): better handling of screen blank
	(crtc_enable_hw_screen_blank): new function. Sets the hw_blank 
	availability flag
	(crtc_screen_enable): set the external blank flag, that is only
	honoured if hw_blank is set
	(crtc_update_window): made non-static

	* crtc/crtc.h (crtc_t): add hw_blank and blank variables.
	(crtc_update_window): new prototype

	* emuid.c (emulator_id): update version to 1.1 (names must be changed
	though)

	* pet/petmem.c (petres,pet_table,pet_set_conf_info): add eoiblank 
	value and handling of it
	(set_eoiblank_enabled, resources, cmdline_options): EoiBlank
	resource, cmdline option and setting function added
	(mem_write_ram_snapshot_module, mem_read_ram_snapshot_module):
	updated to V1.2 (add EoiBlank)

	* pet/pets.h (PetInfo, PetRes): add eoiblank

	* piacore.c (read_mypia): fix typo

1999-07-15  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* arch/unix/xaw/uicommands.c (load_snapshot_trap): if data is not
	NULL, interpret it as filename and load directly.
	(load_quicksnap): new function that directly gives a default filename
	to the trap
	(save_snapshot_trap, save_quicksnap): likewise
	(ui_snapshot_commands_submenu): add entries for loading/saving 
	quick snapshot

	* crtc/crtc-snapshot.c (crtc_write_snapshot_module, 
	crtc_read_snapshot_module): ongoing work to adapt snapshots
	to new raster/crtc code

	* crtc/crtc-snapshot.h: removed

	* crtc/Makefile.am: removed crtc-snapshot.h

	* crtc/crtc.c: remove many bogus prints
	(crtc_raster_draw_alarm_handler): fix a timing bug (frame was
	one rasterline long), also make vsync appear at right place again.
	change handling of crtc.framelines: now stays constant

1999-07-12  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.46.

	* c128/c128mmu.c, c128/c128mmu.h: New files.

	* c128/c128mem.c (mem_update_config, mem_set_ram_bank,
	mem_set_ram_config): New functions.

1999-07-12  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/*: added support for keymap definition files, made
	keyboard handling more generic.

	* arch/riscos/ui.c: display text in info.c

	* arch/riscos/uimsgwin.*: new window for displaying long text.

	* arch/riscos/vsidui.*: dummies for vsid.

	* arch/riscos/Makefile.am: for a change I remembered to register
	the new files ;-).

1999-07-12  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.45.

	* arch/unix/kbd.c, arch/unix/kbd.h: (kbd_parse_entry): Added
	support for 40/80 column key.
	(kbd_register_column4080_key): New function.
	* arch/msdos/kbd.c, arch/msdos/kbd.h, arch/win32/kbd.c,
	arch/win32/kbd.h, arch/riscos/kbd.c, arch/riscos/kbd.h,
	arch/os2/kbd.c, arch/os2/kbd.h: Changed likewise.

	* c128/c128mem.c (mmu_toggle_column4080_key): New function.
	(read_mmu): Set the correct value for the 40/80 column key.

1999-07-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.44.

	* cartridge.h, c64/cartridge.c, c64/cartmem.c: New cartridge type
	"Atomic Power".

	* arch/unix/xaw/c64ui.c, arch/msdos/c64ui.c, arch/win32/c64ui.c,
	arch/win32/res.h, arch/win32/resc64.rc: Added Atomic Power
	cartridge.

	* drive/via2drive0.c, drive/via2drive1.c (store_pcr): Do not
	modify return value.

	* c64/c64.c (machine_init, machine_shutdown): Do not reference
	VSID related functions when no VSID support is available.
	Only include `vsidui.h' when the architecture provides this file.

	* attach.c (file_system_get_disk_name): Return `NULL' if no name
	is available.

	* arch/msdos/c64ui.c (custom_palette_callback): New function.
	* arch/msdos/c128ui.c (custom_palette_callback): New function.
	* arch/msdos/petui.c (custom_palette_callback): New function.
	* arch/msdos/c610ui.c (custom_palette_callback): New function.

1999-07-08  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* cbm2/c610.c (machine_init): use crtc_set_retrace_*

	* cbm2/c610tpi1.c (tpi_set_ca): use crtc_set_chargen_offset

	* crtc/crtc-draw.c (DRAW): handle hardware cursor
	mask screen address with vaddr_mask (screen wraparound)
	(draw_standard_line): draw two parts, the one left of the 
	current crtc rasterline (left of the first char in the line)
	and the current rasterline (from the first char in the line on)
	(draw_reverse_line): likewise

	* crtc/crtc-mem.c (store_crtc): call alarm only when CRTC
	is initialized
	handle hardware cursor registers
	(read_crtc): return correct values

	* crtc/crtc.c (CRTC_SCREEN_WIDTH, CRTC_SCREEN_HEIGHT): removed
	(crtc_update_window): renamed from crtc_update_screen.
	Set the raster geometry here, as well as x/ystart/stop
	(crtc_set_retrace_callback): split into crtc_set_retrace_callback
	and crtc_set_retrace_type
	(crtc_init): move viewport and window init to crtc_update_window
	(crtc_reset): reset some more registers
	(crtc_raster_draw_alarm_handler): tons of fixes: compute
	x/y offset to center the screen in the window, incl. jitter
	when the phase of the horizontal sync changes
	Rasterline counting are now different from raster code and
	crtc code. CRTC counts its internal counters
	Call IRQ routines according to vsync or venable, depending on 
	PET model (i.e. retrace type)
	(crtc_offscreen): return vertical retrace according to 
	retrace type
	(crtc_screen_enable): set blank 

	* crtc/crtc.h (crtc_t): hw_cols replaces hw_double_cols
	sync_diff counts the cycles between the last two sync pulses
	prev_screen_rel is needed to draw the part left of the first
	character in the line
	hjitter computes the jitter when the hsync phase changes
	screen_xoffset, screen_yoffset offset of upper left
	corner of CRTC screen in raster frame
	current_line, framelines, vsync new variables
	crsrmode, crsrcnt, crsrstate new variables for hardware cursor
	handling
	(CRTC_SCREEN_BORDERWIDTH, CRTC_SCREEN_BORDERHEIGHT): 
	the border where CRTC never paints
	(CRTC_EXTRA_COLS, CRTC_EXTRA_RASTERLINES): border around
	the machine defaults (40/80x25) where we can paint border 
	effects

	* pet/Makefile.am (libpet_a_SOURCES): remove crtc.c

	* pet/crtc.c: removed

	* pet/pet.c (machine_init): use crtc_set_retrace_type, 
	crtc_set_retrace_callback.
	Call pet_crtc_set_screen instead of via mem_load
	(pet_crtc_set_screen): new function, copied from 
	petmem.c: set_screen.

	* pet/pet.h (pet_crtc_set_screen): add prototype

	* pet/petmem.c (set_screen): removed
	(mem_load): do not call set_screen, but initialize_memory only
	(mem_read_ram_snapshot_module): call initialize_memory
	and pet_crtc_set_screen

	* pet/petvia.c (VIA_SET_CA2): use crtc_set_chargen_offset
	(undump_pcr): rely on VIA_SET_C*
	(store_pcr): do not return a value

	* raster/raster.c (raster_handle_end_of_frame): new exported
	function to export handle_end_of_frame()

	* raster/raster.h (raster_handle_end_of_frame): new prototype

	* viacore.c (store_myvia): do not set pcr value to return value
	from store_pcr()

1999-07-10  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.43.

	* arch/Makefile.am: Added OS2 directory.

	* arch/os2/Makefile.am, arch/os2/pm/Makefile.am: New files.

1999-07-08  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* cbm2/c610.c (machine_init): use crtc_set_retrace_*

	* cbm2/c610tpi1.c (tpi_set_ca): use crtc_set_chargen_offset

	* crtc/crtc-draw.c (DRAW): handle hardware cursor
	mask screen address with vaddr_mask (screen wraparound)
	(draw_standard_line): draw two parts, the one left of the 
	current crtc rasterline (left of the first char in the line)
	and the current rasterline (from the first char in the line on)
	(draw_reverse_line): likewise

	* crtc/crtc-mem.c (store_crtc): call alarm only when CRTC
	is initialized
	handle hardware cursor registers
	(read_crtc): return correct values

	* crtc/crtc.c (CRTC_SCREEN_WIDTH, CRTC_SCREEN_HEIGHT): removed
	(crtc_update_window): renamed from crtc_update_screen.
	Set the raster geometry here, as well as x/ystart/stop
	(crtc_set_retrace_callback): split into crtc_set_retrace_callback
	and crtc_set_retrace_type
	(crtc_init): move viewport and window init to crtc_update_window
	(crtc_reset): reset some more registers
	(crtc_raster_draw_alarm_handler): tons of fixes: compute
	x/y offset to center the screen in the window, incl. jitter
	when the phase of the horizontal sync changes
	Rasterline counting are now different from raster code and
	crtc code. CRTC counts its internal counters
	Call IRQ routines according to vsync or venable, depending on 
	PET model (i.e. retrace type)
	(crtc_offscreen): return vertical retrace according to 
	retrace type
	(crtc_screen_enable): set blank 

	* crtc/crtc.h (crtc_t): hw_cols replaces hw_double_cols
	sync_diff counts the cycles between the last two sync pulses
	prev_screen_rel is needed to draw the part left of the first
	vcharacter in the line
	hjitter computes the jitter when the hsync phase changes
	screen_xoffset, screen_yoffset offset of upper left
	corner of CRTC screen in raster frame
	current_line, framelines, vsync new variables
	crsrmode, crsrcnt, crsrstate new variables for hardware cursor
	handling
	(CRTC_SCREEN_BORDERWIDTH, CRTC_SCREEN_BORDERHEIGHT): 
	the border where CRTC never paints
	(CRTC_EXTRA_COLS, CRTC_EXTRA_RASTERLINES): border around
	the machine defaults (40/80x25) where we can paint border 
	effects

	* pet/Makefile.am (libpet_a_SOURCES): remove crtc.c

	* pet/crtc.c: removed

	* pet/pet.c (machine_init): use crtc_set_retrace_type, 
	crtc_set_retrace_callback.
	Call pet_crtc_set_screen instead of via mem_load
	(pet_crtc_set_screen): new function, copied from 
	petmem.c: set_screen.

	* pet/pet.h (pet_crtc_set_screen): add prototype

	* pet/petmem.c (set_screen): removed
	(mem_load): do not call set_screen, but initialize_memory only
	(mem_read_ram_snapshot_module): call initialize_memory
	and pet_crtc_set_screen

	* pet/petvia.c (VIA_SET_CA2): use crtc_set_chargen_offset
	(undump_pcr): rely on VIA_SET_C*
	(store_pcr): do not return a value

	* raster/raster.c (raster_handle_end_of_frame): new exported
	function to export handle_end_of_frame()

	* raster/raster.h (raster_handle_end_of_frame): new prototype

	* viacore.c (store_myvia): do not set pcr value to return value
	from store_pcr()

1999-07-07  Thomas Bretz  <tbretz@physik.tu-muenchen.de>

	* arch/os2/*: New directory.

1999-07-02  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.42.

	* attach.c (file_system_detach_disk): Do not attach disks without
	vdrive emulation enabled.

	* arch/unix/xaw/ui.c (ui_display_drive_current_image): Discard
	drive 2 and 3.

	* c1541.c (format_cmd): Added support for G64 images.
	(gcrformat_cmd, set_label, set_disk_size): Removed.
	(zcreate_cmd, block_cmd): Rewritten.

	* diskimage.c (disk_image_create): Also create G64 images.

	* vdrive/vdrive.c (vdrive_command_format): Only format disk if
	some disk image is attached.
	(vdrive_attach_image): Virtual drive emulation has to calculate
	with the logical number of sectors.

	* vdrive/vdrive.h: `NumBlocks' removed.

	* c64/Makefile.am: Removed `libc64vsid.a'.

1999-07-02  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.41.

	* c1541.c (check_drive, info_cmd): Changed to new disk image
	access.
	(create_image): Removed.
	(open_image): Use `disk_image_create'.

	* diskimage.c (disk_image_create): New function.

	* arch/unix/joystick.c (old_joystick): Use correct joystick
	number.

	* vicii/vicii-draw.c (init_drawing_tables): Removed unused
	variables.

1999-07-02  Dag Lem  <resid@nimrod.no>

	* arch/unix/xaw/Makefile.am: Added vsidui.h.

	* arch/unix/xaw/ui.c: Replaced pthread with fork().
	* arch/unix/xaw/ui.h: Likewise.
	* arch/unix/xaw/vsidui.c: Likewise.

	* arch/unix/xaw/vsidui.h: New file.

	* c64/c64.c: Includes vsidui.h

	* raster/raster.c: More checks for console and psid mode.

	* sound.c (closesound): No GUI if console or psid mode is active.

1999-07-01  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* crtc/crtc-draw.c (DRAW): use xoffset for smooth-scrolling

	* crtc/crtc.c (crtc_reset_screen_ptr): set correct values
	for display_xstop, display_ystop
	(crtc_raster_draw_alarm_handler) the charline counter is 7 bit only,
	mask the bits. Also set rl_start.

1999-06-30  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.40.

	* arch/unix/xaw/ui.c: Define `_MIT_POSIX_THREADS'.

	* diskimage.c (disk_image_read_track): New function.
	(disk_image_read_sector): Use new track read function.

	* gcr.c, gcr.h (gcr_read_sector): Rewritten to be more universal.

	* imagecontents.c (open_disk_image): Do not alocate GCR buffer.

1999-06-28  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/*: fixed remaining problems with multiple canvases.

	* raster/raster.c: workaround for the case where colour number 0
	is not black.

1999-06-28  Dag Lem  <resid@nimrod.no>

	* arch/unix/xaw/Makefile.am: Added vsidui.c.

	* arch/unix/xaw/ui.c (ui_exit_thread, ui_thread_start,
	ui_create_thread, ui_join_thread, ui_init_finish,
	ui_dispatch_events): Separate thread for PSID UI.

	* arch/unix/xaw/ui.h: Flag for PSID UI thread operation.

	* arch/unix/xaw/uimenu.c (menu_popup_callback): Keep sound running
	in psid mode.

	* arch/unix/xaw/vsidui.c: New file.

	* c64/c64.c: psid and console mode corrections.

	* c64/psid.c: New command line switch -psid to start up in psid
	mode without a selected PSID file.

	* main.c: Allow startup in psid mode without a selected PSID file.

	* raster/raster.c (update_canvas, update_canvas_all): Skip canvas
	updates in psid and console mode.

	* sound.c (sound_flush): Only do clkfactor magic for adjusting
	sound.
	
1999-06-26  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.39.

	* vicii/vicii.c (vic_ii_update_memory_ptrs): Allow the use of the
	upper charset in Ultimax mode.

	* c64/c64cia2.c (do_reset_cia): Initialize video bank.

	* arch/msdos/uisnapshot.c (write_snapshot_callback): Check for
	NULL pointer.

1999-06-24  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/*: general cleanup (char[] -> const char[] etc.)

	* arch/riscos/archdep.c: properly initialize monitor console.

	* arch/riscos/kbd.c, arch/riscos/video.*, arch/riscos/vsync.c,
	arch/riscos/ui.*: added support for multiple canvases.

	* arch/riscos/ui.c: added support for coredumps.

	* raster/raster.c: catch case of undefined palette on a mode
	change (current VDC implementation requires this)

1999-06-20  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.38.

	* c1541.c: Adapted to new attach routines.
	(floppy_read_directory): Moved here.

	* drive/drive.c (drive_enable): Reattach disk image.

	* drive/drive-dir.c (vdrive_dir_create_directory): Removed
	parameter `secondary'.

	* vdrive/vdrive.c, vdrive/vdrive.h, vdrive/vdrive-iec.c,
	(fsdevice.c,  vdrive_close_all_channels, vdrive_parse_name):
	Renamed.

	* vdrive/vdrive-iec.c, vdrive/vdrive-dir.c, vdrive/vdrive.c:
	Use the new logging system.

	* vdrive/vdrive.c, drive/drive.c, drive/drivecpu.h, attach.c,
	drive/drivecpu0.c, drive/drivecpu1.c, drive/wd1770.c, tape.c:
	Removed silly includes.

	* utils.c, resources.c, zfile.c, archapi.h, arch/unix/archdep.c,
	arch/msdos/archdep.c, arch/win32/archdep.c, arch/riscos/archdep.c
	(make_backup_filename): Moved to architecture specific files.

	* arch/msdos/menudefs.c (quit_callback): Call
	`file_system_detach_disk'.

1999-06-13  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.37.

	* drive/drive.c (drive_read_image_gcr): Use disk image access
	function instead.
	(drive_detach_image): Clear the read only bit if no disk is
	inserted.

	* c1541.c: Adapted to new attach routines.

	* attach.c (file_system_attach_disk): Only change type of drive if
	the disk image could be attached successfully.
	(detach_disk_image): Only detach disk if there is a disk to
	detach.

	* vdrive/vdrive.h, vdrive/vdrive-iec.c, vdrive/vdrive.c: Changed
	`ReadOnly' to `read_only'.

1999-06-13  Markus Brenner  <brenner@biochem.mpg.de>

	* vdc/*: Moved VDC implementation here.

1999-06-13  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* cbm2/c610mem.c (crtc_ptr): removed
	(store_io, read_io): do not use saved crtc register index
	* pet/petmem.c: likewise

	* crtc/crtc-draw.c (DRAW): fix ycounter
	(draw_standard_line, draw_reverse_line): use disp_char instead of 
	memptr_inc

	* crtc/crtc-mem.c (store_crtc): adapt to new crtc code
	* crtc/crtc.c: fixes
	(crtc_raster_draw_alarm_handler): adapt to new crtc code

	* crtc/crtc.h (crtc_t): new entries

1999-06-12  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.36.

	* imagecontents.c (open_disk_image, close_disk_image): Added
	support for GCR images.

	* vdrive.h: Removed cruft.

	* diskimage.c, diskimage.h (disk_image_write_track,
	disk_image_read_gcr_image): New functions.

	* gcr.c, gcr.h (gcr_find_sector_header, gcr_find_sector_data,
	gcr_read_sector, gcr_write_sector, gcr_create_image,
	gcr_destroy_image): New function.

	* drive/drive.c (drive_read_block, drive_write_block): Removed.

1999-06-12  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.35.

	* prdevice.c (prdevice_attach): Do not pass info pointer.

	* attach.c (attach_disk_image): Detach old disk image.

	* diskimage.c (disk_image_read_sector, disk_image_write_sector):
	Better error logging.

	* vdrive/vdrive.c, vdrive/vdrive.h, vdrive/vdrive-bam.c,
	vdrive/vdrive-dir.c, vdrive/vdrive-bam.c: Removed `D64_Header',
	`GCR_Header' and `ActiveName'.  Renamed `ImageFormat' to
	`image_format'.  Separated disk image type from the type of drive
	emulated.

1999-06-11  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.34.

	* vdrive/vdrive.c (set_disk_geometry): Log usage unknown disk
	types.
	(vdrive_setup_device): Initialize disk geometry and file system
	where it belongs and not here.

	* attach.c (file_system_set_serial_hooks): New function.
	(file_system_get_vdrive): New function.

	* fsdevice.c (attach_fsdevice): Renamed.
	(read_fs, write_fs, open_fs, close_fs, flush_fs): Made static.

	* vdrive/vdrive-iec.c (vdrive_iec_attach): New function.
	(vdrive_open): Check if disk image is present.

	* maincpu.c (reset): Do not reset serial devices.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c, cbm2/c610.c
	(machine_reset): Reset serial devices.

	* serial.c, serial.h: Removed `info' from struct `serial_t'.

	* attach.c, mon.c, vdrive/vdrive-bam.c: Do not use `serial_t'.

1999-06-10  Ettore Perazzoli  <ettore@comm2000.it>

	* raster/raster.c (handle_end_of_frame): Removed `#if 0'ed parts.
	(raster_emulate_line): Likewise.
	(raster_set_geometry): Initialize the cache.
	(update_for_minor_changes_with_sprites): Fill space between border
	and start of graphics *before* drawing sprites.  Draw sprites only
	if necessary.  Draw borders again if sprites have been drawn.

	* main.c: #include <ctype.h>
	(replace_hexcodes): Make it work.  Really.
	(hexstring_to_byte): New Helper function for `replace_hexcodes()'.
	(main): Use the string with hexcodes replaced, not the original
	one.

1999-06-09  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.33.

	* tap.c, tap.h (tap_open): Try to open read only as well.

	* datasette.c (datasette_control): Do not write if opened read
	only.

	* arch/win32/ui.c (handle_wm_command): Allow to autostart TAP
	images.

	* serial.c, serial.h (serial_remove_file, serial_select_file):
	Removed.

	* prdevice.c (detach_prdevice, attach_prdevice): Removed.

	* vdrive/vdrive.h, vdrive/vdrive.c (get_diskformat): Removed.

	* attach.c: Do not use DT_* defines anymore.
	(detach_disk_image): Actually detach disk image.

	* imagecontents.c (image_contents_read_disk, open_disk_image,
	close_disk_image): Rewritten for new attach code.

	* diskimage.c (disk_image_close): Free disk image name.

	* c1541.c (main): Switched from `initialize_1541' to
	`vdrive_setup_device'.

1999-06-06  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.32.

	* drive/fdc.c, drive/fdc.h: Adapted to new attach mechanism.

	* attach.c (attach_disk_image, detach_disk_image): Attach disk for
	the FDC emulation here.
	(file_system_get_disk_name): New function.

	* drive/drive.c, drive/drive.h (drive_attach_image,
	drive_detach_image): Struct `DRIVE' is not needed anymore.

	* vdrive/vdrive-bam.h, vdrive/vdrive-bam.c
	(vdrive_bam_get_disk_id, vdrive_bam_set_disk_id): Do not use
	struct `DRIVE'.

	* vdrive/vdrive.c, vdrive/vdrive.h, vdrive/vdrive-bam.h,
	vdrive/vdrive-bam.c, vdrive/vdrive-dir.h, vdrive/vdrive-dir.c,
	vdrive/vdrive-iec.c, attach.c, fsdevice.c, imagecontents.c, mon.c,
	c1541.c: Use `vdrive_t' instead of `DRIVE'.

	* serial.c (serial_get_file_name): Removed.

	* arch/win32/uiattach.c (init_dialog): Use
	`file_system_get_disk_name' instead of `serial_get_file_name'.
	* arch/msdos/menudefs.c: Changed likewise.

	* vdrive/vdrive.c, vdrive/vdrive.h (vdrive_setup_device): New
	function replacing `initialize_1541'.
	(floppy_read_block, floppy_write_block): Removed.

	* vdrive/vdrive-bam.c, vdrive/vdrive-dir.c, vdrive/vdrive-iec.c,
	vdrive/vdrive.c, attach.c, imagecontents.c, mon.c: Do not use
	`ActiveFd', `floppy_read_block' and `floppy_write_block' anymore.

1999-06-06  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.31.

	* diskimage.c (disk_image_close): New function.
	Use separate logging.  (disk_image_check_sector): Moved here.
	(disk_image_sector_per_track): New function replacing those ugly
	global sector tables.
	(disk_image_read_sector, disk_image_write_sector): New functions.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c, cbm2/c610.c
	(machine_shutdown): Detach all disk images.
	(machine_init): No need to initialize special attach hooks.

	* drive/drive.c (drive_attach_floppy, drive_detach_floppy): Use
	new attach mechanism.

	* attach.c (file_system_set_hooks): Removed.
	(attach_disk_image, detach_disk_image): New functions.
	(file_system_attach_disk, file_system_detach_disk): Use new attach
	or detach functions.
	(file_system_init, set_file_system_device8,
	set_file_system_device9, set_file_system_device10,
	set_file_system_device11, file_system_attach_disk): Do not
	initialize attach/detach function pointer.

	* vdrive/vdrive.h: Removed attach/detach function pointer from
	struct `DRIVE'.

	* vdrive/vdrive.c (initialize_1541): Removed attach/detach
	function pointer handling.

	* drive/wd1770.c, drive/wd1770.h (wd1770_attach_image,
	wd1770_detach_disk): Separated from the 1541/71 drive emulation.
	Do not use struct `DRIVE' anymore.

	* drive/drive.c, vdrive/vdrive-bam.c, vdrive/vdrive-dir.c: Use
	`disk_image_sector_per_track' to retrive number of sectors.

	* vdrive/vdrive-bam.h, vdrive/vdrive-bam.c
	(vdrive_bam_reread_bam): Temporary hack.

1999-06-05  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.30.

	* diskimage.h, diskimage.c: New files.

	* vdrive/vdrive.h: Moved around some definfitions.

	* vdrive/vdrive-dir.c (vdrive_dir_create_directory): Moved here.

	* vdrive/vdrive.c (vdrive_attach_image, vdrive_detach_image):
	New functions.
	(attach_floppy_image, check_header, import_GCR_image,
	get_std64_header, get_std71_header, get_std81_header,
	get_std80_header, get_std82_header): Obsolete.

	* serial.h: Added pointer to image data struct to `serial_t'.

	* serial.c (serial_select_file): Do not use this function for
	attaching disk images.

	* attach.c (file_system_init): Initialize disk image struct.

1999-06-05  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.29.

	* Makefile.am: Added `libvdrive.a'.

	* c64/Makefile.am, c128/Makefile.am, vic20/Makefile.am,
	pet/Makefile.am, cbm2/Makefile.am: Added vdrive directory.

	* vdrive.c, vdrive.h, vdrive-iec.c, vdrive-iec.h: Moved into
	separate directory.  Removed old cruft.

	* drive/drive.c, drive/drive.h: Do not mix drive and vdrive
	related varibales anymore.

	* drive/fdc.c, drive/fdc.h (fdc_attach_disk, fdc_detach_disk):
	New functions.  Use own vdrive struct instead of using the one of
	the drive emulation.
	* drive/wd1770.c, drive/wd1770.h: Changed likewise.

	* attach.c: Fixed type of attach/detach functions.

	* arch/unix/xaw/uicommands.c, arch/msdos/menudefs.c, maincpu.c,
	pet/pet.c: Do not #include "vdrive.h".

	* fs_cbm.h: Removed.

	* vic20/vic20.c, pet/pet.c, cbm2/c610.c, vdrive/vdrive-iec.c,
	attach.c, fsdevice.c, mon.c: #include "serial.h".

	* vdrive/vdrive-dir.c, vdrive/vdrive-dir.h, vdrive/vdrive-bam.c,
	vdrive/vdrive-bam.h: New files.

	* imagecontents.c, c1541.c: #include "vdrive-dir.h".

	* c1541.c, drive/fdc.c, drive/drive.c, imagecontents.c:
	vdrive/vdrive-iec.c, vdrive/vdrive-dir.c: #include "vdrive-bam.h"

1999-05-30  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.28.

	* sysfile.c (set_system_path): Use `archdep_path_is_relative' to
	determine type of path.

	* resources.c (make_backup_file_name): Use the function from
	`utils.c'.

	* arch/unix/archdep.h, arch/msdos/archdep.h, arch/win32/archdep.h,
	arch/riscos/archdep.h: Defined `fopen' text modes here.

	* main.c (MAIN_PROGRAM): Removed some cruft.

	* arch/win32/archdep.c, arch/msdos/archdep.c: Removed
	#include "findpath.h".

	* zfile.c, zfile.h (zopen, zclose): Removed.

	* mon_parse.y, autostart.c, arch/unix/video.c, arch/unix/xaw/ui.c,
	arch/msdos/tuifs.c, arch/msdos/video.c, warn.c, arch/win32/kbd.c,
	arch/win32/winmain.c: Use `xmalloc'.

1999-06-01  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/config.h, arch/riscos/Makefile.am: forgot to add
	config.h to Makefile.am the last time.

	* raster/raster.c: define RECALC_FRAME_BUFFER on RISC OS for now.

1999-06-01  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/Makefile.am: Added crtc.dsp and raster.dsp.

	* arch/win32/crtc.dsp, arch/win32/raster.dsp: Files were not
	  included in last patch.

	* sounddrv/sounddx.c (dx_init): Fixed 16/8 bit soundcard detection.

1999-05-30  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.27.

	* datasette.c (datasette_read_bit): Adjusted zero delay value.
	(datasette_set_motor): Set motor on delay to 10000 clock ticks.

	* drive/drive.c (drive_set_clock_frequency): New function.

	* findpath.c, fsdevice.c, mon.c, utils.c, vdrive.c, zfile.c,
	c1541.c, drive/drive.c: Include `unistd.h' if present.

	* c64/c64.c, c128/c128.c, vic20/vic20.c, pet/pet.c, cbm2/c610.c,
	snapshot.c: Use `remove_file' instead of `unlink'.
	Removed #include <unistd.h>.

	* utils.c, utils.h (remove_file): New function.

	* findpath.h, tape.c, vdrive-iec.c, zipcode.c: Removed #include
	<unistd.h>.

	* arch/unix/archdep.h, arch/msdos/archdep.h, arch/win32/archdep.h,
	arch/riscos/archdep.h: Moved path separator here.

	* sysfile.c: #include <unistd.h>.

	* fsdevice.c, zfile.c: Use `remove_file' instead of `unlink'.

	* main.c Removed #include "findpath.h".

	* resource.c, utils.c, arch/win32/archdep.c: Include `dir.h' if
	present.

	* arch/unix/readline/editline.h, os9.h,
	arch/unix/readline/Makefile.am, arch/unix/readline/sysos9.c:
	Removed obsolete OS9 support.

	* arch/msdos/kbd.c, arch/msdos/menudefs.c: Added drive parameter
	for `flip_add_image' and `flip_attach_head'.

1999-05-28  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.26.

	* raster/raster.c: Do not define `RECALC_FRAME_BUFFER' for now.

1999-05-25  Andreas Dehmel  <dehmel@forwiss.tu-muenchen.de>

	* arch/riscos/*: now compiles again; added optional status bar
	in full screen mode.

	* arch/riscos/ui.c: added 1001 drive, fixed pause bug.

	* arch/riscos/config.h: moved configuration file to arch-module.

	* drive/drive.c: changed ui_display_drive_track to
	ui_display_drive_track_int on RISC OS (a double is totally useless
	here anyway)

	* raster/raster.[ch]: added support for mode changes which require
	rebuilding all internal colour tables. A callback function was
	added to raster_t which has to be initialized by the raster client
	(vicii, crtc, ...). A list of active rasters is kept internally.
	raster_mode_change() rebuilds everything for the new mode.

	* crtc/crtc-draw.c, vicii-draw.c, vic-draw.c: register table refresh
	function (init_drawing_tables()) to the raster module.

	* vic20/vic.c: needs to include vsync.h

	* vic20/vic-mem.c: needs to include vic20sound.h

1999-05-25  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.25.

	* Makefile.am: Removed `@LEXLIB@' from `common_libs'.

	* arch/win32/ui.c (handle_wm_command): Fixed `flip_*' calls.

1999-05-25  Tibor Biczo  <crown@mail.matav.hu>

	* arch/win32/c128.dsp, arch/win32/c64.dsp, arch/win32/c64c128.dsp:
	  Added raster dir to include search path.

	* arch/win32/c1541.dsp, arch/win32/petcat.dsp: Removed unnecessary
	  library files.

	* arch/win32/cbm2.dsp, arch/win32/pet.dsp: Added crtc and raster dirs
	  to include search path.

	* arch/win32/crtc.dsp: New MSVC project file for crtc library.

	* arch/win32/msvc/config.h: Define __i386__ to allow unaligned
	  memory access.

	* arch/win32/raster.dsp: New MSVC project file for raster library.

	* arch/win32/ui.c (window_proc): Handle WM_ERASEBKGND message.
	  Switched back to old WM_PAINT handling method.

	* arch/win32/vic20.dsp: Added raster dir to include search path.
	  Added vic-cmdline-options.c, vic-draw.c, vic-mem.c, vic-resources.c,
	  vic-snapshot.c.

	* arch/win32/vice.dsw: Added crtc and raster project. Updated
	  subproject dependencies.

	* arch/win32/vicii.dsp: Added raster dir to include search path.
	  Added vicii-cmdline-options.c, vicii-draw.c, vicii-mem.c,
	  vicii-resources.c, vicii-snapshot.c, vicii-sprites.c.

	* arch/win32/video.c (canvas_refresh): Switched back to old version.

	* arch/win32/x128.dsp, arch/win32/x64.dsp, arch/win32/xcbm2.dsp,
	  arch/win32/xpet.dsp, arch/win32/xvic.dsp: Removed memutils.c.

	* vicii/vicii-mem.c (vic_ii_local_store_vbank): New function.
	  It is the same as the old store_vbank.
	  (store_vbank, store_vbank_39xx, store_vbank_3fxx) Call
	  vic_ii_local_store_vbank instead of store_vbank.

1999-05-24  Martin Pottendorfer  <Martin.Pottendorfer@alcate.at>

	* arch/unix/xaw/uicommands.c: Reworked `fliplist' callbacks and
	helper functions completely.
	(UI_CALLBACK): Commented `button' variable, to keep compiler
	quiet.

	* arch/unix/xaw/ui.h: Added `NUM_DRIVES'. Added a few prototypes
	for drive-fliplist menus.

	* arch/unix/xaw/ui.c: Added static vars: drive8_menu, drive9_menu,
	drive8_menu_translations, drive9_menu_translations.
	Moved `NUM_DRIVES' to ui.h.
	Made `last_attached_images[]' external visible.
	`last_attached_images[]' now contains the full image paths.
	(ui_set_drive8_menu): New function. Adds fliplist popup window for
	drive 8.
	(ui_set_drive9_menu): New function. Adds fliplist popup window for
	drive 9.
	(ui_display_drive_current_image): Update flipmenu for
	`drive_number'.
	(ui_display_drive_current_image2): Just display the basename from
	`last_attached_images[]'. 
	
	* fliplist.h:
	Added a few new interface funtions, Changed interface to expect a unit
	in order to distinguish fliplists for different drives.

	* fliplist.c (ALL): Reworked completely, introduced fliplists for
	multiple drives. Added iterator functions.

1999-05-25  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.24.

	* drive/drive.c, c64/c64mem.c, c128/c128mem.c, vic20/vic20mem.c,
	pet/petmem.c, cbm2/c610mem.c: Removed include "memutils.h".
	Renamed `mem_load_sys_file' to `sysfile_load'.

	* arch/unix/kbd.c: Removed include "memutils.h".

	* sysfile.c (mem_load_sys_file): Moved here.  Use `file_length()'
	to determine length of file.

	* utils.c, utils.h (file_length): Use the `ftell' approach for all
	architectures.  Removed #include <sys/stat.h>.

	* memutils.h, memutils.c: Removed.

	* drive/drive.c, utils.c, utils.h, attach.c, imagecontents.c,
	vdrive.c, c1541.c, zipcode.h, zipcode.c, zfile.c, vdrive-iec.c:
	Changed to ISO C stream functions.

	* arch/unix/types.h, arch/win32/types.h, arch/msdos/types.h,
	arch/riscos/types.h: Removed file descriptor hack.

1999-05-24  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.23.

	* arch/msdos/menudefs.c (rom_submenu): The name for the default
	rom set is "default.vrs" and not `NULL'.
	(ui_create_main_menu): Move working directory entry to special
	settings.

	* romset.c (romset_load): Check for `NULL'.

	* arch/msdos/c64ui.c (rom_menu_items): Added `DosName1001.
	(c64_ui_init): Added c64 specific ROM set entries.

	* arch/msdos/c128ui.c (rom_menu_items): Added c128 specific ROM
	set entries.
	* arch/msdos/vic20ui.c (rom_menu_items): Changed likewise.
	* arch/msdos/petui.c (rom_menu_items): Changed likewise.
	* arch/msdos/c610.c (rom_menu_items): Changed likewise.

	* arch/msdos/vic20ui.c, arch/msdos/petui.c, arch/msdos/c610.c:
	#include <stdlib.h>.

	* arch/unix/xaw/c128ui.c (c128_romset_submenu): Added missing
	drive entries.

	* arch/msdos/ui.h, arch/msdos/ui.c, arch/win32/ui.h,
	arch/win32/ui.c, arch/unix/xaw/ui.h, arch/unix/xaw/ui.c,
	arch/riscos/ui.h, arch/riscos/ui.c
	(ui_display_drive_current_image): Filename has to be `const'.
	Moved common UI pototypes to `uiapi.h'.

	* uiapi.h: New file.

	* arch/msdos/grabkey.c (my_kbd_interrupt_handler_end): Commented
	out.

	* zfile.c (try_uncompress_with_tzx): New function.

1999-05-24  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.22.

	* fsdevice (fs_find_pc64_name): Added missing `closedir'.
	(fsdevice_compare_wildcards): Check the whole P00 name.

	* zfile.c: Updated known extensions.  Added `pkunzip' to the list
	of valid archives (experimental for now).

1999-05-24  Dag Lem  <resid@nimrod.no>

	* c64/c64.c (machine_init): Don't check return value from
	vic_ii_init in console and psid mode

	* main.c (main): Skip UI calls in console mode

	* raster/raster.c: Skip frame buffer access in console and psid
	mode

1999-05-24  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* cbm2/c610.c (cbm2_crtc_signal): new callback function for
	CRTC vertical retrace signal change
	(machine_init): call crtc_set_retrace_callback()

	* pet/pet.c (pet_crtc_signal): new callback for retrace signal
	(machine_init): call crtc_set_retrace_callback()

	* crtc/crtc-draw.c (DRAW): use start and end screen columns
	Use offset 2 for characters in PIXEL4 coordinates

	* crtc/crtc.c (crtc_set_retrace_callback): new function
	(crtc_raster_draw_alarm_handler): handle ycounter and 
	update screen_rel. Also call retrace callback function when
	appropriate
	(crtc_offscreen): check rasterline and give more appropriate 
	values

	* crtc/crtc.h (machine_crtc_retrace_signal_t): new type
	(crtc_set_retrace_callback): new prototype
	(crtc_t): added retrace_callback, retrace_type components

1999-05-23  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* arch/unix/xaw/petui.c (CrtcPaletteFile): renamed from PaletteFile
	(ui_menu_entry_t palette_submenu): use CrtcPaletteFile

	* cbm2/c610mem.c (mem_load_chargen): call crtc_set_chargen_addr
	(mem_load): use new crtc interface
	* pet/petmem.c: likewise

	* crtc/crtc-draw.c (dwg_table_0,  dwg_table_1, dwg_table2x_0,
	dwg_table2x_1, dwg_table2x_2, dwg_table2x_3): new tables
	(init_drawing_tables): init the dwg_tables.
	(draw_standard_background): copied from vicii-draw.c
	(draw_standard_background_2x): copied from vicii-draw.c
	(DRAW): new function, made from old DRAW define 
	(draw_standard_line, draw_reverse_line): new functions
	(setup_single_size_modes): setup non-caching mode

	* crtc/crtc-resources.c (resources): rename "PaletteFile"
	to "CrtcPaletteFile". Set video cache off by default

	* crtc/crtc.c (CRTC_SCREEN_ADDR, CRTC_SCREEN_WIDTH,
	CRTC_SCREEN_HEIGHT, CRTC_SCREEN_TEXTCOLS, CRTC_SCREEN_TEXTLINES,
	CRTC_SCREEN_XPIX, CRTC_SCREEN_YPIX, CRTC_FIRST_DISPLAYED_LINE,
	CRTC_LAST_DISPLAYED_LINE, CRTC_CYCLES_PER_LINE): new defines
	(crtc_reset_screen_ptr, crtc_update_chargen_rel, 
	crtc_update_memptr_inc, crtc_update_screen, crtc_set_screen_addr,
	crtc_set_chargen_offset, crtc_set_chargen_addr,
	crtc_set_screen_options, crtc_set_hw_options): new functions
	(crtc_init): do some sanity checks
	(crtc_reset): call crtc_reset_screen_ptr()
	(crtc_set_screen_mode): removed
	(crtc_raster_draw_alarm_handler): call crtc_reset_screen_ptr()
	on vsync
	(crtc_set_char); removed

	* crtc/crtc.h (crtc_t): new elements
	(CRTC_SCREEN_BORDERWIDTH, CRTC_SCREEN_BORDERHEIGHT):
	new defines
	(crtc_set_screen_addr, crtc_set_chargen_offset,
	crtc_set_chargen_addr,  crtc_set_screen_options, 
	crtc_set_hw_options): new prototypes
	(crtc_set_screen_mode): removed prototype

1999-05-22  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.21.

	* fsdevice.c (fsdevice_create_file_p00): Removed double extension.
	Use proper modes for `fopen()'.

	* arch/unix/archdep.h, arch/msdos/archdep.h, arch/win32/archdep.h,
	arch/riscos/archdep.h: New mode `MODE_APPEND_READ_WRITE'.

	* arch/unix/archdep.c, arch/msdos/archdep.c, arch/win32/archdep.c,
	arch/riscos/archdep.c, archapi.h (archdep_open_monitor_console,
	archdep_close_monitor_console): New functions.

	* mon.c (mon): Use architecture specific functions to open and
	close the monitor console.

	* c1541.c, petcat.c (enable_text, disable_text): Stubs.

	* autostart.c (autostart_prg): Use `archdep_path_is_relative'.

	* utils.c, utils.h (path_is_relative): Removed.

1999-05-22  Dag Lem  <resid@nimrod.no>

	* c64/psid.c: Removed PSIDTune resource
	* c64/c64.c: Likewise

	* vicii/vicii.c (vicii_load_palette): Don't load palette in PSID mode
	
	* machine.h: External declaration of console_mode flag.

	* main.c: Added console_mode flag and -console option (unfinished)
	(main): Removed PSIDTune resource

1999-05-18  Dag Lem  <resid@nimrod.no>

	* c64/c64.c (machine_init): Initialize monitor in psid mode.

	* sid/sid.c (store_sid): Report usage of PSID registers.

	* sid/resid.cc (resid_sound_machine_open): Warnings changed to
	normal messages.
	* sound.c (closesound, initsid): Likewise.

1999-05-22  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.20.

	* drive/drive.c (set_drive_true_emulation): Always enable IEC bus
	if true drive emulation is enabled.

	* raster/raster.h: Always define `RASTER_PIXEL'.  Also define
	`RASTER_PIXEL2' and `RASTER_PIXEL4' on MSDOS until all video chip
	emulations are fixed.

	* raster/raster.c (handle_blank_line): Use
	`raster->viewport.canvas' instead of `canvas'.

	* vicii/vicii-draw.c (setup_double_size_modes): Do not compile
	this function if double size mode is not required.
	(vic_ii_draw_init): Do not setup double size mode if not
	required.
	(setup_double_size_modes): Changed likewise.

	* vicii/vicii-sprites.c (vic_ii_sprites_set_double_size): Do not
	use double size modes if `VIC_II_NEED_2X' is not defined.

	* vic20/vic-resources.c: #include "resources.h".

	* arch/msdos/archdep.c: #include <sys/stat.h>.
	(archdep_expand_path): Do not use `zlog'.

	* serial.c (serial_init): Call `prdevice_late_init' only if
	printer support is enabled.

	* vdrive.c (floppy_read_block): Removed debugging cruft.

1999-05-21  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.19.

	* vdrive.c (set_disk_geometry): Added missing break.

1999-05-21  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* Makefile.am: remove $(rs232_printer_ldadd) from xpet and xcbm2
	library list - they are already in $(common_libs)

	* cbm2/Makefile.am: add raster and crtc dirs to include list
	* pet/Makefile.am: add raster and crtc dirs to include list

	* cbm2/crtc.c: outcomment all functionality
	* pet/crtc.c: outcomment all functionality

	* cbm2/c610.c (machine_reset): rename reset_crtc() to crtc_reset()
	* pet/pet.c (machine_reset): rename reset_crtc() to crtc_reset()

	* crtc/crtc-cmdline-options.c (crtc_init_cmdline_options): renamed
	from crtc_cmdline_options_init()

	* crtc/crtc-resources.c (crtc_init_resources): renamed from 
	crtc_resources_init()

	* crtc/crtc-snapshot.c (crtc_write_snapshot_module): renamed from
	crtc_snapshot_write_module
	(crtc_read_snapshot_module): likewise

	* crtc/crtc.c: remove some strange "^L" in file
	(crtc_init_resources, crtc_init_cmdline_options): removed
	(void video_setfullscreen, crtc_offscreen, crtc_screen_enable,
	crtc_set_char). new dummy functions

	* crtc/crtc.h: remove some strange "^L" in file
	(crtc_write_snapshot_module, crtc_read_snapshot_module,
	crtc_set_char, crtc_offscreen, crtc_screen_enable): new prototypes
	include crtc-mem.h for the store_crtc and read_crtc prototypes

1999-05-20  Ettore Perazzoli  <ettore@comm2000.it>

	* crtc/crtc.c: Rewritten: provides a working skeleton for a new
	CRTC emulation taking advantage of the new raster module.
	* crtc/crtc.h: Likewise.
	* crtc/crtc-cmdline-options.c: Likewise.
	* crtc/crtc-cmdline-options.h: Likewise.
	* crtc/crtc-draw.c: Likewise.
	* crtc/crtc-draw.h: Likewise.
	* crtc/crtc-mem.c: Likewise.
	* crtc/crtc-mem.h: Likewise.
	* crtc/crtc-resources.c: Likewise.
	* crtc/crtc-resources.h: Likewise.

	* raster/raster.c (raster_reset): Do not initialize colors.
	(raster_init): Initialize them here instead.

1999-05-19  Andreas Boose  <boose@linux.rz.fh-hannover.de>

	* Version 1.0.18.

	* arch/unix/xaw/ui.c (vidmode_available): Fixed typo.

	* (_draw_idle): Use `vic_ii.raster.frame_buffer_ptr' instead of
	`frame_buffer_ptr'.

	* * archapi.h: (archdep_home_path): Move prototype to
	`arch/unix/archdep.h' as this is no *common* system-specific
	function.

	* arch/unix/xaw/widgets/FileSel.c: #include "archdep.h".

1999-05-19  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* arch/unix/archdep.c (archdep_home_path): check return values
	of getpwuid(). Make function non-static.

	* arch/unix/xaw/widgets/FileSel.c: include archapi.h
	(GotoDeepestLegalDirectory, UpdateTextLines): call 
	archdep_home_path() instead of getenv().

	* archapi.h: protect with #ifdef _ARCHAPI_H, include <stdarg.h>
	(archdep_home_path): new prototype

1999-05-19  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* drive/drive.h (A_*): remove bogus alarm definitions
	(I_*): remove bogus interrupt definitions

	* configure.in: add src/crtc/Makefile to list of Makefiles

	* Makefile.am: add crtc to subdirectories, remove crtc.h, crtccore.c
	add crtc_lib and clean up xpet and xcbm2 build rules

	* crtc/Makefile.am: new file

	* crtc/crtc-cmdline-options.c, crtc/crtc-cmdline-options.h,
	crtc/crtc-draw.c, crtc/crtc-draw.h, crtc/crtc-mem.c, crtc/crtc-mem.h,
	crtc/crtc-resources.c, crtc/crtc-resources.h, 
	crtc/crtc-snapshot.c, crtc/crtc-snapshot.h,
	crtc/crtc.c, crtc/crtc.h: new files, crudely broken out of 
	the old crtccore.c

	* crtc.h, crtccore.c: removed

1999-05-18  André Fachat  <a.fachat@physik.tu-chemnitz.de>

	* arch/msdos/archdep.c (archdep_expand_path): new function to 
	return a malloc´d string containing the full absolute path of 
	the given file name (taken from zfile.c)
	* arch/riscos/archdep.c: likewise
	* arch/unix/archdep.c: likewise
	* arch/win32/archdep.c: likewise

	* archapi.h (archdep_expand_path): mew prototype

	* drive/drive.c (drive_sync_found): moved from behind 
	drive_rotate_disk() to before drive_rotate_disk(), allow the 
	compiler to inline it.
	(drive_read_image_snapshot_module): call zfile_close_action() to
	mark the image file read from a snapshot for request/deletion

	* zfile.c (struct zfile): add action-on-close and request string
	(zfile_list_add): call archdep_expand_path() to get full path.
	Allow a tmp_name of NULL (for uncompressed files)
	(zopen, zfopen): keep also track of uncompressed files by also calling
	zfile_list_add() for them.
	(handle_close_action): check the action-on-close the file is set to.
	If ZFILE_REQUEST, it should at some point in time open a requester
	to ask whether to save the file or remove it.
	If ZFILE_DEL, simply remove the original file as well. 
